QRUPDATE: A LIBRARY FOR FAST UPDATING OF QR AND CHOLESKY DECOMPOSITIONS
-----------------------------------------------------------------------

The following operations are supported:

QR rank-1 update (qr1up)
	Updates the QR factorization after an additive rank-1 update to the
	original matrix (A = A + u*v'). Works for full & economized 
	factorization.
QR column insert (qrinc)
	Updates the QR factorization after an inserting a column to the
	original matrix. Works for full & economized factorization.
QR column delete (qrdec)
	Updates the QR factorization after an deleting a column from the
	original matrix. Works for full & economized factorization.
QR column shift (qrshc)
	Updates the QR factorization after a circular shift of columns in 
	the original matrix. Works for full & economized factorization.
QR row insert (qrinr)
	Updates the QR factorization after an inserting a row to the
	original matrix. Works for full factorization only.
QR row delete (qrder)
	Updates the QR factorization after an deleting a row from the
	original matrix. Works for full factorization only.

Cholesky rank-1 update (ch1up)
	Updates the Cholesky factorization after positive rank-1 update
	A = A + u*u'. 
Cholesky rank-1 downdate (ch1dn)
	Updates the Cholesky factorization after positive rank-1 downdate
	A = A - u*u'. 
Cholesky symmetric insert (chinx)
	Updates the Cholesky factorization after a symmetric column/row
	insertion.
Cholesky symmetric insert (chdex)
	Updates the Cholesky factorization after a symmetric column/row
	deletion.
Cholesky symmetric shift (chshx)
	Updates the Cholesky factorization after a symmetric column/row
	left/right circular shift.

LU rank-1 update (lu1up)
	Updates the LU factorization after a rank-1 update (A = A + u*v.'). 
	No pivoting available. Faster than lup1up, but less stable.
LU pivoted rank-1 update (lup1up)
	Updates a row-pivoted LUP factorization after a rank-1 update
	(A = A + u*v.'). Also updates the row permutation matrix. Slower
	than lu1up, but more stable.

See the INSTALL file for installation details. Consult individual routines
for documentation.

This directory contains some CMake add-ons.

The following files belong to https://github.com/RWTH-HPC/CMake-codecov and underly
the licenses given in (./LICENSE-CMake-codecov)[LICENSE-CMake-codecov]

* `Findcodecov.cmake`
* `FindGcov.cmake`
* `FindLcov.cmake`
* `llvm-cov-wrapper`

LAPACK-MISSING 
==============
Copyright 2020 by Martin Koehler 


This library checks at compile-time if all required LAPACK routines are
available and creates a small library containing the missing ones. This is
required by projects that use IBM's ESSL library since this library does not
contain the full set of LAPACK routines. 

The routines are taken from LAPACK without any modification and thus uses the
same license. 


The cmake logic is licensed under the same terms as. 

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine dqr1up(m,n,k,Q,ldq,R,ldr,u,v,w)
c purpose:      updates a QR factorization after rank-1 modification
c               i.e., given a m-by-k orthogonal Q and m-by-n upper
c               trapezoidal R, an m-vector u and n-vector v,
c               this subroutine updates Q -> Q1 and R -> R1 so that
c               Q1*R1 = Q*R + u*v', and Q1 is again orthonormal
c               and R1 upper trapezoidal.
c               (real version)
c arguments:
c m (in)        number of rows of the matrix Q.
c n (in)        number of columns of the matrix R.
c k (in)        number of columns of Q, and rows of R. Must be
c               either k = m (full Q) or k = n < m (economical form).
c Q (io)        on entry, the orthogonal m-by-k matrix Q.
c               on exit, the updated matrix Q1.
c ldq (in)      the leading dimension of Q. ldq >= m.
c R (io)        on entry, the upper trapezoidal m-by-n matrix R..
c               on exit, the updated matrix R1.
c ldr (in)      the leading dimension of R. ldr >= k.
c u (io)        the left m-vector. On exit, if k < m, u is destroyed.
c v (io)        the right n-vector. On exit, v is destroyed.
c w (out)       a workspace vector of size 2*k
c
      integer m,n,k,ldq,ldr
      double precision Q(ldq,*),R(ldr,*),u(*),v(*),w(*)
      external dqrqh,dqhqr,dqrot,dqrtv1
      external daxpy,ddot,dnrm2,dlamch,dscal,drot
      double precision ddot,dnrm2,dlamch,ru,ruu
      integer info,i
      logical full
c quick return if possible.
      if (k == 0 .or. n == 0) return
c check arguments.
      info = 0
      if (m < 0) then
        info = 1
      else if (n < 0) then
        info = 2
      else if (k /= m .and. (k /= n .or. n > m)) then
        info = 3
      else if (ldq < m) then
        info = 5
      else if (ldr < k) then
        info = 7
      endif
      if (info /= 0) then
        call xerbla('DQR1UP',info)
        return
      end if

      full = k == m
c in the non-full case, we shall need the norm of u.
      if (.not.full) ru = dnrm2(m,u,1)
c form Q'*u. In the non-full case, form also u - Q*Q'u.
      do i = 1,k
        w(i) = ddot(m,Q(1,i),1,u,1)
        if (.not.full) call daxpy(m,-w(i),Q(1,i),1,u,1)
      end do
c generate rotations to eliminate Q'*u.
      call dqrtv1(k,w,w(k+1))
c apply rotations to R.
      call dqrqh(k,n,R,ldr,w(k+1),w(2))
c apply rotations to Q.
      call dqrot('B',m,k,Q,ldq,w(k+1),w(2))
c update the first row of R.
      call daxpy(n,w(1),v,1,R(1,1),ldr)
c retriangularize R.
      call dqhqr(k,n,R,ldr,w(k+1),w)
c apply rotations to Q.
      call dqrot('F',m,min(k,n+1),Q,ldq,w(k+1),w)
c in the full case, we're finished
      if (full) return
c compute relative residual norm
      ruu = dnrm2(m,u,1)
      ru = ru * dlamch('e')
      if (ruu <= ru) return
c update the orthogonal basis.
      call dscal(n,ruu,v,1)
      call dscal(m,1d0/ruu,u,1)
      call dch1up(n,R,ldr,v,w(k+1))
      do i = 1,n
        call drot(m,Q(1,i),1,u,1,w(k+i),v(i))
      end do
      end subroutine

! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!

module qrupdate
    use iso_fortran_env
    implicit none

    interface
        subroutine caxcpy(n, a, x, incx, y, incy)
            use iso_fortran_env
            integer, intent(in) :: n
            complex(real32), intent(in) :: a
            complex(real32), intent(in) :: x
            integer, intent(in) :: incx
            complex(real32), intent(inout) :: y
            integer, intent(in) :: incy
        end subroutine caxcpy
    end interface

    interface
        subroutine cch1dn(n, R, ldr, u, rw, info)
            use iso_fortran_env
            integer, intent(in) :: n
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            complex(real32), intent(inout) :: u
            real(real32), intent(out) :: rw
            integer, intent(out) :: info
        end subroutine cch1dn
    end interface

    interface
        subroutine cch1up(n, R, ldr, u, w)
            use iso_fortran_env
            integer, intent(in) :: n
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            complex(real32), intent(inout) :: u
            real(real32), intent(out) :: w
        end subroutine cch1up
    end interface

    interface
        subroutine cchdex(n, R, ldr, j, rw)
            use iso_fortran_env
            integer, intent(in) :: n
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: j
            real(real32), intent(out) :: rw
        end subroutine cchdex
    end interface

    interface
        subroutine cchinx(n, R, ldr, j, u, rw, info)
            use iso_fortran_env
            integer, intent(in) :: n
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: j
            complex(real32), intent(inout) :: u
            real(real32), intent(out) :: rw
            integer, intent(out) :: info
        end subroutine cchinx
    end interface

    interface
        subroutine cchshx(n, R, ldr, i, j, w, rw)
            use iso_fortran_env
            integer, intent(in) :: n
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: i
            integer, intent(in) :: j
            complex(real32), intent(out) :: w
            real(real32), intent(out) :: rw
        end subroutine cchshx
    end interface

    interface
        subroutine cgqvec(m, n, Q, ldq, u)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            complex(real32), intent(in) :: Q
            integer, intent(in) :: ldq
            complex(real32), intent(out) :: u
        end subroutine cgqvec
    end interface

    interface
        subroutine clu1up(m, n, L, ldl, R, ldr, u, v)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            complex(real32), intent(inout) :: L
            integer, intent(in) :: ldl
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            complex(real32), intent(inout) :: u
            complex(real32), intent(inout) :: v
        end subroutine clu1up
    end interface

    interface
        subroutine clup1up(m, n, L, ldl, R, ldr, p, u, v, w)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            complex(real32), intent(inout) :: L
            integer, intent(in) :: ldl
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: p
            complex(real32), intent(in) :: u
            complex(real32), intent(in) :: v
            complex(real32), intent(out) :: w
        end subroutine clup1up
    end interface

    interface
        subroutine cqhqr(m, n, R, ldr, c, s)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            real(real32), intent(out) :: c
            complex(real32), intent(out) :: s
        end subroutine cqhqr
    end interface

    interface
        subroutine cqr1up(m, n, k, Q, ldq, R, ldr, u, v, w, rw)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            integer, intent(in) :: k
            complex(real32), intent(inout) :: Q
            integer, intent(in) :: ldq
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            complex(real32), intent(inout) :: u
            complex(real32), intent(inout) :: v
            complex(real32), intent(out) :: w
            real(real32), intent(out) :: rw
        end subroutine cqr1up
    end interface

    interface
        subroutine cqrdec(m, n, k, Q, ldq, R, ldr, j, rw)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            integer, intent(in) :: k
            complex(real32), intent(inout) :: Q
            integer, intent(in) :: ldq
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: j
            real(real32), intent(out) :: rw
        end subroutine cqrdec
    end interface

    interface
        subroutine cqrder(m, n, Q, ldq, R, ldr, j, w, rw)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            complex(real32), intent(inout) :: Q
            integer, intent(in) :: ldq
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: j
            complex(real32), intent(out) :: w
            real(real32), intent(out) :: rw
        end subroutine cqrder
    end interface

    interface
        subroutine cqrinc(m, n, k, Q, ldq, R, ldr, j, x, rw)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            integer, intent(in) :: k
            complex(real32), intent(inout) :: Q
            integer, intent(in) :: ldq
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: j
            complex(real32), intent(in) :: x
            real(real32), intent(out) :: rw
        end subroutine cqrinc
    end interface

    interface
        subroutine cqrinr(m, n, Q, ldq, R, ldr, j, x, rw)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            complex(real32), intent(inout) :: Q
            integer, intent(in) :: ldq
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: j
            complex(real32), intent(inout) :: x
            real(real32), intent(out) :: rw
        end subroutine cqrinr
    end interface

    interface
        subroutine cqrot(dir, m, n, Q, ldq, c, s)
            use iso_fortran_env
            character, intent(in) :: dir
            integer, intent(in) :: m
            integer, intent(in) :: n
            complex(real32), intent(inout) :: Q
            integer, intent(in) :: ldq
            real(real32), intent(in) :: c
            complex(real32), intent(in) :: s
        end subroutine cqrot
    end interface

    interface
        subroutine cqrqh(m, n, R, ldr, c, s)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            real(real32), intent(in) :: c
            complex(real32), intent(in) :: s
        end subroutine cqrqh
    end interface

    interface
        subroutine cqrshc(m, n, k, Q, ldq, R, ldr, i, j, w, rw)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            integer, intent(in) :: k
            complex(real32), intent(inout) :: Q
            integer, intent(in) :: ldq
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: i
            integer, intent(in) :: j
            complex(real32), intent(out) :: w
            real(real32), intent(out) :: rw
        end subroutine cqrshc
    end interface

    interface
        subroutine cqrtv1(n, u, w)
            use iso_fortran_env
            integer, intent(in) :: n
            complex(real32), intent(inout) :: u
            real(real32), intent(out) :: w
        end subroutine cqrtv1
    end interface

    interface
        subroutine dch1dn(n, R, ldr, u, w, info)
            use iso_fortran_env
            integer, intent(in) :: n
            real(real64), intent(inout) :: R
            integer, intent(in) :: ldr
            real(real64), intent(inout) :: u
            real(real64), intent(out) :: w
            integer, intent(out) :: info
        end subroutine dch1dn
    end interface

    interface
        subroutine dch1up(n, R, ldr, u, w)
            use iso_fortran_env
            integer, intent(in) :: n
            real(real64), intent(inout) :: R
            integer, intent(in) :: ldr
            real(real64), intent(inout) :: u
            real(real64), intent(out) :: w
        end subroutine dch1up
    end interface

    interface
        subroutine dchdex(n, R, ldr, j, w)
            use iso_fortran_env
            integer, intent(in) :: n
            real(real64), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: j
            real(real64), intent(out) :: w
        end subroutine dchdex
    end interface

    interface
        subroutine dchinx(n, R, ldr, j, u, w, info)
            use iso_fortran_env
            integer, intent(in) :: n
            real(real64), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: j
            real(real64), intent(inout) :: u
            real(real64), intent(out) :: w
            integer, intent(out) :: info
        end subroutine dchinx
    end interface

    interface
        subroutine dchshx(n, R, ldr, i, j, w)
            use iso_fortran_env
            integer, intent(in) :: n
            real(real64), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: i
            integer, intent(in) :: j
            real(real64), intent(out) :: w
        end subroutine dchshx
    end interface

    interface
        subroutine dgqvec(m, n, Q, ldq, u)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            real(real64), intent(in) :: Q
            integer, intent(in) :: ldq
            real(real64), intent(out) :: u
        end subroutine dgqvec
    end interface

    interface
        subroutine dlu1up(m, n, L, ldl, R, ldr, u, v)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            real(real64), intent(inout) :: L
            integer, intent(in) :: ldl
            real(real64), intent(inout) :: R
            integer, intent(in) :: ldr
            real(real64), intent(inout) :: u
            real(real64), intent(inout) :: v
        end subroutine dlu1up
    end interface

    interface
        subroutine dlup1up(m, n, L, ldl, R, ldr, p, u, v, w)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            real(real64), intent(inout) :: L
            integer, intent(in) :: ldl
            real(real64), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: p
            real(real64), intent(in) :: u
            real(real64), intent(in) :: v
            real(real64), intent(out) :: w
        end subroutine dlup1up
    end interface

    interface
        subroutine dqhqr(m, n, R, ldr, c, s)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            real(real64), intent(inout) :: R
            integer, intent(in) :: ldr
            real(real64), intent(out) :: c
            real(real64), intent(out) :: s
        end subroutine dqhqr
    end interface

    interface
        subroutine dqr1up(m, n, k, Q, ldq, R, ldr, u, v, w)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            integer, intent(in) :: k
            real(real64), intent(inout) :: Q
            integer, intent(in) :: ldq
            real(real64), intent(inout) :: R
            integer, intent(in) :: ldr
            real(real64), intent(inout) :: u
            real(real64), intent(inout) :: v
            real(real64), intent(out) :: w
        end subroutine dqr1up
    end interface

    interface
        subroutine dqrdec(m, n, k, Q, ldq, R, ldr, j, w)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            integer, intent(in) :: k
            real(real64), intent(inout) :: Q
            integer, intent(in) :: ldq
            real(real64), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: j
            real(real64), intent(out) :: w
        end subroutine dqrdec
    end interface

    interface
        subroutine dqrder(m, n, Q, ldq, R, ldr, j, w)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            real(real64), intent(inout) :: Q
            integer, intent(in) :: ldq
            real(real64), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: j
            real(real64), intent(out) :: w
        end subroutine dqrder
    end interface

    interface
        subroutine dqrinc(m, n, k, Q, ldq, R, ldr, j, x, w)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            integer, intent(in) :: k
            real(real64), intent(inout) :: Q
            integer, intent(in) :: ldq
            real(real64), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: j
            real(real64), intent(in) :: x
            real(real64), intent(out) :: w
        end subroutine dqrinc
    end interface

    interface
        subroutine dqrinr(m, n, Q, ldq, R, ldr, j, x, w)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            real(real64), intent(inout) :: Q
            integer, intent(in) :: ldq
            real(real64), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: j
            real(real64), intent(inout) :: x
            real(real64), intent(out) :: w
        end subroutine dqrinr
    end interface

    interface
        subroutine dqrot(dir, m, n, Q, ldq, c, s)
            use iso_fortran_env
            character, intent(in) :: dir
            integer, intent(in) :: m
            integer, intent(in) :: n
            real(real64), intent(inout) :: Q
            integer, intent(in) :: ldq
            real(real64), intent(in) :: c
            real(real64), intent(in) :: s
        end subroutine dqrot
    end interface

    interface
        subroutine dqrqh(m, n, R, ldr, c, s)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            real(real64), intent(inout) :: R
            integer, intent(in) :: ldr
            real(real64), intent(in) :: c
            real(real64), intent(in) :: s
        end subroutine dqrqh
    end interface

    interface
        subroutine dqrshc(m, n, k, Q, ldq, R, ldr, i, j, w)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            integer, intent(in) :: k
            real(real64), intent(inout) :: Q
            integer, intent(in) :: ldq
            real(real64), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: i
            integer, intent(in) :: j
            real(real64), intent(out) :: w
        end subroutine dqrshc
    end interface

    interface
        subroutine dqrtv1(n, u, w)
            use iso_fortran_env
            integer, intent(in) :: n
            real(real64), intent(inout) :: u
            real(real64), intent(out) :: w
        end subroutine dqrtv1
    end interface

    interface
        subroutine sch1dn(n, R, ldr, u, w, info)
            use iso_fortran_env
            integer, intent(in) :: n
            real(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            real(real32), intent(inout) :: u
            real(real32), intent(out) :: w
            integer, intent(out) :: info
        end subroutine sch1dn
    end interface

    interface
        subroutine sch1up(n, R, ldr, u, w)
            use iso_fortran_env
            integer, intent(in) :: n
            real(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            real(real32), intent(inout) :: u
            real(real32), intent(out) :: w
        end subroutine sch1up
    end interface

    interface
        subroutine schdex(n, R, ldr, j, w)
            use iso_fortran_env
            integer, intent(in) :: n
            real(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: j
            real(real32), intent(out) :: w
        end subroutine schdex
    end interface

    interface
        subroutine schinx(n, R, ldr, j, u, w, info)
            use iso_fortran_env
            integer, intent(in) :: n
            real(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: j
            real(real32), intent(inout) :: u
            real(real32), intent(out) :: w
            integer, intent(out) :: info
        end subroutine schinx
    end interface

    interface
        subroutine schshx(n, R, ldr, i, j, w)
            use iso_fortran_env
            integer, intent(in) :: n
            real(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: i
            integer, intent(in) :: j
            real(real32), intent(out) :: w
        end subroutine schshx
    end interface

    interface
        subroutine sgqvec(m, n, Q, ldq, u)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            real(real32), intent(in) :: Q
            integer, intent(in) :: ldq
            real(real32), intent(out) :: u
        end subroutine sgqvec
    end interface

    interface
        subroutine slu1up(m, n, L, ldl, R, ldr, u, v)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            real(real32), intent(inout) :: L
            integer, intent(in) :: ldl
            real(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            real(real32), intent(inout) :: u
            real(real32), intent(inout) :: v
        end subroutine slu1up
    end interface

    interface
        subroutine slup1up(m, n, L, ldl, R, ldr, p, u, v, w)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            real(real32), intent(inout) :: L
            integer, intent(in) :: ldl
            real(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: p
            real(real32), intent(in) :: u
            real(real32), intent(in) :: v
            real(real32), intent(out) :: w
        end subroutine slup1up
    end interface

    interface
        subroutine sqhqr(m, n, R, ldr, c, s)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            real(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            real(real32), intent(out) :: c
            real(real32), intent(out) :: s
        end subroutine sqhqr
    end interface

    interface
        subroutine sqr1up(m, n, k, Q, ldq, R, ldr, u, v, w)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            integer, intent(in) :: k
            real(real32), intent(inout) :: Q
            integer, intent(in) :: ldq
            real(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            real(real32), intent(inout) :: u
            real(real32), intent(inout) :: v
            real(real32), intent(out) :: w
        end subroutine sqr1up
    end interface

    interface
        subroutine sqrdec(m, n, k, Q, ldq, R, ldr, j, w)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            integer, intent(in) :: k
            real(real32), intent(inout) :: Q
            integer, intent(in) :: ldq
            real(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: j
            real(real32), intent(out) :: w
        end subroutine sqrdec
    end interface

    interface
        subroutine sqrder(m, n, Q, ldq, R, ldr, j, w)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            real(real32), intent(inout) :: Q
            integer, intent(in) :: ldq
            real(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: j
            real(real32), intent(out) :: w
        end subroutine sqrder
    end interface

    interface
        subroutine sqrinc(m, n, k, Q, ldq, R, ldr, j, x, w)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            integer, intent(in) :: k
            real(real32), intent(inout) :: Q
            integer, intent(in) :: ldq
            real(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: j
            real(real32), intent(in) :: x
            real(real32), intent(out) :: w
        end subroutine sqrinc
    end interface

    interface
        subroutine sqrinr(m, n, Q, ldq, R, ldr, j, x, w)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            real(real32), intent(inout) :: Q
            integer, intent(in) :: ldq
            real(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: j
            real(real32), intent(inout) :: x
            real(real32), intent(out) :: w
        end subroutine sqrinr
    end interface

    interface
        subroutine sqrot(dir, m, n, Q, ldq, c, s)
            use iso_fortran_env
            character, intent(in) :: dir
            integer, intent(in) :: m
            integer, intent(in) :: n
            real(real32), intent(inout) :: Q
            integer, intent(in) :: ldq
            real(real32), intent(in) :: c
            real(real32), intent(in) :: s
        end subroutine sqrot
    end interface

    interface
        subroutine sqrqh(m, n, R, ldr, c, s)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            real(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            real(real32), intent(in) :: c
            real(real32), intent(in) :: s
        end subroutine sqrqh
    end interface

    interface
        subroutine sqrshc(m, n, k, Q, ldq, R, ldr, i, j, w)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            integer, intent(in) :: k
            real(real32), intent(inout) :: Q
            integer, intent(in) :: ldq
            real(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: i
            integer, intent(in) :: j
            real(real32), intent(out) :: w
        end subroutine sqrshc
    end interface

    interface
        subroutine sqrtv1(n, u, w)
            use iso_fortran_env
            integer, intent(in) :: n
            real(real32), intent(inout) :: u
            real(real32), intent(out) :: w
        end subroutine sqrtv1
    end interface

    interface
        subroutine zaxcpy(n, a, x, incx, y, incy)
            use iso_fortran_env
            integer, intent(in) :: n
            complex(real32), intent(in) :: a
            complex(real32), intent(in) :: x
            integer, intent(in) :: incx
            complex(real32), intent(inout) :: y
            integer, intent(in) :: incy
        end subroutine zaxcpy
    end interface

    interface
        subroutine zch1dn(n, R, ldr, u, rw, info)
            use iso_fortran_env
            integer, intent(in) :: n
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            complex(real32), intent(inout) :: u
            real(real64), intent(out) :: rw
            integer, intent(out) :: info
        end subroutine zch1dn
    end interface

    interface
        subroutine zch1up(n, R, ldr, u, w)
            use iso_fortran_env
            integer, intent(in) :: n
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            complex(real32), intent(inout) :: u
            real(real64), intent(out) :: w
        end subroutine zch1up
    end interface

    interface
        subroutine zchdex(n, R, ldr, j, rw)
            use iso_fortran_env
            integer, intent(in) :: n
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: j
            real(real64), intent(out) :: rw
        end subroutine zchdex
    end interface

    interface
        subroutine zchinx(n, R, ldr, j, u, rw, info)
            use iso_fortran_env
            integer, intent(in) :: n
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: j
            complex(real32), intent(inout) :: u
            real(real64), intent(out) :: rw
            integer, intent(out) :: info
        end subroutine zchinx
    end interface

    interface
        subroutine zchshx(n, R, ldr, i, j, w, rw)
            use iso_fortran_env
            integer, intent(in) :: n
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: i
            integer, intent(in) :: j
            complex(real32), intent(out) :: w
            real(real64), intent(out) :: rw
        end subroutine zchshx
    end interface

    interface
        subroutine zgqvec(m, n, Q, ldq, u)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            complex(real32), intent(in) :: Q
            integer, intent(in) :: ldq
            complex(real32), intent(out) :: u
        end subroutine zgqvec
    end interface

    interface
        subroutine zlu1up(m, n, L, ldl, R, ldr, u, v)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            complex(real32), intent(inout) :: L
            integer, intent(in) :: ldl
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            complex(real32), intent(inout) :: u
            complex(real32), intent(inout) :: v
        end subroutine zlu1up
    end interface

    interface
        subroutine zlup1up(m, n, L, ldl, R, ldr, p, u, v, w)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            complex(real32), intent(inout) :: L
            integer, intent(in) :: ldl
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: p
            complex(real32), intent(in) :: u
            complex(real32), intent(in) :: v
            complex(real32), intent(out) :: w
        end subroutine zlup1up
    end interface

    interface
        subroutine zqhqr(m, n, R, ldr, c, s)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            real(real64), intent(out) :: c
            complex(real32), intent(out) :: s
        end subroutine zqhqr
    end interface

    interface
        subroutine zqr1up(m, n, k, Q, ldq, R, ldr, u, v, w, rw)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            integer, intent(in) :: k
            complex(real32), intent(inout) :: Q
            integer, intent(in) :: ldq
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            complex(real32), intent(inout) :: u
            complex(real32), intent(inout) :: v
            complex(real32), intent(out) :: w
            real(real64), intent(out) :: rw
        end subroutine zqr1up
    end interface

    interface
        subroutine zqrdec(m, n, k, Q, ldq, R, ldr, j, rw)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            integer, intent(in) :: k
            complex(real32), intent(inout) :: Q
            integer, intent(in) :: ldq
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: j
            real(real64), intent(out) :: rw
        end subroutine zqrdec
    end interface

    interface
        subroutine zqrder(m, n, Q, ldq, R, ldr, j, w, rw)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            complex(real32), intent(inout) :: Q
            integer, intent(in) :: ldq
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: j
            complex(real32), intent(out) :: w
            real(real64), intent(out) :: rw
        end subroutine zqrder
    end interface

    interface
        subroutine zqrinc(m, n, k, Q, ldq, R, ldr, j, x, rw)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            integer, intent(in) :: k
            complex(real32), intent(inout) :: Q
            integer, intent(in) :: ldq
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: j
            complex(real32), intent(in) :: x
            real(real64), intent(out) :: rw
        end subroutine zqrinc
    end interface

    interface
        subroutine zqrinr(m, n, Q, ldq, R, ldr, j, x, rw)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            complex(real32), intent(inout) :: Q
            integer, intent(in) :: ldq
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: j
            complex(real32), intent(inout) :: x
            real(real64), intent(out) :: rw
        end subroutine zqrinr
    end interface

    interface
        subroutine zqrot(dir, m, n, Q, ldq, c, s)
            use iso_fortran_env
            character, intent(in) :: dir
            integer, intent(in) :: m
            integer, intent(in) :: n
            complex(real32), intent(inout) :: Q
            integer, intent(in) :: ldq
            real(real64), intent(in) :: c
            complex(real32), intent(in) :: s
        end subroutine zqrot
    end interface

    interface
        subroutine zqrqh(m, n, R, ldr, c, s)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            real(real64), intent(in) :: c
            complex(real32), intent(in) :: s
        end subroutine zqrqh
    end interface

    interface
        subroutine zqrshc(m, n, k, Q, ldq, R, ldr, i, j, w, rw)
            use iso_fortran_env
            integer, intent(in) :: m
            integer, intent(in) :: n
            integer, intent(in) :: k
            complex(real32), intent(inout) :: Q
            integer, intent(in) :: ldq
            complex(real32), intent(inout) :: R
            integer, intent(in) :: ldr
            integer, intent(in) :: i
            integer, intent(in) :: j
            complex(real32), intent(out) :: w
            real(real64), intent(out) :: rw
        end subroutine zqrshc
    end interface

    interface
        subroutine zqrtv1(n, u, w)
            use iso_fortran_env
            integer, intent(in) :: n
            complex(real32), intent(inout) :: u
            real(real64), intent(out) :: w
        end subroutine zqrtv1
    end interface

end module qrupdate

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine srandg(m,n,x,ldx)
      integer m,n,ldx
      real x(ldx,*)
      external slaruv
      integer seed(4),j,k
      common /xrand/ seed
      do j = 1,n
        do k = 1,m,128
          call slaruv(seed,min(m-k+1,128),x(k,j))
        end do
      end do
      do j = 1,n
        do k = 1,m
          if (.not. (x(k,j) > 0e0 .and. x(k,j) < 1e0)) then
            stop 'slaruv produced invalid number'
          end if
        end do
      end do
      end subroutine

      subroutine drandg(m,n,x,ldx)
      integer m,n,ldx
      double precision x(ldx,*)
      external dlaruv
      integer seed(4),j,k
      common /xrand/ seed
      do j = 1,n
        do k = 1,m,128
          call dlaruv(seed,min(m-k+1,128),x(k,j))
        end do
      end do
      do j = 1,n
        do k = 1,m
          if (.not. (x(k,j) > 0d0 .and. x(k,j) < 1d0)) then
            stop 'dlaruv produced invalid number'
          end if
        end do
      end do
      end subroutine

      subroutine crandg(m,n,x,ldx)
      integer m,n,ldx
      complex x(ldx,*)
      external srandg
      call srandg(2*m,n,x,2*ldx)
      end subroutine

      subroutine zrandg(m,n,x,ldx)
      integer m,n,ldx
      double complex x(ldx,*)
      external srandg
      call drandg(2*m,n,x,2*ldx)
      end subroutine

      block data xrandi
      integer seed(4)
      common /xrand/ seed
      data seed /4*1/
      end block data

      subroutine sqrgen(m,n,A,lda,Q,ldq,R,ldr)
      integer m,n,lda,ldq,ldr
      real A(lda,n),Q(ldq,m),R(ldr,n)
      real work(max(m,n)),tau(min(m,n))
      integer info,i,j
      external slacpy,sgeqrf,sorgqr
      if (m == 0) return
      call slacpy('0',m,n,A,lda,R,ldr)
      call sgeqrf(m,n,R,ldr,tau,work,max(m,n),info)
      do i = 1,n
        do j = i+1,m
          Q(j,i) = R(j,i)
          R(j,i) = 0e0
        end do
      end do
      call sorgqr(m,m,min(m,n),Q,ldq,tau,work,max(m,n),info)
      end subroutine

      subroutine dqrgen(m,n,A,lda,Q,ldq,R,ldr)
      integer m,n,lda,ldq,ldr
      double precision A(lda,n),Q(ldq,m),R(ldr,n)
      double precision work(max(m,n)),tau(min(m,n))
      integer info,i,j
      external dlacpy,dgeqrf,dorgqr
      if (m == 0) return
      call dlacpy('0',m,n,A,lda,R,ldr)
      call dgeqrf(m,n,R,ldr,tau,work,max(m,n),info)
      do i = 1,n
        do j = i+1,m
          Q(j,i) = R(j,i)
          R(j,i) = 0d0
        end do
      end do
      call dorgqr(m,m,min(m,n),Q,ldq,tau,work,max(m,n),info)
      end subroutine

      subroutine cqrgen(m,n,A,lda,Q,ldq,R,ldr)
      integer m,n,lda,ldq,ldr
      complex A(lda,n),Q(ldq,m),R(ldr,n)
      complex work(max(m,n)),tau(min(m,n))
      integer info,i,j
      external clacpy,cgeqrf,cungqr
      if (m == 0) return
      call clacpy('0',m,n,A,lda,R,ldr)
      call cgeqrf(m,n,R,ldr,tau,work,max(m,n),info)
      do i = 1,n
        do j = i+1,m
          Q(j,i) = R(j,i)
          R(j,i) = 0e0
        end do
      end do
      call cungqr(m,m,min(m,n),Q,ldq,tau,work,max(m,n),info)
      end subroutine

      subroutine zqrgen(m,n,A,lda,Q,ldq,R,ldr)
      integer m,n,lda,ldq,ldr
      double complex A(lda,n),Q(ldq,m),R(ldr,n)
      double complex work(max(m,n)),tau(min(m,n))
      integer info,i,j
      external zlacpy,zgeqrf,zungqr
      if (m == 0) return
      call zlacpy('0',m,n,A,lda,R,ldr)
      call zgeqrf(m,n,R,ldr,tau,work,max(m,n),info)
      do i = 1,n
        do j = i+1,m
          Q(j,i) = R(j,i)
          R(j,i) = 0d0
        end do
      end do
      call zungqr(m,m,min(m,n),Q,ldq,tau,work,max(m,n),info)
      end subroutine

      subroutine smdump(name,m,n,A,lda)
      character(*) name
      integer m,n,lda
      real A(lda,n)
      integer i,j
      write (*,1001) name
      do i = 1,m
        do j = 1,n
          write(*,1002) A(i,j)
        end do
        write(*,*)
      end do

 1001 format (A,' = ')
 1002 format (1x,F6.3,$)
      end subroutine

      subroutine dmdump(name,m,n,A,lda)
      character(*) name
      integer m,n,lda
      double precision A(lda,n)
      integer i,j
      write (*,1001) name
      do i = 1,m
        do j = 1,n
          write(*,1002) A(i,j)
        end do
        write(*,*)
      end do

 1001 format (A,' = ')
 1002 format (1x,F6.3,$)
      end subroutine

      subroutine cmdump(name,m,n,A,lda)
      character(*) name
      integer m,n,lda
      complex A(lda,n)
      integer i,j
      write (*,1001) name
      do i = 1,m
        do j = 1,n
          write(*,1002) A(i,j)
        end do
        write(*,*)
      end do

 1001 format (A,' = ')
 1002 format (1x,F6.3,SP,F6.3,'i',$)
      end subroutine

      subroutine zmdump(name,m,n,A,lda)
      character(*) name
      integer m,n,lda
      double complex A(lda,n)
      integer i,j
      write (*,1001) name
      do i = 1,m
        do j = 1,n
          write(*,1002) A(i,j)
        end do
        write(*,*)
      end do

 1001 format (A,' = ')
 1002 format (1x,F6.3,SP,F6.3,'i',$)
      end subroutine

      character*4 function spftol(rnrm)
      real rnrm,slamch
      external slamch
      common /stats/ passed,failed
      integer passed,failed
      if (rnrm < 2e2*slamch('p')) then
        spftol = 'PASS'
        passed = passed + 1
      else
        spftol = 'FAIL'
        failed = failed + 1
      end if
      end function

      character*4 function dpftol(rnrm)
      double precision rnrm,dlamch
      external dlamch
      common /stats/ passed,failed
      integer passed,failed
      if (rnrm < 2d2*dlamch('p')) then
        dpftol = 'PASS'
        passed = passed + 1
      else
        dpftol = 'FAIL'
        failed = failed + 1
      end if
      end function

      subroutine pstats
      common /stats/ passed,failed
      integer passed,failed

      write(*,1001) 
      write(*,1002) passed,failed
      write(*,*)
 1001 format(70('-'))
 1002 format(1x,'total:',5x,'PASSED',1x,I3,5x,'FAILED',1x,I3)
      end subroutine

      subroutine sqrchk(m,n,k,A,lda,Q,ldq,R,ldr)
      integer m,n,k,lda,ldq,ldr
      real A(lda,max(n,k)),Q(ldq,k),R(ldr,n)
      real rnrm,slange,slansy
      external sgemm,ssyrk,slange,slansy,spftol
      character*4 spftol
      real wrk(m)
      integer i

c get residual
      call sgemm('N','N',m,n,k,-1e0,Q,ldq,R,ldr,1e0,A,lda)
c get frobenius norm
      rnrm = slange('M',m,n,A,lda,wrk)
      write(*,1001) rnrm,spftol(rnrm)
c form Q'*Q - I
      call ssyrk('U','T',k,m,1e0,Q,ldq,0e0,A,lda)
      do i = 1,k
        A(i,i) = A(i,i) - 1e0
      end do
c get frobenius norm
      rnrm = slansy('M','U',k,A,lda,wrk)
      write(*,1002) rnrm,spftol(rnrm)
      return

 1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
 1002 format('orth. residual error = ',10x,E21.12,5x,A6)
      end subroutine

      subroutine dqrchk(m,n,k,A,lda,Q,ldq,R,ldr)
      integer m,n,k,lda,ldq,ldr
      double precision A(lda,max(n,k)),Q(ldq,k),R(ldr,n)
      double precision rnrm,dlange,dlansy
      external dgemm,dsyrk,dlange,dlansy,dpftol
      character*4 dpftol
      double precision wrk(m)
      integer i

c get residual
      call dgemm('N','N',m,n,k,-1d0,Q,ldq,R,ldr,1d0,A,lda)
c get frobenius norm
      rnrm = dlange('M',m,n,A,lda,wrk)
      write(*,1001) rnrm,dpftol(rnrm)
c form Q'*Q - I
      call dsyrk('U','T',k,m,1d0,Q,ldq,0d0,A,lda)
      do i = 1,k
        A(i,i) = A(i,i) - 1d0
      end do
c get frobenius norm
      rnrm = dlansy('M','U',k,A,lda,wrk)
      write(*,1002) rnrm,dpftol(rnrm)
      return

 1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
 1002 format('orth. residual error = ',10x,E21.12,5x,A6)
      end subroutine

      subroutine cqrchk(m,n,k,A,lda,Q,ldq,R,ldr)
      integer m,n,k,lda,ldq,ldr
      complex A(lda,max(n,k)),Q(ldq,k),R(ldr,n)
      real rnrm,clange,clanhe
      external cgemm,cherk,clange,clanhe,spftol
      character*4 spftol
      real wrk(m)
      integer i

c get residual
      call cgemm('N','N',m,n,k,-(1e0,0e0),Q,ldq,R,ldr,(1e0,0e0),A,lda)
c get frobenius norm
      rnrm = clange('M',m,n,A,lda,wrk)
      write(*,1001) rnrm,spftol(rnrm)
c form Q'*Q - I
      call cherk('U','C',k,m,1e0,Q,ldq,0e0,A,lda)
      do i = 1,k
        A(i,i) = A(i,i) - 1e0
      end do
c get frobenius norm
      rnrm = clanhe('M','U',k,A,lda,wrk)
      write(*,1002) rnrm,spftol(rnrm)
      return

 1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
 1002 format('orth. residual error = ',10x,E21.12,5x,A6)
      end subroutine

      subroutine zqrchk(m,n,k,A,lda,Q,ldq,R,ldr)
      integer m,n,k,lda,ldq,ldr
      double complex A(lda,max(n,k)),Q(ldq,k),R(ldr,n)
      double precision rnrm,zlange,zlanhe
      external zgemm,zherk,zlange,zlanhe,dpftol
      character*4 dpftol
      double precision wrk(m)
      integer i

c get residual
      call zgemm('N','N',m,n,k,-(1d0,0d0),Q,ldq,R,ldr,(1d0,0d0),A,lda)
c get frobenius norm
      rnrm = zlange('M',m,n,A,lda,wrk)
      write(*,1001) rnrm,dpftol(rnrm)
c form Q'*Q - I
      call zherk('U','C',k,m,1d0,Q,ldq,0d0,A,lda)
      do i = 1,k
        A(i,i) = A(i,i) - 1d0
      end do
c get frobenius norm
      rnrm = zlanhe('M','U',k,A,lda,wrk)
      write(*,1002) rnrm,dpftol(rnrm)
      return

 1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
 1002 format('orth. residual error = ',10x,E21.12,5x,A6)
      end subroutine

      subroutine schgen(n,A,lda,R,ldr)
      integer n,lda,ldr
      real A(lda,n),R(ldr,n)
      external ssyrk,slacpy,spotrf
      integer i,j,info
      call ssyrk('U','T',n,n,1e0,A,lda,0e0,R,ldr)
c augment to ensure strict positivity, zero below diag
      do i = 1,n
        R(i,i) = R(i,i) + 1e-3
c zero below diagonal
        do j = i+1,n
          R(j,i) = 0e0
        end do
      end do
      call slacpy('U',n,n,R,ldr,A,lda)
c symmetrize A
      do i = 1,n-1
        do j = i+1,n
          A(j,i) = A(i,j)
        end do
      end do
      call spotrf('U',n,R,ldr,info)
      if (info /= 0) stop 'fatal:error generating positive matrix'
      end subroutine

      subroutine dchgen(n,A,lda,R,ldr)
      integer n,lda,ldr
      double precision A(lda,n),R(ldr,n)
      external dsyrk,dlacpy,dpotrf
      integer i,j,info
      call dsyrk('U','T',n,n,1d0,A,lda,0d0,R,ldr)
c augment to ensure strict positivity
      do i = 1,n
        R(i,i) = R(i,i) + 1d-3
c zero below diagonal
        do j = i+1,n
          R(j,i) = 0d0
        end do
      end do
      call dlacpy('U',n,n,R,ldr,A,lda)
c symmetrize A
      do i = 1,n-1
        do j = i+1,n
          A(j,i) = A(i,j)
        end do
      end do
      call dpotrf('U',n,R,ldr,info)
      if (info /= 0) stop 'fatal:error generating positive matrix'
      end subroutine

      subroutine cchgen(n,A,lda,R,ldr)
      integer n,lda,ldr
      complex A(lda,n),R(ldr,n)
      external cherk,clacpy,cpotrf,cdotc
      complex cdotc,Rii
      integer i,j,info
      call cherk('U','C',n,n,1e0,A,lda,0e0,R,ldr)
c augment to ensure strict positivity
      do i = 1,n
c CHERK is often buggy. We'll recompute the diagonal elements and
c possibly warn about the bug.
        Rii = cdotc (n, A(1,i), 1, A(1,i), 1)
        if (.not. abs (Rii - R(i,i)) < 1e-5 * abs(Rii)) then
          write (*,1001)
          write (*,1002) R(i,i), Rii
        endif
        R(i,i) = Rii + 1e-3
c zero below diagonal
        do j = i+1,n
          R(j,i) = 0e0
        end do
      end do
      call clacpy('U',n,n,R,ldr,A,lda)
c symmetrize A
      do i = 1,n-1
        do j = i+1,n
          A(j,i) = conjg(A(i,j))
        end do
      end do
      call cpotrf('U',n,R,ldr,info)
      if (info /= 0) stop 'fatal:error generating positive matrix'
 1001 format ('WARNING: Possible bug in BLAS CHERK:')
 1002 format ('WARNING: CHERK computed diagonal element (',
     +F6.3,F6.3,'), direct computation gives (',F6.3,F6.3,').')
      end subroutine

      subroutine zchgen(n,A,lda,R,ldr)
      integer n,lda,ldr
      double complex A(lda,n),R(ldr,n)
      external zherk,zlacpy,zpotrf,zdotc
      double complex zdotc,Rii
      integer i,j,info
      call zherk('U','C',n,n,1d0,A,lda,0d0,R,ldr)
c augment to ensure strict positivity
      do i = 1,n
c ZHERK is often buggy. We'll recompute the diagonal elements and
c possibly warn about the bug.
        Rii = zdotc (n, A(1,i), 1, A(1,i), 1)
        if (.not. abs (Rii - R(i,i)) < 1d-10 * abs(Rii)) then
          write (*,1001)
          write (*,1002) R(i,i), Rii 
        endif
        R(i,i) = Rii + 1d-3
c zero below diagonal
        do j = i+1,n
          R(j,i) = 0d0
        end do
      end do
      call zlacpy('U',n,n,R,ldr,A,lda)
c symmetrize A
      do i = 1,n-1
        do j = i+1,n
          A(j,i) = conjg(A(i,j))
        end do
      end do
      call zpotrf('U',n,R,ldr,info)
      if (info /= 0) stop 'fatal:error generating positive matrix'
 1001 format ('WARNING: Possible bug in BLAS CHERK:')
 1002 format ('WARNING: ZHERK computed diagonal element (',
     +F6.3,F6.3,'), direct computation gives (',F6.3,F6.3,').')
      end subroutine

      subroutine schchk(n,A,lda,R,ldr)
      integer n,lda,ldr
      real A(lda,n),R(ldr,n)
      real rnrm,slansy
      external ssyrk,slansy,spftol
      character*4 spftol
      real wrk(n)
      integer i,j

c zero lower triangle of R
      do j = 1,n-1
        do i = j+1,n
          R(i,j) = 0e0
        end do
      end do
c form A - R'*R
      call ssyrk('U','T',n,n,1e0,R,ldr,-1e0,A,lda)
c get frobenius norm
      rnrm = slansy('M','U',n,A,lda,wrk)
      write(*,1001) rnrm,spftol(rnrm)
      return

 1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
      end subroutine

      subroutine dchchk(n,A,lda,R,ldr)
      integer n,lda,ldr
      double precision A(lda,n),R(ldr,n)
      double precision rnrm,dlansy
      external dsyrk,dlansy,dpftol
      character*4 dpftol
      double precision wrk(n)
      integer i,j

c zero lower triangle of R
      do j = 1,n-1
        do i = j+1,n
          R(i,j) = 0d0
        end do
      end do
c form A - R'*R
      call dsyrk('U','T',n,n,1d0,R,ldr,-1d0,A,lda)
c get frobenius norm
      rnrm = dlansy('M','U',n,A,lda,wrk)
      write(*,1001) rnrm,dpftol(rnrm)
      return

 1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
      end subroutine

      subroutine cchchk(n,A,lda,R,ldr)
      integer n,lda,ldr
      complex A(lda,n),R(ldr,n)
      real rnrm,clanhe
      external cherk,clanhe,spftol
      character*4 spftol
      real wrk(n)
      integer i,j

c zero lower triangle of R
      do j = 1,n-1
        do i = j+1,n
          R(i,j) = 0e0
        end do
      end do
c form A - R'*R
      call cherk('U','C',n,n,1e0,R,ldr,-1e0,A,lda)
c get frobenius norm
      rnrm = clanhe('M','U',n,A,lda,wrk)
      write(*,1001) rnrm,spftol(rnrm)
      return

 1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
      end subroutine

      subroutine zchchk(n,A,lda,R,ldr)
      integer n,lda,ldr
      double complex A(lda,n),R(ldr,n)
      double precision rnrm,zlanhe
      external zherk,zlanhe,dpftol
      character*4 dpftol
      double precision wrk(n)
      integer i,j

c zero lower triangle of R
      do j = 1,n-1
        do i = j+1,n
          R(i,j) = 0d0
        end do
      end do
c form A - R'*R
      call zherk('U','C',n,n,1d0,R,ldr,-1d0,A,lda)
c get frobenius norm
      rnrm = zlanhe('M','U',n,A,lda,wrk)
      write(*,1001) rnrm,dpftol(rnrm)
      return

 1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
      end subroutine

      subroutine slugen(m,n,A,lda,L,ldl,R,ldr)
      integer m,n,lda,ldl,ldr
      real A(lda,n),L(ldl,min(m,n)),R(ldr,n)
      integer ipiv(min(m,n)),info,i,j
      external sswap,slacpy,sgetrf
      if (m >= n) then
        call slacpy('0',m,n,A,lda,L,ldl)
        call sgetrf(m,n,L,ldl,ipiv,info)
        call slacpy('U',m,n,L,ldl,R,ldr)
      else
        call slacpy('0',m,n,A,lda,R,ldr)
        call sgetrf(m,n,R,ldr,ipiv,info)
        call slacpy('L',m,n,R,ldr,L,ldl)
      end if
      do i = 1,min(m,n)
        do j = 1,i-1
          L(j,i) = 0e0
        end do
        L(i,i) = 1e0
      end do
c permute the orig matrix      
      do i = 1,min(m,n)
        j = ipiv(i)
        if (i /= j) then
          call sswap(n,A(i,1),lda,A(j,1),lda)
        end if
      end do
      end subroutine

      subroutine dlugen(m,n,A,lda,L,ldl,R,ldr)
      integer m,n,lda,ldl,ldr
      double precision A(lda,n),L(ldl,min(m,n)),R(ldr,n)
      integer ipiv(min(m,n)),info,i,j
      external dswap,dlacpy,dgetrf
      if (m >= n) then
        call dlacpy('0',m,n,A,lda,L,ldl)
        call dgetrf(m,n,L,ldl,ipiv,info)
        call dlacpy('U',m,n,L,ldl,R,ldr)
      else
        call dlacpy('0',m,n,A,lda,R,ldr)
        call dgetrf(m,n,R,ldr,ipiv,info)
        call dlacpy('L',m,n,R,ldr,L,ldl)
      end if
      do i = 1,min(m,n)
        do j = 1,i-1
          L(j,i) = 0d0
        end do
        L(i,i) = 1d0
      end do
c permute the orig matrix      
      do i = 1,min(m,n)
        j = ipiv(i)
        if (i /= j) then
          call dswap(n,A(i,1),lda,A(j,1),lda)
        end if
      end do
      end subroutine

      subroutine clugen(m,n,A,lda,L,ldl,R,ldr)
      integer m,n,lda,ldl,ldr
      complex A(lda,n),L(ldl,min(m,n)),R(ldr,n)
      integer ipiv(min(m,n)),info,i,j
      external cswap,clacpy,cgetrf
      if (m >= n) then
        call clacpy('0',m,n,A,lda,L,ldl)
        call cgetrf(m,n,L,ldl,ipiv,info)
        call clacpy('U',m,n,L,ldl,R,ldr)
      else
        call clacpy('0',m,n,A,lda,R,ldr)
        call cgetrf(m,n,R,ldr,ipiv,info)
        call clacpy('L',m,n,R,ldr,L,ldl)
      end if
      do i = 1,min(m,n)
        do j = 1,i-1
          L(j,i) = 0d0
        end do
        L(i,i) = 1e0
      end do
c permute the orig matrix      
      do i = 1,min(m,n)
        j = ipiv(i)
        if (i /= j) then
          call cswap(n,A(i,1),lda,A(j,1),lda)
        end if
      end do
      end subroutine

      subroutine zlugen(m,n,A,lda,L,ldl,R,ldr)
      integer m,n,lda,ldl,ldr
      double complex A(lda,n),L(ldl,min(m,n)),R(ldr,n)
      integer ipiv(min(m,n)),info,i,j
      external zswap,zlacpy,zgetrf
      if (m >= n) then
        call zlacpy('0',m,n,A,lda,L,ldl)
        call zgetrf(m,n,L,ldl,ipiv,info)
        call zlacpy('U',m,n,L,ldl,R,ldr)
      else
        call zlacpy('0',m,n,A,lda,R,ldr)
        call zgetrf(m,n,R,ldr,ipiv,info)
        call zlacpy('L',m,n,R,ldr,L,ldl)
      end if
      do i = 1,min(m,n)
        do j = 1,i-1
          L(j,i) = 0d0
        end do
        L(i,i) = 1d0
      end do
c permute the orig matrix      
      do i = 1,min(m,n)
        j = ipiv(i)
        if (i /= j) then
          call zswap(n,A(i,1),lda,A(j,1),lda)
        end if
      end do
      end subroutine

      subroutine sluchk(m,n,A,lda,L,ldl,R,ldr)
      integer m,n,lda,ldl,ldr
      real A(lda,n),L(ldl,min(m,n)),R(ldr,n)
      real rnrm,slange
      external sgemm,slange,spftol
      character*4 spftol
      real wrk(1)
      integer i,j

c zero lower triangle of R
      do j = 1,n-1
        do i = j+1,min(m,n)
          R(i,j) = 0e0
        end do
      end do
c form A - L*R
      call sgemm('N','N',m,n,min(m,n),1e0,L,ldl,R,ldr,-1e0,A,lda)
c get frobenius norm
      rnrm = slange('M',m,n,A,lda,wrk)
      write(*,1001) rnrm,spftol(rnrm)
      return

 1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
      end subroutine

      subroutine dluchk(m,n,A,lda,L,ldl,R,ldr)
      integer m,n,lda,ldl,ldr
      double precision A(lda,n),L(ldl,min(m,n)),R(ldr,n)
      double precision rnrm,dlange
      external dgemm,dlange,dpftol
      character*4 dpftol
      double precision wrk(1)
      integer i,j

c zero lower triangle of R
      do j = 1,n-1
        do i = j+1,min(m,n)
          R(i,j) = 0e0
        end do
      end do
c form A - L*R
      call dgemm('N','N',m,n,min(m,n),1d0,L,ldl,R,ldr,-1d0,A,lda)
c get frobenius norm
      rnrm = dlange('M',m,n,A,lda,wrk)
      write(*,1001) rnrm,dpftol(rnrm)
      return

 1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
      end subroutine

      subroutine cluchk(m,n,A,lda,L,ldl,R,ldr)
      integer m,n,lda,ldl,ldr
      complex A(lda,n),L(ldl,min(m,n)),R(ldr,n)
      real rnrm,clange
      external cgemm,clange,spftol
      character*4 spftol
      real wrk(1)
      integer i,j

c zero lower triangle of R
      do j = 1,n-1
        do i = j+1,min(m,n)
          R(i,j) = 0e0
        end do
      end do
c form A - L*R
      call cgemm('N','N',m,n,min(m,n),(1e0,0e0),L,ldl,R,ldr,(-1e0,0e0),
     +A,lda)
c get frobenius norm
      rnrm = clange('M',m,n,A,lda,wrk)
      write(*,1001) rnrm,spftol(rnrm)
      return

 1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
      end subroutine

      subroutine zluchk(m,n,A,lda,L,ldl,R,ldr)
      integer m,n,lda,ldl,ldr
      double complex A(lda,n),L(ldl,min(m,n)),R(ldr,n)
      double precision rnrm,zlange
      external zgemm,zlange,dpftol
      character*4 dpftol
      double precision wrk(1)
      integer i,j

c zero lower triangle of R
      do j = 1,n-1
        do i = j+1,min(m,n)
          R(i,j) = 0e0
        end do
      end do
c form A - L*R
      call zgemm('N','N',m,n,min(m,n),(1d0,0d0),L,ldl,R,ldr,(-1d0,0d0),
     +A,lda)
c get frobenius norm
      rnrm = zlange('M',m,n,A,lda,wrk)
      write(*,1001) rnrm,dpftol(rnrm)
      return

 1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
      end subroutine

      subroutine slupgen(m,n,A,lda,L,ldl,R,ldr,p)
      integer m,n,lda,ldl,ldr,p(m)
      real A(lda,n),L(ldl,min(m,n)),R(ldr,n)
      integer ipiv(min(m,n)),info,i,j,tmp
      external sswap,slacpy,sgetrf
      if (m >= n) then
        call slacpy('0',m,n,A,lda,L,ldl)
        call sgetrf(m,n,L,ldl,ipiv,info)
        call slacpy('U',m,n,L,ldl,R,ldr)
      else
        call slacpy('0',m,n,A,lda,R,ldr)
        call sgetrf(m,n,R,ldr,ipiv,info)
        call slacpy('L',m,n,R,ldr,L,ldl)
      end if
      do i = 1,min(m,n)
        do j = 1,i-1
          L(j,i) = 0e0
        end do
        L(i,i) = 1e0
      end do
c generate permutation
      do i = 1,m
        p(i) = i
      end do
      do i = 1,min(m,n)
        j = ipiv(i)
        if (i /= j) then
          tmp = p(i)
          p(i) = p(j)
          p(j) = tmp
        end if
      end do
c zero lower triangle of R
      do j = 1,n-1
        do i = j+1,min(m,n)
          R(i,j) = 0e0
        end do
      end do
      end subroutine

      subroutine dlupgen(m,n,A,lda,L,ldl,R,ldr,p)
      integer m,n,lda,ldl,ldr,p(m)
      double precision A(lda,n),L(ldl,min(m,n)),R(ldr,n)
      integer ipiv(min(m,n)),info,i,j,tmp
      external dswap,dlacpy,dgetrf
      if (m >= n) then
        call dlacpy('0',m,n,A,lda,L,ldl)
        call dgetrf(m,n,L,ldl,ipiv,info)
        call dlacpy('U',m,n,L,ldl,R,ldr)
      else
        call dlacpy('0',m,n,A,lda,R,ldr)
        call dgetrf(m,n,R,ldr,ipiv,info)
        call dlacpy('L',m,n,R,ldr,L,ldl)
      end if
      do i = 1,min(m,n)
        do j = 1,i-1
          L(j,i) = 0d0
        end do
        L(i,i) = 1d0
      end do
c generate permutation
      do i = 1,m
        p(i) = i
      end do
      do i = 1,min(m,n)
        j = ipiv(i)
        if (i /= j) then
          tmp = p(i)
          p(i) = p(j)
          p(j) = tmp
        end if
      end do
c zero lower triangle of R
      do j = 1,n-1
        do i = j+1,min(m,n)
          R(i,j) = 0d0
        end do
      end do
      end subroutine

      subroutine clupgen(m,n,A,lda,L,ldl,R,ldr,p)
      integer m,n,lda,ldl,ldr,p(m)
      complex A(lda,n),L(ldl,min(m,n)),R(ldr,n)
      integer ipiv(min(m,n)),info,i,j,tmp
      external cswap,clacpy,cgetrf
      if (m >= n) then
        call clacpy('0',m,n,A,lda,L,ldl)
        call cgetrf(m,n,L,ldl,ipiv,info)
        call clacpy('U',m,n,L,ldl,R,ldr)
      else
        call clacpy('0',m,n,A,lda,R,ldr)
        call cgetrf(m,n,R,ldr,ipiv,info)
        call clacpy('L',m,n,R,ldr,L,ldl)
      end if
      do i = 1,min(m,n)
        do j = 1,i-1
          L(j,i) = 0e0
        end do
        L(i,i) = 1e0
      end do
c generate permutation
      do i = 1,m
        p(i) = i
      end do
      do i = 1,min(m,n)
        j = ipiv(i)
        if (i /= j) then
          tmp = p(i)
          p(i) = p(j)
          p(j) = tmp
        end if
      end do
c zero lower triangle of R
      do j = 1,n-1
        do i = j+1,min(m,n)
          R(i,j) = 0e0
        end do
      end do
      end subroutine

      subroutine zlupgen(m,n,A,lda,L,ldl,R,ldr,p)
      integer m,n,lda,ldl,ldr,p(m)
      double complex A(lda,n),L(ldl,min(m,n)),R(ldr,n)
      integer ipiv(min(m,n)),info,i,j,tmp
      external zswap,zlacpy,zgetrf
      if (m >= n) then
        call zlacpy('0',m,n,A,lda,L,ldl)
        call zgetrf(m,n,L,ldl,ipiv,info)
        call zlacpy('U',m,n,L,ldl,R,ldr)
      else
        call zlacpy('0',m,n,A,lda,R,ldr)
        call zgetrf(m,n,R,ldr,ipiv,info)
        call zlacpy('L',m,n,R,ldr,L,ldl)
      end if
      do i = 1,min(m,n)
        do j = 1,i-1
          L(j,i) = 0d0
        end do
        L(i,i) = 1d0
      end do
c generate permutation
      do i = 1,m
        p(i) = i
      end do
      do i = 1,min(m,n)
        j = ipiv(i)
        if (i /= j) then
          tmp = p(i)
          p(i) = p(j)
          p(j) = tmp
        end if
      end do
c zero lower triangle of R
      do j = 1,n-1
        do i = j+1,min(m,n)
          R(i,j) = 0d0
        end do
      end do
      end subroutine

c converts a linear permutation into LAPACK ipiv-style form
      subroutine p2ipiv(n,p)
      integer n,p(n)
      integer q(n),i,j,k
      do i = 1,n
        q(p(i)) = i
      end do
      do i = 1,n
        j = p(i)
        k = q(i)
        if (j /= i) then
          p(k) = j
          q(j) = k
          p(i) = j
        end if
      end do
      end subroutine

      subroutine slupchk(m,n,A,lda,L,ldl,R,ldr,p)
      integer m,n,lda,ldl,ldr,p(m)
      real A(lda,n),L(ldl,min(m,n)),R(ldr,n)
      real rnrm,slange
      external sswap,sgemm,slange,spftol
      character*4 spftol
      real wrk(1)
      integer i,j

c convert p into successive swaps      
      call p2ipiv(m,p)
c form A - L*R
      do i = 1,m
        j = p(i)
        if (i /= j) then
          call sswap(n,A(i,1),lda,A(j,1),lda)
        end if
      end do
      call sgemm('N','N',m,n,min(m,n),1e0,L,ldl,R,ldr,-1e0,A,lda)
c get frobenius norm
      rnrm = slange('M',m,n,A,lda,wrk)
      write(*,1001) rnrm,spftol(rnrm)
      return

 1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
      end subroutine

      subroutine dlupchk(m,n,A,lda,L,ldl,R,ldr,p)
      integer m,n,lda,ldl,ldr,p(m)
      double precision A(lda,n),L(ldl,min(m,n)),R(ldr,n)
      double precision rnrm,dlange
      external dswap,dgemm,dlange,dpftol
      character*4 dpftol
      double precision wrk(1)
      integer i,j

c convert p into successive swaps      
      call p2ipiv(m,p)
c form A - L*R
      do i = 1,m
        j = p(i)
        if (i /= j) then
          call dswap(n,A(i,1),lda,A(j,1),lda)
        end if
      end do
      call dgemm('N','N',m,n,min(m,n),1d0,L,ldl,R,ldr,-1d0,A,lda)
c get frobenius norm
      rnrm = dlange('M',m,n,A,lda,wrk)
      write(*,1001) rnrm,dpftol(rnrm)
      return

 1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
      end subroutine

      subroutine clupchk(m,n,A,lda,L,ldl,R,ldr,p)
      integer m,n,lda,ldl,ldr,p(m)
      complex A(lda,n),L(ldl,min(m,n)),R(ldr,n)
      real rnrm,clange
      external cswap,cgemm,clange,spftol
      character*4 spftol
      real wrk(1)
      integer i,j

c convert p into successive swaps      
      call p2ipiv(m,p)
c form A - L*R
      do i = 1,m
        j = p(i)
        if (i /= j) then
          call cswap(n,A(i,1),lda,A(j,1),lda)
        end if
      end do
      call cgemm('N','N',m,n,min(m,n),(1e0,0e0),L,ldl,R,ldr,(-1e0,0e0),
     +A,lda)
c get frobenius norm
      rnrm = clange('M',m,n,A,lda,wrk)
      write(*,1001) rnrm,spftol(rnrm)
      return

 1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
      end subroutine

      subroutine zlupchk(m,n,A,lda,L,ldl,R,ldr,p)
      integer m,n,lda,ldl,ldr,p(m)
      double complex A(lda,n),L(ldl,min(m,n)),R(ldr,n)
      double precision rnrm,zlange
      external zswap,zgemm,zlange,dpftol
      character*4 dpftol
      double precision wrk(1)
      integer i,j

c convert p into successive swaps      
      call p2ipiv(m,p)
c form A - L*R
      do i = 1,m
        j = p(i)
        if (i /= j) then
          call zswap(n,A(i,1),lda,A(j,1),lda)
        end if
      end do
      call zgemm('N','N',m,n,min(m,n),(1d0,0d0),L,ldl,R,ldr,(-1d0,0d0),
     +A,lda)
c get frobenius norm
      rnrm = zlange('M',m,n,A,lda,wrk)
      write(*,1001) rnrm,dpftol(rnrm)
      return

 1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
      end subroutine

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
!> \brief Updates an LU factorization after a rank-1 modification.
!>
!> \par Definition:
! =============
!> \verbatim
!>       subroutine zlu1up(m,n,L,ldl,R,ldr,u,v)
!>
!>       .. Scalar Arguments ..
!>       integer            m, n, ldl, ldr
!>       ..
!>       .. Array Arguments ..
!>       double complex     L(ldl,*), R(ldr,*), u(*), v(*)
!>       ..
!> \endverbatim
!>
!> \par Purpose:
! =============
!> \verbatim
!>
!> ZLU1UP updates an LU factorization after rank-1 modification.
!> Given an m-by-k lower-triangular matrix L with unit diagonal and
!> a k-by-n upper-trapezoidal matrix R, where k = min(m,n), this
!> ZLU1UP updates L -> L1 and R -> R1 so that L1 is again
!> lower unit triangular, R1 upper trapezoidal, and
!> L1*R1 = L*R + u*v', where v' denotes the conjugate transpose
!> of v.
!>
!> The update is performed using the Bennett algorithm with
!> column-major access, which processes the leading k-by-k block
!> first and then finishes the trailing part of R if needed.
!> \endverbatim
!>
!> \param[in] m
!> \verbatim
!>          m is INTEGER
!>          The number of rows of the matrix L.  m >= 0.
!> \endverbatim
!>
!> \param[in] n
!> \verbatim
!>          n is INTEGER
!>          The number of columns of the matrix R.  n >= 0.
!> \endverbatim
!>
!> \param[in,out] L
!> \verbatim
!>          L is COMPLEX*16 array, dimension (ldl,k)
!>          On entry, the unit lower triangular matrix L.  On exit,
!>          the updated unit lower triangular matrix L1.
!> \endverbatim
!>
!> \param[in] ldl
!> \verbatim
!>          ldl is INTEGER
!>          The leading dimension of the array L.  ldl >= m.
!> \endverbatim
!>
!> \param[in,out] R
!> \verbatim
!>          R is COMPLEX*16 array, dimension (ldr,n)
!>          On entry, the upper trapezoidal m-by-n matrix R.
!>          On exit, the updated upper trapezoidal matrix R1.
!> \endverbatim
!>
!> \param[in] ldr
!> \verbatim
!>          ldr is INTEGER
!>          The leading dimension of the array R.  ldr >= k,
!>          where k = min(m,n).
!> \endverbatim
!>
!> \param[in,out] u
!> \verbatim
!>          u is COMPLEX*16 array, dimension (m)
!>          On entry, the left m-vector defining the rank-1
!>          modification.  On exit, if k < m, u is destroyed;
!>          otherwise, u contains the updated vector.
!> \endverbatim
!>
!> \param[in,out] v
!> \verbatim
!>          v is COMPLEX*16 array, dimension (n)
!>          On entry, the right n-vector defining the rank-1
!>          modification.  On exit, v is destroyed.
!> \endverbatim
!>
!> \ingroup ludecomp
subroutine zlu1up(m,n,L,ldl,R,ldr,u,v)
    use iso_fortran_env
    use qrupdate_error
    integer, intent(in) :: m, n, ldl, ldr
    complex(real64), intent(inout) :: L(ldl,*), R(ldr,*)
    complex(real64), intent(inout) :: u(*), v(*)
    complex(real64) ui,vi
    integer k,info,i,j
    ! quick return if possible.
    k = min(m,n)
    if (k == 0) return
    ! check arguments.
    info = 0
    if (m < 0) then
        info = 1
    else if (n < 0) then
        info = 2
    else if (ldl < m) then
        info = 4
    else if (ldr < k) then
        info = 6
    endif
    if (info /= 0) then
        call qrupdate_xerror('ZLU1UP',info)
        return
    end if
    ! The Bennett algorithm, modified for column-major access.
    ! The leading part.
    do i = 1,k
        ! prefetch
        ui = u(i)
        vi = v(i)
        ! delayed R update
        do j = 1,i-1
            R(j,i) = R(j,i) + u(j)*vi
            vi = vi - v(j)*R(j,i)
        end do
        ! diagonal update
        R(i,i) = R(i,i) + ui*vi
        vi = vi/R(i,i)
        ! L update
        do j = i+1,m
            u(j) = u(j) - ui*L(j,i)
            L(j,i) = L(j,i) + u(j)*vi
        end do
        u(i) = ui
        v(i) = vi
    end do
    ! Finish the trailing part of R if needed.
    do i = k+1,n
        vi = v(i)
        do j = 1,k
            R(j,i) = R(j,i) + u(j)*vi
            vi = vi - v(j)*R(j,i)
        end do
        v(i) = vi
    end do
end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine cchinx(n,R,ldr,j,u,rw,info)
c purpose:      given an upper triangular matrix R that is a Cholesky
c               factor of a hermitian positive definite matrix A, i.e.
c               A = R'*R, this subroutine updates R -> R1 so that
c               R1'*R1 = A1, A1(jj,jj) = A, A(j,:) = u', A(:,j) = u,
c               jj = [1:j-1,j+1:n+1].
c               (complex version)
c arguments:
c n (in)        the order of matrix R.
c R (io)        on entry, the original upper trapezoidal matrix R.
c               on exit, the updated matrix R1.
c ldr (in)      leading dimension of R. ldr >= n+1.
c j (in)        the position of the inserted row/column
c u (io)        on entry, the inserted row/column.
c               on exit, u is destroyed.
c rw (out)      real workspace vector of size n+1.
c info (out)    on exit, error code:
c                info = 0: success.
c                info = 1: update violates positive-definiteness.
c                info = 2: R is singular.
c                info = 3: diagonal element of u is not real.
c
      integer n,j,ldr,info
      complex R(ldr,*),u(*),rw(*)
      external xerbla,ccopy,scnrm2,ctrsv,cqrtv1,cqrqh
      complex t
      real scnrm2,rho
      integer i

c check arguments
      info = 0
      if (n < 0) then
        info = -1
      else if (j < 1 .or. j > n+1) then
        info = -4
      end if
      if (info /= 0) then
        call xerbla('CCHINX',info)
        return
      end if

c shift vector.
      t = u(j)
      do i = j,n
        u(i) = u(i+1)
      end do
c the diagonal element must be real.
      if (imag(t) /= 0e0) goto 30

c check for singularity of R.
      do i = 1,n
        if (R(i,i) == 0e0) goto 20
      end do
c form R' \ u
      call ctrsv('U','C','N',n,R,ldr,u,1)
      rho = scnrm2(n,u,1)
c check positive definiteness.
      rho = t - rho**2
      if (rho <= 0e0) goto 10
c shift columns
      do i = n,j,-1
        call ccopy(i,R(1,i),1,R(1,i+1),1)
        R(i+1,i+1) = 0e0
      end do
      call ccopy(n,u,1,R(1,j),1)
      R(n+1,j) = sqrt(rho)
c retriangularize
      if (j < n+1) then
c eliminate the introduced spike.
        call cqrtv1(n+2-j,R(j,j),rw)
c apply rotations to R
        call cqrqh(n+2-j,n+1-j,R(j,j+1),ldr,rw,R(j+1,j))
c zero spike.
        do i = j+1,n+1
          R(i,j) = 0e0
        end do
      end if
c normal return.
      return
c error returns.
 10   info = 1
      return
 20   info = 2
      return
 30   info = 3
      return
      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine sqrtv1(n,u,w)
c purpose:      generates a sequence of n-1 Givens rotations that
c               eliminate all but the first element of a vector u.
c arguments:
c n (in)        the length of the vector u
c u (io)        on entry, the vector u.
c               on exit, u(2:n) contains the rotation sines, u(1)
c               contains the remaining element.
c w (o)         on exit, w contains the rotation cosines.
c
      integer n
      real u(*),w(*)
      external slartg
      real rr,t
      integer i
c quick return if possible.
      if (n <= 0) return
      rr = u(n)
      do i = n-1,1,-1
        call slartg(u(i),rr,w(i),u(i+1),t)
        rr = t
      end do
      u(1) = rr
      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine cqrot(dir,m,n,Q,ldq,c,s)
c purpose:      Apply a sequence of inv. rotations from right
c
c arguments:
c dir (in)      if 'B' or 'b', rotations are applied from backwards
c               if 'F' or 'f', from forwards.
c m (in)        number of rows of matrix Q
c n (in)        number of columns of the matrix Q
c Q (io)        on entry, the matrix Q
c               on exit, the updated matrix Q1
c ldq (in)      the leading dimension of Q
c c (in)        n-1 rotation cosines
c s (in)        n-1 rotation sines
c
      character dir
      integer m,n,ldq
      complex Q(ldq,*),s(*)
      real c(*)
      external crot,lsame
      logical lsame,fwd
      integer info,i
c quick return if possible
      if (m == 0 .or. n == 0 .or. n == 1) return
c check arguments.
      info = 0
      fwd = lsame(dir,'F')
      if (.not.(fwd .or. lsame(dir,'B'))) then
        info = 1
      else if (m < 0) then
        info = 2
      else if (n < 0) then
        info = 3
      else if (ldq < m) then
        info = 5
      end if
      if (info /= 0) then
        call xerbla('CQROT',info)
        return
      end if

      if (fwd) then
        do i = 1,n-1
          call crot(m,Q(1,i),1,Q(1,i+1),1,c(i),conjg(s(i)))
        end do
      else
        do i = n-1,1,-1
          call crot(m,Q(1,i),1,Q(1,i+1),1,c(i),conjg(s(i)))
        end do
      end if
      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine dqhqr(m,n,R,ldr,c,s)
c purpose:      given an m-by-n upper Hessenberg matrix R, this
c               subroutine updates R to upper trapezoidal form
c               using min(m-1,n) Givens rotations.
c               (real version)
c arguments:
c m (in)        number of rows of the matrix R
c n (in)        number of columns of the matrix R
c R (io)        on entry, the upper Hessenberg matrix R
c               on exit, the updated upper trapezoidal matrix
c ldr (in)      leading dimension of R, >= m
c c(out)        rotation cosines, size at least min(m-1,n)
c s(out)        rotation sines, size at least min(m-1,n)
c
      integer m,n,ldr
      double precision R(ldr,*),c(*),s(*)
      external xerbla,dlartg
      double precision t
      integer info,i,ii,j
c quick return if possible.
      if (m == 0 .or. m == 1 .or. n == 0) return
c check arguments.
      info = 0
      if (m < 0) then
        info = 1
      else if (n < 0) then
        info = 2
      else if (ldr < m) then
        info = 4
      end if
      if (info /= 0) then
        call xerbla('DQHQR',info)
        return
      end if
      do i = 1,n
c apply stored rotations, column-wise
        t = R(1,i)
        ii = min(m,i)
        do j = 1,ii-1
          R(j,i) = c(j)*t + s(j)*R(j+1,i)
          t = c(j)*R(j+1,i) - s(j)*t
        end do
        if (ii < m) then
c generate next rotation
          call dlartg(t,R(ii+1,i),c(i),s(i),R(ii,i))
          R(ii+1,i) = 0d0
        else
          R(ii,i) = t
        end if
      end do
      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      program tlu1up
      integer m,n

      write (*,*)
      write (*,*) 'testing LU rank-1 update routines.'
      write (*,*) 'All residual errors are expected to be small.'
      write (*,*)

      m = 60
      n = 40
      write (*,*) 'slu1up test (rows > columns):'
      call stest(m,n)
      write (*,*) 'dlu1up test (rows > columns):'
      call dtest(m,n)
      write (*,*) 'clu1up test (rows > columns):'
      call ctest(m,n)
      write (*,*) 'zlu1up test (rows > columns):'
      call ztest(m,n)

      m = 40
      n = 60
      write (*,*) 'slu1up test (rows < columns):'
      call stest(m,n)
      write (*,*) 'dlu1up test (rows < columns):'
      call dtest(m,n)
      write (*,*) 'clu1up test (rows < columns):'
      call ctest(m,n)
      write (*,*) 'zlu1up test (rows < columns):'
      call ztest(m,n)

      call pstats
      end program

      subroutine stest(m,n)
      integer m,n
      real A(m,n),L(m,min(m,n)),R(min(m,n),n),u(m),v(n)
      external srandg,slugen,sger,slu1up,sluchk
      integer k
c set up random matrix & vectors
      call srandg(m,n,A,m)
      call srandg(m,1,u,m)
      call srandg(n,1,v,n)
      k = min(m,n)
c generate LU decomposition
      call slugen(m,n,A,m,L,m,R,k)
c update A
      call sger(m,n,1e0,u,1,v,1,A,m)
c update the LU decomposition
      call slu1up(m,n,L,m,R,k,u,v)
c check result
      call sluchk(m,n,A,m,L,m,R,k)

      end subroutine

      subroutine dtest(m,n)
      integer m,n
      double precision A(m,n),L(m,min(m,n)),R(min(m,n),n),u(m),v(n)
      external drandg,dlugen,dger,dlu1up,dluchk
      integer k
c set up random matrix & vectors
      call drandg(m,n,A,m)
      call drandg(m,1,u,m)
      call drandg(n,1,v,n)
      k = min(m,n)
c generate LU decomposition
      call dlugen(m,n,A,m,L,m,R,k)
c update A
      call dger(m,n,1d0,u,1,v,1,A,m)
c update the LU decomposition
      call dlu1up(m,n,L,m,R,k,u,v)
c check result
      call dluchk(m,n,A,m,L,m,R,k)

      end subroutine

      subroutine ctest(m,n)
      integer m,n
      complex A(m,n),L(m,min(m,n)),R(min(m,n),n),u(m),v(n)
      external crandg,clugen,cgeru,clu1up,cluchk
      integer k
c set up random matrix & vectors
      call crandg(m,n,A,m)
      call crandg(m,1,u,m)
      call crandg(n,1,v,n)
      k = min(m,n)
c generate LU decomposition
      call clugen(m,n,A,m,L,m,R,k)
c update A
      call cgeru(m,n,(1e0,0e0),u,1,v,1,A,m)
c update the LU decomposition
      call clu1up(m,n,L,m,R,k,u,v)
c check result
      call cluchk(m,n,A,m,L,m,R,k)

      end subroutine

      subroutine ztest(m,n)
      integer m,n
      double complex A(m,n),L(m,min(m,n)),R(min(m,n),n),u(m),v(n)
      external zrandg,zlugen,zgeru,zlu1up,zluchk
      integer k
c set up random matrix & vectors
      call zrandg(m,n,A,m)
      call zrandg(m,1,u,m)
      call zrandg(n,1,v,n)
      k = min(m,n)
c generate LU decomposition
      call zlugen(m,n,A,m,L,m,R,k)
c update A
      call zgeru(m,n,(1d0,0d0),u,1,v,1,A,m)
c update the LU decomposition
      call zlu1up(m,n,L,m,R,k,u,v)
c check result
      call zluchk(m,n,A,m,L,m,R,k)

      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      program tqrder
      integer m,n,j

      write (*,*)
      write (*,*) 'testing QR row delete routines.'
      write (*,*) 'All residual errors are expected to be small.'
      write (*,*)

      m = 60
      n = 40
      j = 30
      write (*,*) 'sqrder test (full factorization):'
      call stest(m,n,j)
      write (*,*) 'dqrder test (full factorization):'
      call dtest(m,n,j)
      write (*,*) 'cqrder test (full factorization):'
      call ctest(m,n,j)
      write (*,*) 'zqrder test (full factorization):'
      call ztest(m,n,j)

      call pstats
      end program

      subroutine stest(m,n,j)
      integer m,n,j
      real A(m,max(m,n)),Q(m,m),R(m,n),wrk(2*m)
      external srandg,sqrgen,scopy,sqrder,sqrchk
      integer i
c set up random matrix & vector
      call srandg(m,n,A,m)
c generate QR decomposition
      call sqrgen(m,n,A,m,Q,m,R,m)
c update A
      do i = j,m-1
        call scopy(n,A(i+1,1),m,A(i,1),m)
      end do
c update the QR decomposition
      call sqrder(m,n,Q,m,R,m,j,wrk)
c check result
      call sqrchk(m-1,n,m-1,A,m,Q,m,R,m)

      end subroutine

      subroutine dtest(m,n,j)
      integer m,n,j
      double precision A(m,max(m,n)),Q(m,m),R(m,n),wrk(2*m)
      external drandg,dqrgen,dcopy,dqrder,dqrchk
      integer i
c set up random matrix & vector
      call drandg(m,n,A,m)
c generate QR decomposition
      call dqrgen(m,n,A,m,Q,m,R,m)
c update A
      do i = j,m-1
        call dcopy(n,A(i+1,1),m,A(i,1),m)
      end do
c update the QR decomposition
      call dqrder(m,n,Q,m,R,m,j,wrk)
c check result
      call dqrchk(m-1,n,m-1,A,m,Q,m,R,m)

      end subroutine

      subroutine ctest(m,n,j)
      integer m,n,j
      complex A(m,max(m,n)),Q(m,m),R(m,n),wrk(m)
      real rwrk(m)
      external crandg,cqrgen,ccopy,cqrder,cqrchk
      integer i
c set up random matrix & vector
      call crandg(m,n,A,m)
c generate QR decomposition
      call cqrgen(m,n,A,m,Q,m,R,m)
c update A
      do i = j,m-1
        call ccopy(n,A(i+1,1),m,A(i,1),m)
      end do
c update the QR decomposition
      call cqrder(m,n,Q,m,R,m,j,wrk,rwrk)
c check result
      call cqrchk(m-1,n,m-1,A,m,Q,m,R,m)

      end subroutine

      subroutine ztest(m,n,j)
      integer m,n,j
      double complex A(m,max(m,n)),Q(m,m),R(m,n),wrk(m)
      double precision rwrk(m)
      external zrandg,zqrgen,zcopy,zqrder,zqrchk
      integer i
c set up random matrix & vector
      call zrandg(m,n,A,m)
c generate QR decomposition
      call zqrgen(m,n,A,m,Q,m,R,m)
c update A
      do i = j,m-1
        call zcopy(n,A(i+1,1),m,A(i,1),m)
      end do
c update the QR decomposition
      call zqrder(m,n,Q,m,R,m,j,wrk,rwrk)
c check result
      call zqrchk(m-1,n,m-1,A,m,Q,m,R,m)

      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      program tqrinr
      integer m,n,j

      write (*,*)
      write (*,*) 'testing QR row insert routines.'
      write (*,*) 'All residual errors are expected to be small.'
      write (*,*)

      m = 60
      n = 40
      j = 30
      write (*,*) 'sqrinr test (full factorization):'
      call stest(m,n,j)
      write (*,*) 'dqrinr test (full factorization):'
      call dtest(m,n,j)
      write (*,*) 'cqrinr test (full factorization):'
      call ctest(m,n,j)
      write (*,*) 'zqrinr test (full factorization):'
      call ztest(m,n,j)

      call pstats
      end program

      subroutine stest(m,n,j)
      integer m,n,j
      real A(m+1,max(m+1,n)),Q(m+1,m+1),R(m+1,n),u(n),wrk(n)
      external srandg,sqrgen,scopy,sqrinr,sqrchk
      integer i
c set up random matrix & vector
      call srandg(m,n,A,m+1)
      call srandg(n,1,u,n)
c generate QR decomposition
      call sqrgen(m,n,A,m+1,Q,m+1,R,m+1)
c update A
      do i = m,j,-1
        call scopy(n,A(i,1),m+1,A(i+1,1),m+1)
      end do
      call scopy(n,u,1,A(j,1),m+1)
c update the QR decomposition
      call sqrinr(m,n,Q,m+1,R,m+1,j,u,wrk)
c check result
      call sqrchk(m+1,n,m+1,A,m+1,Q,m+1,R,m+1)

      end subroutine

      subroutine dtest(m,n,j)
      integer m,n,j
      double precision A(m+1,max(m+1,n)),Q(m+1,m+1),R(m+1,n),u(n),wrk(n)
      external drandg,dqrgen,dcopy,dqrinr,dqrchk
      integer i
c set up random matrix & vector
      call drandg(m,n,A,m+1)
      call drandg(n,1,u,n)
c generate QR decomposition
      call dqrgen(m,n,A,m+1,Q,m+1,R,m+1)
c update A
      do i = m,j,-1
        call dcopy(n,A(i,1),m+1,A(i+1,1),m+1)
      end do
      call dcopy(n,u,1,A(j,1),m+1)
c update the QR decomposition
      call dqrinr(m,n,Q,m+1,R,m+1,j,u,wrk)
c check result
      call dqrchk(m+1,n,m+1,A,m+1,Q,m+1,R,m+1)

      end subroutine

      subroutine ctest(m,n,j)
      integer m,n,j
      complex A(m+1,max(m+1,n)),Q(m+1,m+1),R(m+1,n),u(n),wrk(n)
      external crandg,cqrgen,ccopy,cqrinr,cqrchk
      integer i
c set up random matrix & vector
      call crandg(m,n,A,m+1)
      call crandg(n,1,u,n)
c generate QR decomposition
      call cqrgen(m,n,A,m+1,Q,m+1,R,m+1)
c update A
      do i = m,j,-1
        call ccopy(n,A(i,1),m+1,A(i+1,1),m+1)
      end do
      call ccopy(n,u,1,A(j,1),m+1)
c update the QR decomposition
      call cqrinr(m,n,Q,m+1,R,m+1,j,u,wrk)
c check result
      call cqrchk(m+1,n,m+1,A,m+1,Q,m+1,R,m+1)

      end subroutine

      subroutine ztest(m,n,j)
      integer m,n,j
      double complex A(m+1,max(m+1,n)),Q(m+1,m+1),R(m+1,n),u(n),wrk(n)
      external zrandg,zqrgen,zcopy,zqrinr,zqrchk
      integer i
c set up random matrix & vector
      call zrandg(m,n,A,m+1)
      call zrandg(n,1,u,n)
c generate QR decomposition
      call zqrgen(m,n,A,m+1,Q,m+1,R,m+1)
c update A
      do i = m,j,-1
        call zcopy(n,A(i,1),m+1,A(i+1,1),m+1)
      end do
      call zcopy(n,u,1,A(j,1),m+1)
c update the QR decomposition
      call zqrinr(m,n,Q,m+1,R,m+1,j,u,wrk)
c check result
      call zqrchk(m+1,n,m+1,A,m+1,Q,m+1,R,m+1)

      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine cqrdec(m,n,k,Q,ldq,R,ldr,j,rw)
c purpose:      updates a QR factorization after deleting
c               a column.
c               i.e., given an m-by-k unitary matrix Q, an k-by-n
c               upper trapezoidal matrix R and index j in the range
c               1:n+1, this subroutine updates the matrix Q -> Q1 and
c               R -> R1 so that Q1 remains unitary, R1 is upper
c               trapezoidal, and Q1*R1 = [A(:,1:j-1) A(:,j+1:n)],
c               where A = Q*R.
c               (complex version)
c arguments:
c m (in)        number of rows of the matrix Q.
c n (in)        number of columns of the matrix R.
c k (in)        number of columns of Q, and rows of R. Must be
c               either k = m (full Q) or k = n < m (economical form,
c               basis dimension will decrease).
c Q (io)        on entry, the unitary m-by-k matrix Q.
c               on exit, the updated matrix Q1.
c ldq (in)      leading dimension of Q. ldq >= m.
c R (io)        on entry, the original matrix R.
c               on exit, the updated matrix R1.
c ldr (in)      leading dimension of R. ldr >= k.
c j (in)        the position of the deleted column in R.
c               1 <= j <= n.
c rw (o)        a real workspace vector of size k-j.
c
      integer m,n,k,ldq,ldr,j
      complex Q(ldq,*),R(ldr,*)
      real rw(*)
      external xerbla,ccopy,cqhqr,cqrot
      integer info,i
c quick return if possible.
      if (m == 0 .or. n == 0 .or. j == n) return
c check arguments.
      info = 0
      if (m < 0) then
        info = 1
      else if (n < 0) then
        info = 2
      else if (k /= m .and. (k /= n .or. n >= m)) then
        info = 3
      else if (ldq < m) then
        info = 5
      else if (ldr < k) then
        info = 7
      else if (j < 1 .or. j > n+1) then
        info = 8
      end if
      if (info /= 0) then
        call xerbla('CQRDEC',info)
        return
      end if

c delete the j-th column.
      do i = j,n-1
        call ccopy(k,R(1,i+1),1,R(1,i),1)
      end do
c retriangularize.
      if (j < k) then
        call cqhqr(k+1-j,n-j,R(j,j),ldr,rw,R(1,n))
c apply rotations to Q.
        call cqrot('F',m,min(k,n)+1-j,Q(1,j),ldq,rw,R(1,n))
      end if
      end subroutine

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
program tchdex
    integer n,j
    external stest, dtest, ctest, ztest, pstats


    write (*,*)
    write (*,*) 'testing Cholesky symmetric delete routines.'
    write (*,*) 'All residual errors are expected to be small.'
    write (*,*)

    n = 50
    j = 15
    write (*,*) 'schdex test:'
    call stest(n,j)
    write (*,*) 'dchdex test:'
    call dtest(n,j)
    write (*,*) 'cchdex test:'
    call ctest(n,j)
    write (*,*) 'zchdex test:'
    call ztest(n,j)

    call pstats
end program

subroutine stest(n,j)
    use iso_fortran_env
    integer n,j
    real(real32) A(n,n),R(n,n),wrk(n)
    external srandg,schgen,schdex,schchk
    integer i,k
    ! set up random matrix & vectors
    call srandg(n,n,A,n)
    ! generate A'*A and its Cholesky decomposition
    call schgen(n,A,n,R,n)
    ! update the matrix A
    do k = j,n-1
        do i = 1,j-1
            A(i,k) = A(i,k+1)
        end do
        do i = j,k
            A(i,k) = A(i+1,k+1)
        end do
    end do
    ! update the Cholesky decomposition
    call schdex(n,R,n,j,wrk)
    ! check result
    call schchk(n-1,A,n,R,n)

end subroutine

subroutine dtest(n,j)
    use iso_fortran_env
    integer n,j
    real(real64) A(n,n),R(n,n),wrk(n)
    external drandg,dchgen,dchdex,dchchk
    integer i,k
    ! set up random matrix & vectors
    call drandg(n,n,A,n)
    ! generate A'*A and its Cholesky decomposition
    call dchgen(n,A,n,R,n)
    ! update the matrix A
    do k = j,n-1
        do i = 1,j-1
            A(i,k) = A(i,k+1)
        end do
        do i = j,k
            A(i,k) = A(i+1,k+1)
        end do
    end do
    ! update the Cholesky decomposition
    call dchdex(n,R,n,j,wrk)
    ! check result
    call dchchk(n-1,A,n,R,n)

end subroutine

subroutine ctest(n,j)
    use iso_fortran_env
    integer n,j
    complex(real32) A(n,n),R(n,n)
    real(real32) rwrk(n)
    external crandg,cchgen,cchdex,cchchk
    integer i,k
    ! set up random matrix & vectors
    call crandg(n,n,A,n)
    ! generate A'*A and its Cholesky decomposition
    call cchgen(n,A,n,R,n)
    ! update the matrix A
    do k = j,n-1
        do i = 1,j-1
            A(i,k) = A(i,k+1)
        end do
        do i = j,k
            A(i,k) = A(i+1,k+1)
        end do
    end do
    ! update the Cholesky decomposition
    call cchdex(n,R,n,j,rwrk)
    ! check result
    call cchchk(n-1,A,n,R,n)

end subroutine

subroutine ztest(n,j)
    use iso_fortran_env
    integer n,j
    complex(real64) A(n,n),R(n,n)
    real(real64) rwrk(n)
    external zrandg,zchgen,zchdex,zchchk
    integer i,k
    ! set up random matrix & vectors
    call zrandg(n,n,A,n)
    ! generate A'*A and its Cholesky decomposition
    call zchgen(n,A,n,R,n)
    ! update the matrix A
    do k = j,n-1
        do i = 1,j-1
            A(i,k) = A(i,k+1)
        end do
        do i = j,k
            A(i,k) = A(i+1,k+1)
        end do
    end do
    ! update the Cholesky decomposition
    call zchdex(n,R,n,j,rwrk)
    ! check result
    call zchchk(n-1,A,n,R,n)

    END

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine schdex(n,R,ldr,j,w)
c purpose:      given an upper triangular matrix R that is a Cholesky
c               factor of a symmetric positive definite matrix A, i.e.
c               A = R'*R, this subroutine updates R -> R1 so that
c               R1'*R1 = A(jj,jj), where jj = [1:j-1,j+1:n+1].
c               (real version)
c arguments:
c n (in)        the order of matrix R.
c R (io)        on entry, the original upper trapezoidal matrix R.
c               on exit, the updated matrix R1.
c ldr (in)      leading dimension of R. ldr >= n.
c j (in)        the position of the deleted row/column.
c w (out)       a workspace vector of size n.
c
      integer n,ldr,j
      real R(ldr,*),w(*)
      integer info,i
      external xerbla,scopy,sqhqr

c quick return if possible
      if (n == 1) return

c check arguments
      info = 0
      if (n < 0) then
        info = 1
      else if (j < 1 .or. j > n) then
        info = 4
      end if
      if (info /= 0) then
        call xerbla('SCHDEX',info)
        return
      end if

c delete the j-th column.
      do i = j,n-1
        call scopy(n,R(1,i+1),1,R(1,i),1)
      end do
c retriangularize.
      if (j < n) then
        call sqhqr(n+1-j,n-j,R(j,j),ldr,w,R(1,n))
      end if
      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      program tch1up
      integer n

      write (*,*)
      write (*,*) 'testing Cholesky rank-1 update routines.'
      write (*,*) 'All residual errors are expected to be small.'
      write (*,*)

      n = 50
      write (*,*) 'sch1up test:'
      call stest(n)
      write (*,*) 'dch1up test:'
      call dtest(n)
      write (*,*) 'cch1up test:'
      call ctest(n)
      write (*,*) 'zch1up test:'
      call ztest(n)

      call pstats
      end program

      subroutine stest(n)
      integer n
      real A(n,n),R(n,n),u(n),wrk(n)
      external srandg,schgen,ssyr,sch1up,schchk
c set up random matrix & vectors
      call srandg(n,n,A,n)
      call srandg(n,1,u,n)
c generate A'*A and its Cholesky decomposition
      call schgen(n,A,n,R,n)
c update the matrix A
      call ssyr('U',n,1e0,u,1,A,n)
c update the Cholesky decomposition
      call sch1up(n,R,n,u,wrk)
c check result
      call schchk(n,A,n,R,n)

      end subroutine

      subroutine dtest(n)
      integer n
      double precision A(n,n),R(n,n),u(n),wrk(n)
      external drandg,dchgen,dsyr,dch1up,dchchk
c set up random matrix & vectors
      call drandg(n,n,A,n)
      call drandg(n,1,u,n)
c generate A'*A and its Cholesky decomposition
      call dchgen(n,A,n,R,n)
c update the matrix A
      call dsyr('U',n,1d0,u,1,A,n)
c update the Cholesky decomposition
      call dch1up(n,R,n,u,wrk)
c check result
      call dchchk(n,A,n,R,n)

      end subroutine

      subroutine ctest(n)
      integer n
      complex A(n,n),R(n,n),u(n)
      real rwrk(n)
      external crandg,cchgen,cher,cch1up,cchchk
c set up random matrix & vectors
      call crandg(n,n,A,n)
      call crandg(n,1,u,n)
c generate A'*A and its Cholesky decomposition
      call cchgen(n,A,n,R,n)
c update the matrix A
      call cher('U',n,1e0,u,1,A,n)
c update the Cholesky decomposition
      call cch1up(n,R,n,u,rwrk)
c check result
      call cchchk(n,A,n,R,n)

      end subroutine

      subroutine ztest(n)
      integer n
      double complex A(n,n),R(n,n),u(n)
      double precision rwrk(n)
      external zrandg,zchgen,zher,zch1up,zchchk
c set up random matrix & vectors
      call zrandg(n,n,A,n)
      call zrandg(n,1,u,n)
c generate A'*A and its Cholesky decomposition
      call zchgen(n,A,n,R,n)
c update the matrix A
      call zher('U',n,1d0,u,1,A,n)
c update the Cholesky decomposition
      call zch1up(n,R,n,u,rwrk)
c check result
      call zchchk(n,A,n,R,n)

      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      program tchinx
      integer n,j

      write (*,*)
      write (*,*) 'testing Cholesky symmetric insert routines.'
      write (*,*) 'All residual errors are expected to be small.'
      write (*,*)

      n = 50
      j = 25
      write (*,*) 'schinx test:'
      call stest(n,j)
      write (*,*) 'dchinx test:'
      call dtest(n,j)
      write (*,*) 'cchinx test:'
      call ctest(n,j)
      write (*,*) 'zchinx test:'
      call ztest(n,j)

      call pstats
      end program

      subroutine stest(n,j)
      integer n,j
      real A(n,n),R(n,n),u(n),wrk(n)
      external srandg,schgen,schinx,schchk
      integer info,i
c set up random matrix & vectors
      call srandg(n,n,A,n)
c generate A'*A and its Cholesky decomposition
      call schgen(n,A,n,R,n)
c save the row/column
      do i = 1,j
        u(i) = A(i,j)
      end do
      do i = j+1,n
        u(i) = A(j,i)
      end do
c update the Cholesky decomposition
      call schdex(n,R,n,j,wrk)
c put the row/column back
      call schinx(n-1,R,n,j,u,wrk,info)
c check result
      call schchk(n,A,n,R,n)

      end subroutine

      subroutine dtest(n,j)
      integer n,j
      double precision A(n,n),R(n,n),u(n),wrk(n)
      external drandg,dchgen,dchinx,dchchk
      integer info,i
c set up random matrix & vectors
      call drandg(n,n,A,n)
c generate A'*A and its Cholesky decomposition
      call dchgen(n,A,n,R,n)
c save the row/column
      do i = 1,j
        u(i) = A(i,j)
      end do
      do i = j+1,n
        u(i) = A(j,i)
      end do
c update the Cholesky decomposition
      call dchdex(n,R,n,j,wrk)
c put the row/column back
      call dchinx(n-1,R,n,j,u,wrk,info)
c check result
      call dchchk(n,A,n,R,n)

      end subroutine

      subroutine ctest(n,j)
      integer n,j
      complex A(n,n),R(n,n),u(n)
      real rwrk(n)
      external crandg,cchgen,cchinx,cchchk
      integer info,i
c set up random matrix & vectors
      call crandg(n,n,A,n)
c generate A'*A and its Cholesky decomposition
      call cchgen(n,A,n,R,n)
c save the row/column
      do i = 1,j
        u(i) = A(i,j)
      end do
      do i = j+1,n
        u(i) = conjg(A(j,i))
      end do
c update the Cholesky decomposition
      call cchdex(n,R,n,j,rwrk)
c put the row/column back
      call cchinx(n-1,R,n,j,u,rwrk,info)
c check result
      call cchchk(n,A,n,R,n)

      end subroutine

      subroutine ztest(n,j)
      integer n,j
      double complex A(n,n),R(n,n),u(n)
      double precision rwrk(n)
      external zrandg,zchgen,zchinx,zchchk
      integer info,i
c set up random matrix & vectors
      call zrandg(n,n,A,n)
c generate A'*A and its Cholesky decomposition
      call zchgen(n,A,n,R,n)
c save the row/column
      do i = 1,j
        u(i) = A(i,j)
      end do
      do i = j+1,n
        u(i) = conjg(A(j,i))
      end do
c update the Cholesky decomposition
      call zchdex(n,R,n,j,rwrk)
c put the row/column back
      call zchinx(n-1,R,n,j,u,rwrk,info)
c check result
      call zchchk(n,A,n,R,n)

      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      program tchdex
      integer n,j

      write (*,*)
      write (*,*) 'testing Cholesky symmetric delete routines.'
      write (*,*) 'All residual errors are expected to be small.'
      write (*,*)

      n = 50
      j = 15
      write (*,*) 'schdex test:'
      call stest(n,j)
      write (*,*) 'dchdex test:'
      call dtest(n,j)
      write (*,*) 'cchdex test:'
      call ctest(n,j)
      write (*,*) 'zchdex test:'
      call ztest(n,j)

      call pstats
      end program

      subroutine stest(n,j)
      integer n,j
      real A(n,n),R(n,n),wrk(n)
      external srandg,schgen,schdex,schchk
      integer i,k
c set up random matrix & vectors
      call srandg(n,n,A,n)
c generate A'*A and its Cholesky decomposition
      call schgen(n,A,n,R,n)
c update the matrix A
      do k = j,n-1
        do i = 1,j-1
          A(i,k) = A(i,k+1)
        end do
        do i = j,k
          A(i,k) = A(i+1,k+1)
        end do
      end do
c update the Cholesky decomposition
      call schdex(n,R,n,j,wrk)
c check result
      call schchk(n-1,A,n,R,n)

      end subroutine

      subroutine dtest(n,j)
      integer n,j
      double precision A(n,n),R(n,n),wrk(n)
      external drandg,dchgen,dchdex,dchchk
      integer i,k
c set up random matrix & vectors
      call drandg(n,n,A,n)
c generate A'*A and its Cholesky decomposition
      call dchgen(n,A,n,R,n)
c update the matrix A
      do k = j,n-1
        do i = 1,j-1
          A(i,k) = A(i,k+1)
        end do
        do i = j,k
          A(i,k) = A(i+1,k+1)
        end do
      end do
c update the Cholesky decomposition
      call dchdex(n,R,n,j,wrk)
c check result
      call dchchk(n-1,A,n,R,n)

      end subroutine

      subroutine ctest(n,j)
      integer n,j
      complex A(n,n),R(n,n)
      real rwrk(n)
      external crandg,cchgen,cchdex,cchchk
      integer i,k
c set up random matrix & vectors
      call crandg(n,n,A,n)
c generate A'*A and its Cholesky decomposition
      call cchgen(n,A,n,R,n)
c update the matrix A
      do k = j,n-1
        do i = 1,j-1
          A(i,k) = A(i,k+1)
        end do
        do i = j,k
          A(i,k) = A(i+1,k+1)
        end do
      end do
c update the Cholesky decomposition
      call cchdex(n,R,n,j,rwrk)
c check result
      call cchchk(n-1,A,n,R,n)

      end subroutine

      subroutine ztest(n,j)
      integer n,j
      double complex A(n,n),R(n,n)
      double precision rwrk(n)
      external zrandg,zchgen,zchdex,zchchk
      integer i,k
c set up random matrix & vectors
      call zrandg(n,n,A,n)
c generate A'*A and its Cholesky decomposition
      call zchgen(n,A,n,R,n)
c update the matrix A
      do k = j,n-1
        do i = 1,j-1
          A(i,k) = A(i,k+1)
        end do
        do i = j,k
          A(i,k) = A(i+1,k+1)
        end do
      end do
c update the Cholesky decomposition
      call zchdex(n,R,n,j,rwrk)
c check result
      call zchchk(n-1,A,n,R,n)

      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine cch1dn(n,R,ldr,u,rw,info)
c purpose:      given an upper triangular matrix R that is a Cholesky
c               factor of a hermitian positive definite matrix A, i.e.
c               A = R'*R, this subroutine downdates R -> R1 so that
c               R1'*R1 = A - u*u'
c               (complex version)
c arguments:
c n (in)        the order of matrix R
c R (io)        on entry, the upper triangular matrix R
c               on exit, the updated matrix R1
c ldr (in)      leading dimension of R. ldr >= n.
c u (io)        the vector determining the rank-1 update
c               on exit, u contains the reflector sines
c               used to transform R to R1.
c rw (out)      cosine parts of reflectors.
c
c info (out)    on exit, error code:
c                info = 0: success.
c                info = 1: update violates positive-definiteness.
c                info = 2: R is singular.
c
      integer n,ldr
      complex R(ldr,*),u(*)
      real rw(*)
      integer info
      external ctrsv,clartg,scnrm2
      complex crho,rr,ui,t
      real scnrm2,rho
      integer i,j

c quick return if possible.
      if (n == 0) return
c check arguments.
      info = 0
      if (n < 0) then
        info = -1
      else if (ldr < n) then
        info = -3
      end if
      if (info /= 0) then
        call xerbla('CCH1DN',-info)
        return
      end if

c check for singularity of R.
      do i = 1,n
        if (R(i,i) == 0e0) goto 20
      end do
c form R' \ u
      call ctrsv('U','C','N',n,R,ldr,u,1)
      rho = scnrm2(n,u,1)
c check positive definiteness
      rho = 1 - rho**2
      if (rho <= 0e0) goto 10
      crho = sqrt(rho)
c eliminate R' \ u
      do i = n,1,-1
        ui = u(i)
c generate next rotation
        call clartg(crho,ui,rw(i),u(i),rr)
        crho = rr
      end do
c apply rotations
      do i = n,1,-1
        ui = 0e0
        do j = i,1,-1
          t = rw(j)*ui + u(j)*R(j,i)
          R(j,i) = rw(j)*R(j,i) - conjg(u(j))*ui
          ui = t
        end do
      end do

c normal return
      return
c error returns
 10   info = 1
      return
 20   info = 2
      return
      end subroutine

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
!> \brief Reduces an upper Hessenberg matrix to upper trapezoidal form.
!>
!> \par Definition:
! =============
!> \verbatim
!>       subroutine cqhqr(m,n,R,ldr,c,s)
!>
!>       .. Scalar Arguments ..
!>       integer            m, n, ldr
!>       ..
!>       .. Array Arguments ..
!>       complex            R(ldr,*), s(*)
!>       real               c(*)
!>       ..
!> \endverbatim
!>
!> \par Purpose:
! =============
!> \verbatim
!>
!> CQHQR reduces an m-by-n upper Hessenberg matrix R to upper
!> trapezoidal form.  Given an m-by-n upper Hessenberg matrix R,
!> CQHQR applies min(m-1,n) Givens rotations from the
!> left to eliminate the subdiagonal elements, producing an upper
!> trapezoidal matrix.
!>
!> On exit, c contains the cosine parts and s contains the sine
!> parts of the Givens rotations used in the reduction.
!> \endverbatim
!>
!> \param[in] m
!> \verbatim
!>          m is INTEGER
!>          The number of rows of the matrix R.  m >= 0.
!> \endverbatim
!>
!> \param[in] n
!> \verbatim
!>          n is INTEGER
!>          The number of columns of the matrix R.  n >= 0.
!> \endverbatim
!>
!> \param[in,out] R
!> \verbatim
!>          R is COMPLEX array, dimension (ldr,n)
!>          On entry, the upper Hessenberg matrix R.  On exit, the
!>          updated upper trapezoidal matrix.
!> \endverbatim
!>
!> \param[in] ldr
!> \verbatim
!>          ldr is INTEGER
!>          The leading dimension of the array R.  ldr >= m.
!> \endverbatim
!>
!> \param[out] c
!> \verbatim
!>          c is REAL array, dimension (min(m-1,n))
!>          On exit, the cosine parts of the Givens rotations used
!>          to reduce R to upper trapezoidal form.
!> \endverbatim
!>
!> \param[out] s
!> \verbatim
!>          s is COMPLEX array, dimension (min(m-1,n))
!>          On exit, the sine parts of the Givens rotations used
!>          to reduce R to upper trapezoidal form.
!> \endverbatim
!>
!> \ingroup qrdecomp
subroutine cqhqr(m,n,R,ldr,c,s)
    use iso_fortran_env
    use qrupdate_error
    integer, intent(in) :: m, n, ldr
    complex(real32), intent(inout) :: R(ldr,*)
    real(real32), intent(out) :: c(*)
    complex(real32), intent(out) :: s(*)
    external clartg
    complex(real32) t
    integer info,i,ii,j
    ! quick return if possible.
    if (m == 0 .or. m == 1 .or. n == 0) return
    ! check arguments.
    info = 0
    if (m < 0) then
        info = 1
    else if (n < 0) then
        info = 2
    else if (ldr < m) then
        info = 4
    end if
    if (info /= 0) then
        call qrupdate_xerror('CQHQR',info)
        return
    end if
    do i = 1,n
        ! apply stored rotations, column-wise
        t = R(1,i)
        ii = min(m,i)
        do j = 1,ii-1
            R(j,i) = c(j)*t + s(j)*R(j+1,i)
            t = c(j)*R(j+1,i) - conjg(s(j))*t
        end do
        if (ii < m) then
            ! generate next rotation
            call clartg(t,R(ii+1,i),c(i),s(i),R(ii,i))
            R(ii+1,i) = 0e0
        else
            R(ii,i) = t
        end if
    end do
end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine caxcpy(n,a,x,incx,y,incy)
c purpose:      constant times a conjugated vector plus a vector.
c arguments:
c n (in)        vector length
c a (in)        complex factor
c x (in)        added vector
c incx (in)     x increments
c y (io)        accumulator vector
c incy (in)     y increments
c
      integer n,incx,incy
      complex a,x(*),y(*)
      integer i,ix,iy
c quick return if possible.
      if (n <= 0) return
      if (incx /= 1 .or. incy /= 1) then
c code for unequal increments or equal increments not equal to 1
        ix = 1
        iy = 1
        if (incx.lt.0) ix = (-n+1)*incx + 1
        if (incy.lt.0) iy = (-n+1)*incy + 1
        do i = 1,n
          y(iy) = y(iy) + a*conjg(x(ix))
          ix = ix + incx
          iy = iy + incy
        end do
      else
c code for both increments equal to 1
        do i = 1,n
           y(i) = y(i) + a*conjg(x(i))
        end do
      end if
      end subroutine

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
!> \brief Updates a Cholesky factorization after inserting a row and column.
!>
!> \par Definition:
! =============
!> \verbatim
!>       subroutine zchinx(n,R,ldr,j,u,rw,info)
!>
!>       .. Scalar Arguments ..
!>       integer            n, j, ldr, info
!>       ..
!>       .. Array Arguments ..
!>       double complex     R(ldr,*), u(*), rw(*)
!>       ..
!> \endverbatim
!>
!> \par Purpose:
! =============
!> \verbatim
!>
!> ZCHINX updates the Cholesky factorization of a hermitian
!> positive definite matrix A after inserting a row and column.
!> Given an upper triangular matrix R that is a Cholesky factor of
!> A, i.e., A = R'*R, where R' denotes the conjugate transpose of
!> R, ZCHINX updates R -> R1 so that R1'*R1 = A1, where
!> A1(jj,jj) = A, A1(j,:) = u', A1(:,j) = u, and
!> jj = [1:j-1, j+1:n+1].
!>
!> On exit, u is destroyed and R is extended by one row and column.
!> The insertion is performed by first solving R'*u = v, checking
!> positive definiteness, and then retriangularizing.
!> \endverbatim
!>
!> \param[in] n
!> \verbatim
!>          n is INTEGER
!>          The order of matrix R.  n >= 0.
!> \endverbatim
!>
!> \param[in,out] R
!> \verbatim
!>          R is COMPLEX*16 array, dimension (ldr,n+1)
!>          On entry, the upper triangular matrix R, the Cholesky
!>          factor of A.  On exit, the updated upper triangular
!>          matrix R1, the Cholesky factor of A1.
!> \endverbatim
!>
!> \param[in] ldr
!> \verbatim
!>          ldr is INTEGER
!>          The leading dimension of the array R.  ldr >= n+1.
!> \endverbatim
!>
!> \param[in] j
!> \verbatim
!>          j is INTEGER
!>          The position of the inserted row and column.
!>          1 <= j <= n+1.
!> \endverbatim
!>
!> \param[in,out] u
!> \verbatim
!>          u is COMPLEX*16 array, dimension (n+1)
!>          On entry, the vector defining the inserted row/column.
!>          On exit, u is destroyed.
!> \endverbatim
!>
!> \param[out] rw
!> \verbatim
!>          rw is DOUBLE PRECISION array, dimension (n+1)
!>          Workspace vector used to store rotation cosines during
!>          the retriangularization.
!> \endverbatim
!>
!> \param[out] info
!> \verbatim
!>          info is INTEGER
!>          = 0:  successful exit
!>          = 1:  the update would violate positive-definiteness
!>          = 2:  R is singular
!>          = 3:  the diagonal element of u is not real
!> \endverbatim
!>
!> \ingroup choldecomp
subroutine zchinx(n,R,ldr,j,u,rw,info)
    use iso_fortran_env
    use qrupdate_error
    integer, intent(in) :: n, j, ldr
    complex(real64), intent(inout) :: R(ldr,*), u(*)
    real(real64), intent(out) :: rw(*)
    integer, intent(out) :: info
    external zcopy,dznrm2,ztrsv,zqrtv1,zqrqh
    complex(real64) t
    real(real64) dznrm2,rho
    integer i
    ! check arguments
    info = 0
    if (n < 0) then
        info = -1
    else if (j < 1 .or. j > n+1) then
        info = -4
    end if
    if (info /= 0) then
        call qrupdate_xerror('ZCHINX',info)
        return
    end if
    ! shift vector.
    t = u(j)
    do i = j,n
        u(i) = u(i+1)
    end do
    ! the diagonal element must be real.
    if (imag(t) /= 0d0) goto 30
    ! check for singularity of R.
    do i = 1,n
        if (R(i,i) == 0d0) goto 20
    end do
    ! form R' \ u
    call ztrsv('U','C','N',n,R,ldr,u,1)
    rho = dznrm2(n,u,1)
    ! check positive definiteness.
    rho = dble(t) - rho**2
    if (rho <= 0d0) goto 10
    ! shift columns
    do i = n,j,-1
        call zcopy(i,R(1,i),1,R(1,i+1),1)
        R(i+1,i+1) = 0d0
    end do
    call zcopy(n,u,1,R(1,j),1)
    R(n+1,j) = sqrt(rho)
    ! retriangularize
    if (j < n+1) then
        ! eliminate the introduced spike.
        call zqrtv1(n+2-j,R(j,j),rw)
        ! apply rotations to R
        call zqrqh(n+2-j,n+1-j,R(j,j+1),ldr,rw,R(j+1,j))
        ! zero spike.
        do i = j+1,n+1
            R(i,j) = 0d0
        end do
    end if
    ! normal return.
    return
    ! error returns.
    10 info = 1
    return
    20 info = 2
    return
    30 info = 3
    return
end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine cch1up(n,R,ldr,u,w)
c purpose:      given an upper triangular matrix R that is a Cholesky
c               factor of a hermitian positive definite matrix A, i.e.
c               A = R'*R, this subroutine updates R -> R1 so that
c               R1'*R1 = A + u*u'
c               (complex version)
c arguments:
c n (in)        the order of matrix R
c R (io)        on entry, the upper triangular matrix R
c               on exit, the updated matrix R1
c ldr (in)      leading dimension of R. ldr >= n.
c u (io)        the vector determining the rank-1 update
c               on exit, u contains the rotation sines
c               used to transform R to R1.
c w (out)       cosine parts of rotations.
c
      integer n,ldr
      complex R(ldr,*),u(*)
      real w(*)
      external clartg
      complex rr,ui,t
      integer i,j

      do i = 1,n
c apply stored rotations, column-wise
        ui = conjg(u(i))
        do j = 1,i-1
          t = w(j)*R(j,i) + u(j)*ui
          ui = w(j)*ui - conjg(u(j))*R(j,i)
          R(j,i) = t
        end do
c generate next rotation
        call clartg(R(i,i),ui,w(i),u(i),rr)
        R(i,i) = rr
      end do
      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      program tqrdec
      integer m,n,j

      write (*,*)
      write (*,*) 'testing QR column delete routines.'
      write (*,*) 'All residual errors are expected to be small.'
      write (*,*)

      m = 60
      n = 40
      j = 12
      write (*,*) 'sqrdec test (full factorization):'
      call stest(m,n,j,0)
      write (*,*) 'dqrdec test (full factorization):'
      call dtest(m,n,j,0)
      write (*,*) 'cqrdec test (full factorization):'
      call ctest(m,n,j,0)
      write (*,*) 'zqrdec test (full factorization):'
      call ztest(m,n,j,0)

      write (*,*) 'sqrdec test (economized factorization):'
      call stest(m,n,j,1)
      write (*,*) 'dqrdec test (economized factorization):'
      call dtest(m,n,j,1)
      write (*,*) 'cqrdec test (economized factorization):'
      call ctest(m,n,j,1)
      write (*,*) 'zqrdec test (economized factorization):'
      call ztest(m,n,j,1)

      call pstats
      end program

      subroutine stest(m,n,j,ec)
      integer m,n,j,ec
      real A(m,max(m,n)),Q(m,m),R(m,n),wrk(m)
      external srandg,sqrgen,scopy,sqrdec,sqrchk
      integer k,i
c set up random matrix & vector
      call srandg(m,n,A,m)
c generate QR decomposition
      call sqrgen(m,n,A,m,Q,m,R,m)
c update A
      do i = j,n-1
        call scopy(m,A(1,i+1),1,A(1,i),1)
      end do
c update the QR decomposition
      k = m
      if (ec == 1) k = n
      call sqrdec(m,n,k,Q,m,R,m,j,wrk)
c check result
      if (ec == 1) k = n+1
      call sqrchk(m,n-1,k,A,m,Q,m,R,m)

      end subroutine

      subroutine dtest(m,n,j,ec)
      integer m,n,j,ec
      double precision A(m,max(m,n)),Q(m,m),R(m,n),wrk(m)
      external drandg,dqrgen,dcopy,dqrdec,dqrchk
      integer k,i
c set up random matrix & vector
      call drandg(m,n,A,m)
c generate QR decomposition
      call dqrgen(m,n,A,m,Q,m,R,m)
c update A
      do i = j,n-1
        call dcopy(m,A(1,i+1),1,A(1,i),1)
      end do
c update the QR decomposition
      k = m
      if (ec == 1) k = n
      call dqrdec(m,n,k,Q,m,R,m,j,wrk)
c check result
      if (ec == 1) k = n+1
      call dqrchk(m,n-1,k,A,m,Q,m,R,m)

      end subroutine

      subroutine ctest(m,n,j,ec)
      integer m,n,j,ec
      complex A(m,max(m,n)),Q(m,m),R(m,n),wrk(m)
      external crandg,cqrgen,ccopy,cqrdec,cqrchk
      integer k,i
c set up random matrix & vector
      call crandg(m,n,A,m)
c generate QR decomposition
      call cqrgen(m,n,A,m,Q,m,R,m)
c update A
      do i = j,n-1
        call ccopy(m,A(1,i+1),1,A(1,i),1)
      end do
c update the QR decomposition
      k = m
      if (ec == 1) k = n
      call cqrdec(m,n,k,Q,m,R,m,j,wrk)
c check result
      if (ec == 1) k = n+1
      call cqrchk(m,n-1,k,A,m,Q,m,R,m)

      end subroutine

      subroutine ztest(m,n,j,ec)
      integer m,n,j,ec
      double complex A(m,max(m,n)),Q(m,m),R(m,n),wrk(m)
      external zrandg,zqrgen,zcopy,zqrdec,zqrchk
      integer k,i
c set up random matrix & vector
      call zrandg(m,n,A,m)
c generate QR decomposition
      call zqrgen(m,n,A,m,Q,m,R,m)
c update A
      do i = j,n-1
        call zcopy(m,A(1,i+1),1,A(1,i),1)
      end do
c update the QR decomposition
      k = m
      if (ec == 1) k = n
      call zqrdec(m,n,k,Q,m,R,m,j,wrk)
c check result
      if (ec == 1) k = n+1
      call zqrchk(m,n-1,k,A,m,Q,m,R,m)

      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      subroutine cgqvec(m,n,Q,ldq,u)
c purpose:      given an unitary m-by-n matrix Q, n < m, generates
c               a vector u such that Q'*u = 0 and norm(u) = 1.
c arguments:
c m (in)        number of rows of matrix Q.
c n (in)        number of columns of matrix Q.
c Q (in)        the unitary matrix Q.
c ldq (in)      leading dimension of Q.
c u (out)       the generated vector.
c
      integer m,n,ldq
      complex Q(ldq,*),u(*)
      external cdotu,caxpy,scnrm2,csscal
      complex cdotu
      real scnrm2,r
      integer info,i,j
c quick return if possible.
      if (m == 0) return
      if (n == 0) then
        u(1) = 1e0
        do i = 2,m
          u(i) = 0e0
        end do
        return
      end if
c check arguments.
      info = 0
      if (m < 0) then
        info = 1
      else if (n < 0) then
        info = 2
      else if (ldq < m) then
        info = 4
      end if
      if (info /= 0) then
        call xerbla('CGQVEC',info)
        return
      end if

      j = 1
 10   continue
c probe j-th canonical unit vector.
      do i = 1,m
        u(i) = 0e0
      end do
      u(j) = 1e0
c form u - Q*Q'*u
      do i = 1,n
        r = cdotu(m,Q(1,i),1,u,1)
        call caxpy(m,-r,Q(1,i),1,u,1)
      end do
      r = scnrm2(m,u,1)
      if (r == 0e0) then
        j = j + 1
        if (j > n) then
c this is fatal, and in theory, it can't happen.
          stop 'fatal: impossible condition in CGQVEC'
        else
          j = j + 1
          goto 10
        end if
      end if
      call csscal(m,1e0/r,u,1)
      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      program tqrshc
      integer m,n,i,j

      write (*,*)
      write (*,*) 'testing QR column shift routines.'
      write (*,*) 'All residual errors are expected to be small.'
      write (*,*)

      m = 60
      n = 50
      i = 20
      j = 40
      write (*,*) 'sqrshc test (left shift, full factorization):'
      call stest(m,n,i,j,0)
      write (*,*) 'dqrshc test (left shift, full factorization):'
      call dtest(m,n,i,j,0)
      write (*,*) 'cqrshc test (left shift, full factorization):'
      call ctest(m,n,i,j,0)
      write (*,*) 'zqrshc test (left shift, full factorization):'
      call ztest(m,n,i,j,0)

      i = 40
      j = 20
      write (*,*) 'sqrshc test (right shift, economized factorization):'
      call stest(m,n,i,j,1)
      write (*,*) 'dqrshc test (right shift, economized factorization):'
      call dtest(m,n,i,j,1)
      write (*,*) 'cqrshc test (right shift, economized factorization):'
      call ctest(m,n,i,j,1)
      write (*,*) 'zqrshc test (right shift, economized factorization):'
      call ztest(m,n,i,j,1)

      call pstats
      end program

      subroutine stest(m,n,i,j,ec)
      integer m,n,i,j,ec
      real A(m,max(m,n)),Q(m,m),R(m,n),wrk(2*m)
      external srandg,sqrgen,scopy,sqrshc,sqrchk
      integer k
c set up random matrix & vector
      call srandg(m,n,A,m)
c generate QR decomposition
      call sqrgen(m,n,A,m,Q,m,R,m)
c update A
      if (i < j) then
        call scopy(m,A(1,i),1,wrk,1)
        do k = i,j-1
          call scopy(m,A(1,k+1),1,A(1,k),1)
        end do
        call scopy(m,wrk,1,A(1,j),1)
      else
        call scopy(m,A(1,i),1,wrk,1)
        do k = i,j+1,-1
          call scopy(m,A(1,k-1),1,A(1,k),1)
        end do
        call scopy(m,wrk,1,A(1,j),1)
      end if
c update the QR decomposition
      k = m
      if (ec == 1) k = n
      call sqrshc(m,n,k,Q,m,R,m,i,j,wrk)
c check result
      call sqrchk(m,n,k,A,m,Q,m,R,m)

      end subroutine

      subroutine dtest(m,n,i,j,ec)
      integer m,n,i,j,ec
      double precision A(m,max(m,n)),Q(m,m),R(m,n),wrk(2*m)
      external drandg,dqrgen,dcopy,dqrshc,dqrchk
      integer k
c set up random matrix & vector
      call drandg(m,n,A,m)
c generate QR decomposition
      call dqrgen(m,n,A,m,Q,m,R,m)
c update A
      if (i < j) then
        call dcopy(m,A(1,i),1,wrk,1)
        do k = i,j-1
          call dcopy(m,A(1,k+1),1,A(1,k),1)
        end do
        call dcopy(m,wrk,1,A(1,j),1)
      else
        call dcopy(m,A(1,i),1,wrk,1)
        do k = i,j+1,-1
          call dcopy(m,A(1,k-1),1,A(1,k),1)
        end do
        call dcopy(m,wrk,1,A(1,j),1)
      end if
c update the QR decomposition
      k = m
      if (ec == 1) k = n
      call dqrshc(m,n,k,Q,m,R,m,i,j,wrk)
c check result
      call dqrchk(m,n,k,A,m,Q,m,R,m)

      end subroutine

      subroutine ctest(m,n,i,j,ec)
      integer m,n,i,j,ec
      complex A(m,max(m,n)),Q(m,m),R(m,n),wrk(m)
      real rwrk(m)
      external crandg,cqrgen,ccopy,cqrshc,cqrchk
      integer k
c set up random matrix & vector
      call crandg(m,n,A,m)
c generate QR decomposition
      call cqrgen(m,n,A,m,Q,m,R,m)
c update A
      if (i < j) then
        call ccopy(m,A(1,i),1,wrk,1)
        do k = i,j-1
          call ccopy(m,A(1,k+1),1,A(1,k),1)
        end do
        call ccopy(m,wrk,1,A(1,j),1)
      else
        call ccopy(m,A(1,i),1,wrk,1)
        do k = i,j+1,-1
          call ccopy(m,A(1,k-1),1,A(1,k),1)
        end do
        call ccopy(m,wrk,1,A(1,j),1)
      end if
c update the QR decomposition
      k = m
      if (ec == 1) k = n
      call cqrshc(m,n,k,Q,m,R,m,i,j,wrk,rwrk)
c check result
      call cqrchk(m,n,k,A,m,Q,m,R,m)

      end subroutine

      subroutine ztest(m,n,i,j,ec)
      integer m,n,i,j,ec
      double complex A(m,max(m,n)),Q(m,m),R(m,n),wrk(m)
      double precision rwrk(m)
      external zrandg,zqrgen,zcopy,zqrshc,zqrchk
      integer k
c set up random matrix & vector
      call zrandg(m,n,A,m)
c generate QR decomposition
      call zqrgen(m,n,A,m,Q,m,R,m)
c update A
      if (i < j) then
        call zcopy(m,A(1,i),1,wrk,1)
        do k = i,j-1
          call zcopy(m,A(1,k+1),1,A(1,k),1)
        end do
        call zcopy(m,wrk,1,A(1,j),1)
      else
        call zcopy(m,A(1,i),1,wrk,1)
        do k = i,j+1,-1
          call zcopy(m,A(1,k-1),1,A(1,k),1)
        end do
        call zcopy(m,wrk,1,A(1,j),1)
      end if
c update the QR decomposition
      k = m
      if (ec == 1) k = n
      call zqrshc(m,n,k,Q,m,R,m,i,j,wrk,rwrk)
c check result
      call zqrchk(m,n,k,A,m,Q,m,R,m)

      end subroutine

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
program tchinx
    integer n,j
    external stest, dtest, ctest, ztest, pstats


    write (*,*)
    write (*,*) 'testing Cholesky symmetric insert routines.'
    write (*,*) 'All residual errors are expected to be small.'
    write (*,*)

    n = 50
    j = 25
    write (*,*) 'schinx test:'
    call stest(n,j)
    write (*,*) 'dchinx test:'
    call dtest(n,j)
    write (*,*) 'cchinx test:'
    call ctest(n,j)
    write (*,*) 'zchinx test:'
    call ztest(n,j)

    call pstats
end program

subroutine stest(n,j)
    use iso_fortran_env
    integer n,j
    real(real32) A(n,n),R(n,n),u(n),wrk(n)
    external srandg,schgen,schinx,schchk,schdex
    integer info,i
    ! set up random matrix & vectors
    call srandg(n,n,A,n)
    ! generate A'*A and its Cholesky decomposition
    call schgen(n,A,n,R,n)
    ! save the row/column
    do i = 1,j
        u(i) = A(i,j)
    end do
    do i = j+1,n
        u(i) = A(j,i)
    end do
    ! update the Cholesky decomposition
    call schdex(n,R,n,j,wrk)
    ! put the row/column back
    call schinx(n-1,R,n,j,u,wrk,info)
    ! check result
    call schchk(n,A,n,R,n)

end subroutine

subroutine dtest(n,j)
    use iso_fortran_env
    integer n,j
    real(real64) A(n,n),R(n,n),u(n),wrk(n)
    external drandg,dchgen,dchinx,dchchk,dchdex
    integer info,i
    ! set up random matrix & vectors
    call drandg(n,n,A,n)
    ! generate A'*A and its Cholesky decomposition
    call dchgen(n,A,n,R,n)
    ! save the row/column
    do i = 1,j
        u(i) = A(i,j)
    end do
    do i = j+1,n
        u(i) = A(j,i)
    end do
    ! update the Cholesky decomposition
    call dchdex(n,R,n,j,wrk)
    ! put the row/column back
    call dchinx(n-1,R,n,j,u,wrk,info)
    ! check result
    call dchchk(n,A,n,R,n)

end subroutine

subroutine ctest(n,j)
    use iso_fortran_env
    integer n,j
    complex(real32) A(n,n),R(n,n),u(n)
    real(real32) rwrk(n)
    external crandg,cchgen,cchinx,cchchk,cchdex
    integer info,i
    ! set up random matrix & vectors
    call crandg(n,n,A,n)
    ! generate A'*A and its Cholesky decomposition
    call cchgen(n,A,n,R,n)
    ! save the row/column
    do i = 1,j
        u(i) = A(i,j)
    end do
    do i = j+1,n
        u(i) = conjg(A(j,i))
    end do
    ! update the Cholesky decomposition
    call cchdex(n,R,n,j,rwrk)
    ! put the row/column back
    call cchinx(n-1,R,n,j,u,rwrk,info)
    ! check result
    call cchchk(n,A,n,R,n)

end subroutine

subroutine ztest(n,j)
    use iso_fortran_env
    integer n,j
    complex(real64) A(n,n),R(n,n),u(n)
    real(real64) rwrk(n)
    external zrandg,zchgen,zchinx,zchchk,zchdex
    integer info,i
    ! set up random matrix & vectors
    call zrandg(n,n,A,n)
    ! generate A'*A and its Cholesky decomposition
    call zchgen(n,A,n,R,n)
    ! save the row/column
    do i = 1,j
        u(i) = A(i,j)
    end do
    do i = j+1,n
        u(i) = conjg(A(j,i))
    end do
    ! update the Cholesky decomposition
    call zchdex(n,R,n,j,rwrk)
    ! put the row/column back
    call zchinx(n-1,R,n,j,u,rwrk,info)
    ! check result
    call zchchk(n,A,n,R,n)

    END

      program tchshx
      integer n,i,j

      write (*,*)
      write (*,*) 'testing QR column shift routines.'
      write (*,*) 'All residual errors are expected to be small.'
      write (*,*)

      n = 50
      i = 20
      j = 40
      write (*,*) 'schshx test (left shift):'
      call stest(n,i,j)
      write (*,*) 'dchshx test (left shift):'
      call dtest(n,i,j)
      write (*,*) 'cchshx test (left shift):'
      call ctest(n,i,j)
      write (*,*) 'zchshx test (left shift):'
      call ztest(n,i,j)

      i = 40
      j = 20
      write (*,*) 'schshx test (right shift):'
      call stest(n,i,j)
      write (*,*) 'dchshx test (right shift):'
      call dtest(n,i,j)
      write (*,*) 'cchshx test (right shift):'
      call ctest(n,i,j)
      write (*,*) 'zchshx test (right shift):'
      call ztest(n,i,j)

      call pstats
      end program

      subroutine stest(n,i,j)
      integer n,i,j
      real A(n,n),R(n,n),wrk(2*n)
      external srandg,schgen,sswap,schshx,schchk
      integer k
c set up random matrix
      call srandg(n,n,A,n)
c generate A'*A and its Cholesky decomposition
      call schgen(n,A,n,R,n)
c update matrix
      if (i < j) then
        do k = i,j-1
          call sswap(n,A(1,k),1,A(1,k+1),1)
          call sswap(n,A(k,1),n,A(k+1,1),n)
        end do
      else if (i > j) then
        do k = i,j+1,-1
          call sswap(n,A(1,k),1,A(1,k-1),1)
          call sswap(n,A(k,1),n,A(k-1,1),n)
        end do
      end if
c update factorization
      call schshx(n,R,n,i,j,wrk)
c check result
      call schchk(n,A,n,R,n)

      end subroutine

      subroutine dtest(n,i,j)
      integer n,i,j
      double precision A(n,n),R(n,n),wrk(2*n)
      external drandg,dchgen,dswap,dchshx,dchchk
      integer k
c set up random matrix
      call drandg(n,n,A,n)
c generate A'*A and its Cholesky decomposition
      call dchgen(n,A,n,R,n)
c update matrix
      if (i < j) then
        do k = i,j-1
          call dswap(n,A(1,k),1,A(1,k+1),1)
          call dswap(n,A(k,1),n,A(k+1,1),n)
        end do
      else if (i > j) then
        do k = i,j+1,-1
          call dswap(n,A(1,k),1,A(1,k-1),1)
          call dswap(n,A(k,1),n,A(k-1,1),n)
        end do
      end if
c update factorization
      call dchshx(n,R,n,i,j,wrk)
c check result
      call dchchk(n,A,n,R,n)

      end subroutine

      subroutine ctest(n,i,j)
      integer n,i,j
      complex A(n,n),R(n,n),wrk(n)
      real rwrk(n)
      external crandg,cchgen,cswap,cchshx,cchchk
      integer k
c set up random matrix
      call crandg(n,n,A,n)
c generate A'*A and its Cholesky decomposition
      call cchgen(n,A,n,R,n)
c update matrix
      if (i < j) then
        do k = i,j-1
          call cswap(n,A(1,k),1,A(1,k+1),1)
          call cswap(n,A(k,1),n,A(k+1,1),n)
        end do
      else if (i > j) then
        do k = i,j+1,-1
          call cswap(n,A(1,k),1,A(1,k-1),1)
          call cswap(n,A(k,1),n,A(k-1,1),n)
        end do
      end if
c update factorization
      call cchshx(n,R,n,i,j,wrk,rwrk)
c check result
      call cchchk(n,A,n,R,n)

      end subroutine

      subroutine ztest(n,i,j)
      integer n,i,j
      double complex A(n,n),R(n,n),wrk(n)
      double precision rwrk(n)
      external zrandg,zchgen,zswap,zchshx,zchchk
      integer k
c set up random matrix
      call zrandg(n,n,A,n)
c generate A'*A and its Cholesky decomposition
      call zchgen(n,A,n,R,n)
c update matrix
      if (i < j) then
        do k = i,j-1
          call zswap(n,A(1,k),1,A(1,k+1),1)
          call zswap(n,A(k,1),n,A(k+1,1),n)
        end do
      else if (i > j) then
        do k = i,j+1,-1
          call zswap(n,A(1,k),1,A(1,k-1),1)
          call zswap(n,A(k,1),n,A(k-1,1),n)
        end do
      end if
c update factorization
      call zchshx(n,R,n,i,j,wrk,rwrk)
c check result
      call zchchk(n,A,n,R,n)

      end subroutine

c Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
c
c Author: Jaroslav Hajek <highegg@gmail.com>
c
c This file is part of qrupdate.
c
c qrupdate is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 3 of the License, or
c (at your option) any later version.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this software; see the file COPYING.  If not, see
c <http://www.gnu.org/licenses/>.
c
      program tqr1up
      integer m,n

      write (*,*)
      write (*,*) 'testing QR rank-1 update routines.'
      write (*,*) 'All residual errors are expected to be small.'
      write (*,*)

      m = 60
      n = 40
      write (*,*) 'sqr1up test (full factorization):'
      call stest(m,n,0)
      write (*,*) 'dqr1up test (full factorization):'
      call dtest(m,n,0)
      write (*,*) 'cqr1up test (full factorization):'
      call ctest(m,n,0)
      write (*,*) 'zqr1up test (full factorization):'
      call ztest(m,n,0)

      write (*,*) 'sqr1up test (economized factorization):'
      call stest(m,n,1)
      write (*,*) 'dqr1up test (economized factorization):'
      call dtest(m,n,1)
      write (*,*) 'cqr1up test (economized factorization):'
      call ctest(m,n,1)
      write (*,*) 'zqr1up test (economized factorization):'
      call ztest(m,n,1)

      m = 40
      n = 60
      write (*,*) 'sqr1up test (rows < columns):'
      call stest(m,n,0)
      write (*,*) 'dqr1up test (rows < columns):'
      call dtest(m,n,0)
      write (*,*) 'cqr1up test (rows < columns):'
      call ctest(m,n,0)
      write (*,*) 'zqr1up test (rows < columns):'
      call ztest(m,n,0)

      call pstats
      end program

      subroutine stest(m,n,ec)
      integer m,n,ec
      real A(m,max(m,n)),Q(m,m),R(m,n),u(m),v(n),wrk(2*m)
      external srandg,sqrgen,sger,sqr1up,sqrchk
      integer k
c set up random matrix & vectors
      call srandg(m,n,A,m)
      call srandg(m,1,u,m)
      call srandg(n,1,v,n)
c generate QR decomposition
      call sqrgen(m,n,A,m,Q,m,R,m)
c update A
      call sger(m,n,1e0,u,1,v,1,A,m)
c update the QR decomposition
      k = m
      if (ec == 1) k = n
      call sqr1up(m,n,k,Q,m,R,m,u,v,wrk)
c check result
      call sqrchk(m,n,k,A,m,Q,m,R,m)

      end subroutine

      subroutine dtest(m,n,ec)
      integer m,n,ec
      double precision A(m,max(m,n)),Q(m,m),R(m,n),u(m),v(n),wrk(2*m)
      external drandg,dqrgen,dger,dqr1up,dqrchk
      integer k
c set up random matrix & vectors
      call drandg(m,n,A,m)
      call drandg(m,1,u,m)
      call drandg(n,1,v,n)
c generate QR decomposition
      call dqrgen(m,n,A,m,Q,m,R,m)
c update A
      call dger(m,n,1d0,u,1,v,1,A,m)
c update the QR decomposition
      k = m
      if (ec == 1) k = n
      call dqr1up(m,n,k,Q,m,R,m,u,v,wrk)
c check result
      call dqrchk(m,n,k,A,m,Q,m,R,m)

      end subroutine

      subroutine ctest(m,n,ec)
      integer m,n,ec
      complex A(m,max(m,n)),Q(m,m),R(m,n),u(m),v(n),wrk(m)
      real rwrk(m)
      external crandg,cqrgen,cgerc,cqr1up,cqrchk
      integer k
c set up random matrix & vectors
      call crandg(m,n,A,m)
      call crandg(m,1,u,m)
      call crandg(n,1,v,n)
c generate QR decomposition
      call cqrgen(m,n,A,m,Q,m,R,m)
c update A
      call cgerc(m,n,(1e0,0e0),u,1,v,1,A,m)
c update the QR decomposition
      k = m
      if (ec == 1) k = n
      call cqr1up(m,n,k,Q,m,R,m,u,v,wrk,rwrk)
c check result
      call cqrchk(m,n,k,A,m,Q,m,R,m)

      end subroutine

      subroutine ztest(m,n,ec)
      integer m,n,ec
      double complex A(m,max(m,n)),Q(m,m),R(m,n),u(m),v(n),wrk(m)
      double precision rwrk(m)
      external zrandg,zqrgen,zgerc,zqr1up,zqrchk
      integer k
c set up random matrix & vectors
      call zrandg(m,n,A,m)
      call zrandg(m,1,u,m)
      call zrandg(n,1,v,n)
c generate QR decomposition
      call zqrgen(m,n,A,m,Q,m,R,m)
c update A
      call zgerc(m,n,(1d0,0d0),u,1,v,1,A,m)
c update the QR decomposition
      k = m
      if (ec == 1) k = n
      call zqr1up(m,n,k,Q,m,R,m,u,v,wrk,rwrk)
c check result
      call zqrchk(m,n,k,A,m,Q,m,R,m)

      end subroutine

! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
program tgqvec
    use iso_fortran_env
    implicit none
    integer :: m, n, passed, failed
    integer :: i
    real(real32) :: slamch
    real(real64) :: dlamch
    external :: slamch, dlamch

    common /stats/ passed, failed
    passed = 0
    failed = 0

    write(*,*)
    write(*,*) 'Testing gqvec routines.'
    write(*,*)
    write(*,1000)

    ! Test cases: (m, n) pairs
    ! - n = 0: trivial case, u should be e_1
    ! - n = 1: orthogonal complement is m-1 dimensional
    ! - n = m-1: orthogonal complement is 1 dimensional
    ! - n = m div 2: moderate complement dimension
    ! - n = m div 2 - 1: slightly smaller complement
    ! - large m: stress test

    do i = 1, 6
        select case (i)
        case (1)
            m = 10
            n = 0
        case (2)
            m = 10
            n = 1
        case (3)
            m = 10
            n = m - 1
        case (4)
            m = 10
            n = m / 2
        case (5)
            m = 10
            n = m / 2 - 1
        case (6)
            m = 100
            n = 50
        end select

        write(*,*) 'Test case (m,n) = (', m, ',', n, '):'
        call stest(m, n)
        call dtest(m, n)
        call ctest(m, n)
        call ztest(m, n)
    end do

    write(*,1000)
    write(*,1001) passed, failed
    write(*,*)
    if (failed .ne. 0) stop 1

    1000 format(70('-'))
    1001 format('total:', 1x, 'PASSED', 1x, I6, 1x, 'FAILED', 1x, I6)
end program tgqvec

! Convert integer to string
subroutine int2str(n, s)
    integer, intent(in) :: n
    character(len=*), intent(out) :: s
    character(len=12) :: tmp
    write(tmp, '(I12)') n
    s = adjustl(tmp)
end subroutine int2str

subroutine stest(m, n)
    use iso_fortran_env
    integer, intent(in) :: m, n
    real(real32), allocatable :: A(:,:), Q(:,:), R(:,:), u(:), Qcheck(:,:)
    real(real32) :: slamch, tol
    integer :: j
    character(len=40) :: lbl
    integer :: passed, failed
    common /stats/ passed, failed

    external :: sgqvec, srandg, sqrgen, slamch
    real(real32) :: sdot, snrm2

    allocate(A(m, m), Q(m, m), R(m, m), u(m), Qcheck(m+3, m))

    call srandg(m, n, A, m)
    call sqrgen(m, n, A, m, Q, m, R, m)

    ! Test with ldq = m (tight packing)
    call sgqvec(m, n, Q, m, u)
    tol = 5e2 * slamch('p')
    call int2str(m, lbl)
    if (n == 0) then
        call check_unit_vector_s(m, u, tol, 's (n=0, ldq=' // lbl // ')')
    else
        call check_orthogonal_s(m, n, Q, m, u, tol, 's (n>0, ldq=' // lbl // ')')
        call check_unit_norm_s(m, u, tol, 's (n>0, ldq=' // lbl // ')')
    end if

    ! Test with ldq > m (leading dimension padding)
    do j = 1, 3
        call srandg(m, n, A, m)
        call sqrgen(m, n, A, m, Q, m, R, m)
        if (n == 0) then
            call sgqvec(m, n, Q, m+j, u)
            tol = 5e2 * slamch('p')
            call int2str(m + j, lbl)
            call check_unit_vector_s(m, u, tol, 's (n=0, ldq=' // lbl // ')')
        else
            call sgqvec_ldq(m, n, Q, m+j, u, Qcheck)
            tol = 5e2 * slamch('p')
            call int2str(m + j, lbl)
            call check_orthogonal_s(m, n, Qcheck, m+j, u, tol, 's (n>0, ldq=' // lbl // ')')
            call check_unit_norm_s(m, u, tol, 's (n>0, ldq=' // lbl // ')')
        end if
    end do

    deallocate(A, Q, R, u)

end subroutine stest

subroutine dtest(m, n)
    use iso_fortran_env
    integer, intent(in) :: m, n
    real(real64), allocatable :: A(:,:), Q(:,:), R(:,:), u(:), Qcheck(:,:)
    real(real64) :: dlamch, tol
    integer :: j
    character(len=40) :: lbl
    integer :: passed, failed
    common /stats/ passed, failed

    external :: dgqvec, drandg, dqrgen, dlamch
    real(real64) :: ddot, dnrm2

    allocate(A(m, m), Q(m, m), R(m, m), u(m), Qcheck(m+3, m))

    call drandg(m, n, A, m)
    call dqrgen(m, n, A, m, Q, m, R, m)

    call dgqvec(m, n, Q, m, u)
    tol = 5d2 * dlamch('p')
    call int2str(m, lbl)
    if (n == 0) then
        call check_unit_vector_d(m, u, tol, 'd (n=0, ldq=' // lbl // ')')
    else
        call check_orthogonal_d(m, n, Q, m, u, tol, 'd (n>0, ldq=' // lbl // ')')
        call check_unit_norm_d(m, u, tol, 'd (n>0, ldq=' // lbl // ')')
    end if

    ! Test with ldq > m
    do j = 1, 3
        call drandg(m, n, A, m)
        call dqrgen(m, n, A, m, Q, m, R, m)
        if (n == 0) then
            call dgqvec(m, n, Q, m+j, u)
            tol = 5d2 * dlamch('p')
            call int2str(m + j, lbl)
            call check_unit_vector_d(m, u, tol, 'd (n=0, ldq=' // lbl // ')')
        else
            call dgqvec_ldq(m, n, Q, m+j, u, Qcheck)
            tol = 5d2 * dlamch('p')
            call int2str(m + j, lbl)
            call check_orthogonal_d(m, n, Qcheck, m+j, u, tol, 'd (n>0, ldq=' // lbl // ')')
            call check_unit_norm_d(m, u, tol, 'd (n>0, ldq=' // lbl // ')')
        end if
    end do

    deallocate(A, Q, R, u)

end subroutine dtest

subroutine ctest(m, n)
    use iso_fortran_env
    use qrupdate_blas
    integer, intent(in) :: m, n
    complex(real32), allocatable :: A(:,:), Q(:,:), R(:,:), u(:), Qcheck(:,:)
    real(real32) :: slamch, tol
    integer :: j
    character(len=40) :: lbl
    integer :: passed, failed
    common /stats/ passed, failed

    external :: cgqvec, crandg, cqrgen

    allocate(A(m, m), Q(m, m), R(m, m), u(m), Qcheck(m+3, m))

    call crandg(m, n, A, m)
    call cqrgen(m, n, A, m, Q, m, R, m)

    call cgqvec(m, n, Q, m, u)
    tol = 5e2 * slamch('p')
    call int2str(m, lbl)
    if (n == 0) then
        call check_unit_vector_c(m, u, tol, 'c (n=0, ldq=' // lbl // ')')
    else
        call check_orthogonal_c(m, n, Q, m, u, tol, 'c (n>0, ldq=' // lbl // ')')
        call check_unit_norm_c(m, u, tol, 'c (n>0, ldq=' // lbl // ')')
    end if

    ! Test with ldq > m
    do j = 1, 3
        call crandg(m, n, A, m)
        call cqrgen(m, n, A, m, Q, m, R, m)
        if (n == 0) then
            call cgqvec(m, n, Q, m+j, u)
            tol = 5e2 * slamch('p')
            call int2str(m + j, lbl)
            call check_unit_vector_c(m, u, tol, 'c (n=0, ldq=' // lbl // ')')
        else
            call cgqvec_ldq(m, n, Q, m+j, u, Qcheck)
            tol = 5e2 * slamch('p')
            call int2str(m + j, lbl)
            call check_orthogonal_c(m, n, Qcheck, m+j, u, tol, 'c (n>0, ldq=' // lbl // ')')
            call check_unit_norm_c(m, u, tol, 'c (n>0, ldq=' // lbl // ')')
        end if
    end do

    deallocate(A, Q, R, u)

end subroutine ctest

subroutine ztest(m, n)
    use iso_fortran_env
    use qrupdate_blas
    integer, intent(in) :: m, n
    complex(real64), allocatable :: A(:,:), Q(:,:), R(:,:), u(:), Qcheck(:,:)
    real(real64) :: dlamch, tol
    integer :: j
    character(len=40) :: lbl
    integer :: passed, failed
    common /stats/ passed, failed

    external :: zgqvec, zrandg, zqrgen

    allocate(A(m, m), Q(m, m), R(m, m), u(m), Qcheck(m+3, m))

    call zrandg(m, n, A, m)
    call zqrgen(m, n, A, m, Q, m, R, m)

    call zgqvec(m, n, Q, m, u)
    tol = 5d2 * dlamch('p')
    call int2str(m, lbl)
    if (n == 0) then
        call check_unit_vector_z(m, u, tol, 'z (n=0, ldq=' // lbl // ')')
    else
        call check_orthogonal_z(m, n, Q, m, u, tol, 'z (n>0, ldq=' // lbl // ')')
        call check_unit_norm_z(m, u, tol, 'z (n>0, ldq=' // lbl // ')')
    end if

    ! Test with ldq > m
    do j = 1, 3
        call zrandg(m, n, A, m)
        call zqrgen(m, n, A, m, Q, m, R, m)
        if (n == 0) then
            call zgqvec(m, n, Q, m+j, u)
            tol = 5d2 * dlamch('p')
            call int2str(m + j, lbl)
            call check_unit_vector_z(m, u, tol, 'z (n=0, ldq=' // lbl // ')')
        else
            call zgqvec_ldq(m, n, Q, m+j, u, Qcheck)
            tol = 5d2 * dlamch('p')
            call int2str(m + j, lbl)
            call check_orthogonal_z(m, n, Qcheck, m+j, u, tol, 'z (n>0, ldq=' // lbl // ')')
            call check_unit_norm_z(m, u, tol, 'z (n>0, ldq=' // lbl // ')')
        end if
    end do

    deallocate(A, Q, R, u)

end subroutine ztest

! Helper: call gqvec with a padded Q buffer for ldq > m.
! Creates Qpad(ldq, n) with Q in the first m rows, calls gqvec, returns Qpad via Qout.
subroutine sgqvec_ldq(m, n, Q, ldq, u, Qout)
    use iso_fortran_env
    integer, intent(in) :: m, n, ldq
    real(real32), intent(in) :: Q(m, *)
    real(real32), intent(out) :: u(m)
    real(real32), intent(out) :: Qout(ldq, n)
    external sgqvec
    if (n == 0) then
        call sgqvec(m, n, Q, ldq, u)
        return
    end if
    Qout = 0e0
    Qout(1:m, 1:n) = Q(1:m, 1:n)
    call sgqvec(m, n, Qout, ldq, u)
end subroutine sgqvec_ldq

subroutine dgqvec_ldq(m, n, Q, ldq, u, Qout)
    use iso_fortran_env
    integer, intent(in) :: m, n, ldq
    real(real64), intent(in) :: Q(m, *)
    real(real64), intent(out) :: u(m)
    real(real64), intent(out) :: Qout(ldq, n)
    external dgqvec
    if (n == 0) then
        call dgqvec(m, n, Q, ldq, u)
        return
    end if
    Qout = 0d0
    Qout(1:m, 1:n) = Q(1:m, 1:n)
    call dgqvec(m, n, Qout, ldq, u)
end subroutine dgqvec_ldq

subroutine cgqvec_ldq(m, n, Q, ldq, u, Qout)
    use iso_fortran_env
    integer, intent(in) :: m, n, ldq
    complex(real32), intent(in) :: Q(m, *)
    complex(real32), intent(out) :: u(m)
    complex(real32), intent(out) :: Qout(ldq, n)
    external cgqvec
    if (n == 0) then
        call cgqvec(m, n, Q, ldq, u)
        return
    end if
    Qout = (0e0, 0e0)
    Qout(1:m, 1:n) = Q(1:m, 1:n)
    call cgqvec(m, n, Qout, ldq, u)
end subroutine cgqvec_ldq

subroutine zgqvec_ldq(m, n, Q, ldq, u, Qout)
    use iso_fortran_env
    integer, intent(in) :: m, n, ldq
    complex(real64), intent(in) :: Q(m, *)
    complex(real64), intent(out) :: u(m)
    complex(real64), intent(out) :: Qout(ldq, n)
    external zgqvec
    if (n == 0) then
        call zgqvec(m, n, Q, ldq, u)
        return
    end if
    Qout = (0d0, 0d0)
    Qout(1:m, 1:n) = Q(1:m, 1:n)
    call zgqvec(m, n, Qout, ldq, u)
end subroutine zgqvec_ldq

! Check that u is approximately the first canonical unit vector e_1
subroutine check_unit_vector_s(m, u, tol, label)
    use iso_fortran_env
    integer, intent(in) :: m
    real(real32), intent(in) :: u(m)
    real(real32), intent(in) :: tol
    character(*), intent(in) :: label
    real(real32) :: err
    integer :: passed, failed
    common /stats/ passed, failed
    external :: snrm2
    real(real32) :: snrm2
    character(6) :: result

    err = abs(u(1) - 1e0)
    if (err > tol) then
        result = 'FAIL'
        failed = failed + 1
    else
        result = 'PASS'
        passed = passed + 1
    end if
    write(*, 1001) trim(label), 'u(1)=1  :', err, result

    if (m > 1) then
        err = snrm2(m - 1, u(2), 1)
    else
        err = 0e0
    end if
    if (err > tol) then
        result = 'FAIL'
        failed = failed + 1
    else
        result = 'PASS'
        passed = passed + 1
    end if
    write(*, 1002) trim(label), 'u(2:m)=0:', err, result

    return
    1001 format('   ', A, 1x, A10, E12.4, 1x, A4)
    1002 format('   ', A, 1x, A10, E12.4, 1x, A4)
end subroutine check_unit_vector_s

subroutine check_unit_vector_d(m, u, tol, label)
    use iso_fortran_env
    integer, intent(in) :: m
    real(real64), intent(in) :: u(m)
    real(real64), intent(in) :: tol
    character(*), intent(in) :: label
    real(real64) :: err
    integer :: passed, failed
    common /stats/ passed, failed
    external :: dnrm2
    real(real64) :: dnrm2
    character(6) :: result

    err = abs(u(1) - 1d0)
    if (err > tol) then
        result = 'FAIL'
        failed = failed + 1
    else
        result = 'PASS'
        passed = passed + 1
    end if
    write(*, 1001) trim(label), 'u(1)=1  :', err, result

    if (m > 1) then
        err = dnrm2(m - 1, u(2), 1)
    else
        err = 0d0
    end if
    if (err > tol) then
        result = 'FAIL'
        failed = failed + 1
    else
        result = 'PASS'
        passed = passed + 1
    end if
    write(*, 1002) trim(label), 'u(2:m)=0:', err, result

    return
    1001 format('   ', A, 1x, A10, E12.4, 1x, A4)
    1002 format('   ', A, 1x, A10, E12.4, 1x, A4)
end subroutine check_unit_vector_d

subroutine check_unit_vector_c(m, u, tol, label)
    use iso_fortran_env
    use qrupdate_blas
    integer, intent(in) :: m
    complex(real32), intent(in) :: u(m)
    real(real32), intent(in) :: tol
    character(*), intent(in) :: label
    real(real32) :: err
    integer :: passed, failed
    common /stats/ passed, failed
    external :: scnrm2
    real(real32) :: scnrm2
    character(6) :: result

    err = abs(abs(u(1)) - 1e0)
    if (err > tol) then
        result = 'FAIL'
        failed = failed + 1
    else
        result = 'PASS'
        passed = passed + 1
    end if
    write(*, 1001) trim(label), '|u(1)|=1:', err, result

    if (m > 1) then
        err = scnrm2(m - 1, u(2), 1)
    else
        err = 0e0
    end if
    if (err > tol) then
        result = 'FAIL'
        failed = failed + 1
    else
        result = 'PASS'
        passed = passed + 1
    end if
    write(*, 1002) trim(label), 'u(2:m)=0:', err, result

    return
    1001 format('   ', A, 1x, A10, E12.4, 1x, A4)
    1002 format('   ', A, 1x, A10, E12.4, 1x, A4)
end subroutine check_unit_vector_c

subroutine check_unit_vector_z(m, u, tol, label)
    use iso_fortran_env
    use qrupdate_blas
    integer, intent(in) :: m
    complex(real64), intent(in) :: u(m)
    real(real64), intent(in) :: tol
    character(*), intent(in) :: label
    real(real64) :: err
    integer :: passed, failed
    common /stats/ passed, failed
    external :: dznrm2
    real(real64) :: dznrm2
    character(6) :: result

    err = abs(abs(u(1)) - 1d0)
    if (err > tol) then
        result = 'FAIL'
        failed = failed + 1
    else
        result = 'PASS'
        passed = passed + 1
    end if
    write(*, 1001) trim(label), '|u(1)|=1:', err, result

    if (m > 1) then
        err = dznrm2(m - 1, u(2), 1)
    else
        err = 0d0
    end if
    if (err > tol) then
        result = 'FAIL'
        failed = failed + 1
    else
        result = 'PASS'
        passed = passed + 1
    end if
    write(*, 1002) trim(label), 'u(2:m)=0:', err, result

    return
    1001 format('   ', A, 1x, A10, E12.4, 1x, A4)
    1002 format('   ', A, 1x, A10, E12.4, 1x, A4)
end subroutine check_unit_vector_z

subroutine check_orthogonal_s(m, n, Q, ldq, u, tol, label)
    use iso_fortran_env
    integer, intent(in) :: m, n, ldq
    real(real32), intent(in) :: Q(ldq, n), u(m)
    real(real32), intent(in) :: tol
    character(*), intent(in) :: label
    real(real32) :: prod, err
    integer :: passed, failed
    common /stats/ passed, failed
    external :: sdot
    real(real32) :: sdot
    integer :: i
    character(6) :: result

    err = 0e0
    do i = 1, n
        prod = sdot(m, Q(1, i), 1, u, 1)
        if (abs(prod) > err) err = abs(prod)
    end do
    if (err > tol) then
        result = 'FAIL'
        failed = failed + 1
    else
        result = 'PASS'
        passed = passed + 1
    end if
    write(*, 1001) trim(label), 'max|Q''u|:', err, result

    return
    1001 format('   ', A, 1x, A10, E12.4, 1x, A4)
end subroutine check_orthogonal_s

subroutine check_orthogonal_d(m, n, Q, ldq, u, tol, label)
    use iso_fortran_env
    integer, intent(in) :: m, n, ldq
    real(real64), intent(in) :: Q(ldq, n), u(m)
    real(real64), intent(in) :: tol
    character(*), intent(in) :: label
    real(real64) :: prod, err
    integer :: passed, failed
    common /stats/ passed, failed
    external :: ddot
    real(real64) :: ddot
    integer :: i
    character(6) :: result

    err = 0d0
    do i = 1, n
        prod = ddot(m, Q(1, i), 1, u, 1)
        if (abs(prod) > err) err = abs(prod)
    end do
    if (err > tol) then
        result = 'FAIL'
        failed = failed + 1
    else
        result = 'PASS'
        passed = passed + 1
    end if
    write(*, 1001) trim(label), 'max|Q''u|:', err, result

    return
    1001 format('   ', A, 1x, A10, E12.4, 1x, A4)
end subroutine check_orthogonal_d

subroutine check_orthogonal_c(m, n, Q, ldq, u, tol, label)
    use iso_fortran_env
    use qrupdate_blas
    integer, intent(in) :: m, n, ldq
    complex(real32), intent(in) :: Q(ldq, n), u(m)
    real(real32), intent(in) :: tol
    character(*), intent(in) :: label
    real(real32) :: err, rr
    complex(real32) :: rc
    integer :: i
    integer :: passed, failed
    common /stats/ passed, failed
    character(6) :: result

    err = 0e0
    do i = 1, n
        call qrupdate_cdotc(rc, m, Q(1, i), 1, u, 1)
        rr = sqrt(real(rc, real32)**2 + aimag(rc)**2)
        if (rr > err) err = rr
    end do
    if (err > tol) then
        result = 'FAIL'
        failed = failed + 1
    else
        result = 'PASS'
        passed = passed + 1
    end if
    write(*, 1001) trim(label), 'max|Q''u|:', err, result

    return
    1001 format('   ', A, 1x, A10, E12.4, 1x, A4)
end subroutine check_orthogonal_c

subroutine check_orthogonal_z(m, n, Q, ldq, u, tol, label)
    use iso_fortran_env
    use qrupdate_blas
    integer, intent(in) :: m, n, ldq
    complex(real64), intent(in) :: Q(ldq, n), u(m)
    real(real64), intent(in) :: tol
    character(*), intent(in) :: label
    real(real64) :: err, rr
    complex(real64) :: rc
    integer :: i
    integer :: passed, failed
    common /stats/ passed, failed
    character(6) :: result

    err = 0d0
    do i = 1, n
        call qrupdate_zdotc(rc, m, Q(1, i), 1, u, 1)
        rr = dsqrt(real(rc, real64)**2 + aimag(rc)**2)
        if (rr > err) err = rr
    end do
    if (err > tol) then
        result = 'FAIL'
        failed = failed + 1
    else
        result = 'PASS'
        passed = passed + 1
    end if
    write(*, 1001) trim(label), 'max|Q''u|:', err, result

    return
    1001 format('   ', A, 1x, A10, E12.4, 1x, A4)
end subroutine check_orthogonal_z

subroutine check_unit_norm_s(m, u, tol, label)
    use iso_fortran_env
    integer, intent(in) :: m
    real(real32), intent(in) :: u(m)
    real(real32), intent(in) :: tol
    character(*), intent(in) :: label
    real(real32) :: unrm, err
    integer :: passed, failed
    common /stats/ passed, failed
    external :: snrm2
    real(real32) :: snrm2
    character(6) :: result

    unrm = snrm2(m, u, 1)
    err = abs(unrm - 1e0)
    if (err > tol) then
        result = 'FAIL'
        failed = failed + 1
    else
        result = 'PASS'
        passed = passed + 1
    end if
    write(*, 1001) trim(label), 'norm(u) :', unrm, result

    return
    1001 format('   ', A, 1x, A10, E12.4, 1x, A4)
end subroutine check_unit_norm_s

subroutine check_unit_norm_d(m, u, tol, label)
    use iso_fortran_env
    integer, intent(in) :: m
    real(real64), intent(in) :: u(m)
    real(real64), intent(in) :: tol
    character(*), intent(in) :: label
    real(real64) :: unrm, err
    integer :: passed, failed
    common /stats/ passed, failed
    external :: dnrm2
    real(real64) :: dnrm2
    character(6) :: result

    unrm = dnrm2(m, u, 1)
    err = abs(unrm - 1d0)
    if (err > tol) then
        result = 'FAIL'
        failed = failed + 1
    else
        result = 'PASS'
        passed = passed + 1
    end if
    write(*, 1001) trim(label), 'norm(u) :', unrm, result

    return
    1001 format('   ', A, 1x, A10, E12.4, 1x, A4)
end subroutine check_unit_norm_d

subroutine check_unit_norm_c(m, u, tol, label)
    use iso_fortran_env
    use qrupdate_blas
    integer, intent(in) :: m
    complex(real32), intent(in) :: u(m)
    real(real32), intent(in) :: tol
    character(*), intent(in) :: label
    real(real32) :: unrm, err
    integer :: passed, failed
    common /stats/ passed, failed
    external :: scnrm2
    real(real32) :: scnrm2
    character(6) :: result

    unrm = scnrm2(m, u, 1)
    err = abs(unrm - 1e0)
    if (err > tol) then
        result = 'FAIL'
        failed = failed + 1
    else
        result = 'PASS'
        passed = passed + 1
    end if
    write(*, 1001) trim(label), 'norm(u) :', unrm, result

    return
    1001 format('   ', A, 1x, A10, E12.4, 1x, A4)
end subroutine check_unit_norm_c

subroutine check_unit_norm_z(m, u, tol, label)
    use iso_fortran_env
    use qrupdate_blas
    integer, intent(in) :: m
    complex(real64), intent(in) :: u(m)
    real(real64), intent(in) :: tol
    character(*), intent(in) :: label
    real(real64) :: unrm, err
    integer :: passed, failed
    common /stats/ passed, failed
    external :: dznrm2
    real(real64) :: dznrm2
    character(6) :: result

    unrm = dznrm2(m, u, 1)
    err = abs(unrm - 1d0)
    if (err > tol) then
        result = 'FAIL'
        failed = failed + 1
    else
        result = 'PASS'
        passed = passed + 1
    end if
    write(*, 1001) trim(label), 'norm(u) :', unrm, result

    return
    1001 format('   ', A, 1x, A10, E12.4, 1x, A4)
end subroutine check_unit_norm_z

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
subroutine srandg(m,n,x,ldx)
    use iso_fortran_env
    integer m,n,ldx
    real(real32) x(ldx,*)
    external slaruv
    integer seed(4),j,k
    common /xrand/ seed
    do j = 1,n
        do k = 1,m,128
            call slaruv(seed,min(m-k+1,128),x(k,j))
        end do
    end do
    do j = 1,n
        do k = 1,m
            if (.not. (x(k,j) > 0e0 .and. x(k,j) < 1e0)) then
                stop 'slaruv produced invalid number'
            end if
        end do
    end do
end subroutine

subroutine drandg(m,n,x,ldx)
    use iso_fortran_env
    integer m,n,ldx
    real(real64) x(ldx,*)
    external dlaruv
    integer seed(4),j,k
    common /xrand/ seed
    do j = 1,n
        do k = 1,m,128
            call dlaruv(seed,min(m-k+1,128),x(k,j))
        end do
    end do
    do j = 1,n
        do k = 1,m
            if (.not. (x(k,j) > 0d0 .and. x(k,j) < 1d0)) then
                stop 'dlaruv produced invalid number'
            end if
        end do
    end do
end subroutine

subroutine crandg(m,n,x,ldx)
    use iso_fortran_env
    integer m,n,ldx
    integer k,l
    complex(real32) x(ldx,*)
    external srandg
    real(real32), allocatable :: xr(:,:)
    allocate(xr(2*ldx,n))
    call srandg(2*m,n,xr,2*ldx)
    do l = 1, n
        do k = 1, m
            x(k,l) = cmplx(xr(2*k-1,l), xr(2*k,l))
        end do
    end do
    deallocate(xr)
end subroutine

subroutine zrandg(m,n,x,ldx)
    use iso_fortran_env
    integer m,n,ldx
    complex(real64) x(ldx,*)
    external drandg
    integer l,k
    real(real64), allocatable :: xr(:,:)
    allocate(xr(2*ldx,n))
    call drandg(2*m,n,xr,2*ldx)
    do l = 1, n
        do k = 1, m
            x(k,l) = cmplx(xr(2*k-1,l), xr(2*k,l), kind = 8)
        end do
    end do
    deallocate(xr)
end subroutine

block data xrandi
    integer seed(4)
    common /xrand/ seed
    data seed /4*1/
end block data

subroutine sqrgen(m,n,A,lda,Q,ldq,R,ldr)
    use iso_fortran_env
    integer m,n,lda,ldq,ldr
    real(real32) A(lda,n),Q(ldq,m),R(ldr,n)
    real(real32) work(max(m,n)),tau(min(m,n))
    integer info,i,j
    external slacpy,sgeqrf,sorgqr
    if (m == 0) return
    call slacpy('0',m,n,A,lda,R,ldr)
    call sgeqrf(m,n,R,ldr,tau,work,max(m,n),info)
    do i = 1,n
        do j = i+1,m
            Q(j,i) = R(j,i)
            R(j,i) = 0e0
        end do
    end do
    call sorgqr(m,m,min(m,n),Q,ldq,tau,work,max(m,n),info)
end subroutine

subroutine dqrgen(m,n,A,lda,Q,ldq,R,ldr)
    use iso_fortran_env
    integer m,n,lda,ldq,ldr
    real(real64) A(lda,n),Q(ldq,m),R(ldr,n)
    real(real64) work(max(m,n)),tau(min(m,n))
    integer info,i,j
    external dlacpy,dgeqrf,dorgqr
    if (m == 0) return
    call dlacpy('0',m,n,A,lda,R,ldr)
    call dgeqrf(m,n,R,ldr,tau,work,max(m,n),info)
    do i = 1,n
        do j = i+1,m
            Q(j,i) = R(j,i)
            R(j,i) = 0d0
        end do
    end do
    call dorgqr(m,m,min(m,n),Q,ldq,tau,work,max(m,n),info)
end subroutine

subroutine cqrgen(m,n,A,lda,Q,ldq,R,ldr)
    use iso_fortran_env
    integer m,n,lda,ldq,ldr
    complex(real32) A(lda,n),Q(ldq,m),R(ldr,n)
    complex(real32) work(max(m,n)),tau(min(m,n))
    integer info,i,j
    external clacpy,cgeqrf,cungqr
    if (m == 0) return
    call clacpy('0',m,n,A,lda,R,ldr)
    call cgeqrf(m,n,R,ldr,tau,work,max(m,n),info)
    do i = 1,n
        do j = i+1,m
            Q(j,i) = R(j,i)
            R(j,i) = 0e0
        end do
    end do
    call cungqr(m,m,min(m,n),Q,ldq,tau,work,max(m,n),info)
end subroutine

subroutine zqrgen(m,n,A,lda,Q,ldq,R,ldr)
    use iso_fortran_env
    integer m,n,lda,ldq,ldr
    complex(real64) A(lda,n),Q(ldq,m),R(ldr,n)
    complex(real64) work(max(m,n)),tau(min(m,n))
    integer info,i,j
    external zlacpy,zgeqrf,zungqr
    if (m == 0) return
    call zlacpy('0',m,n,A,lda,R,ldr)
    call zgeqrf(m,n,R,ldr,tau,work,max(m,n),info)
    do i = 1,n
        do j = i+1,m
            Q(j,i) = R(j,i)
            R(j,i) = 0d0
        end do
    end do
    call zungqr(m,m,min(m,n),Q,ldq,tau,work,max(m,n),info)
end subroutine

subroutine smdump(name,m,n,A,lda)
    use iso_fortran_env
    character(*) name
    integer m,n,lda
    real(real32) A(lda,n)
    integer i,j
    write (*,1001) name
    do i = 1,m
        do j = 1,n
            write(*,1002) A(i,j)
        end do
        write(*,*)
    end do

    1001 format (A,' = ')
    1002 format (1x,F6.3,$)
end subroutine

subroutine dmdump(name,m,n,A,lda)
    use iso_fortran_env
    character(*) name
    integer m,n,lda
    real(real64) A(lda,n)
    integer i,j
    write (*,1001) name
    do i = 1,m
        do j = 1,n
            write(*,1002) A(i,j)
        end do
        write(*,*)
    end do

    1001 format (A,' = ')
    1002 format (1x,F6.3,$)
end subroutine

subroutine cmdump(name,m,n,A,lda)
    use iso_fortran_env
    character(*) name
    integer m,n,lda
    complex(real32) A(lda,n)
    integer i,j
    write (*,1001) name
    do i = 1,m
        do j = 1,n
            write(*,1002) A(i,j)
        end do
        write(*,*)
    end do

    1001 format (A,' = ')
    1002 format (1x,F6.3,SP,F6.3,'i',$)
end subroutine

subroutine zmdump(name,m,n,A,lda)
    use iso_fortran_env
    character(*) name
    integer m,n,lda
    complex(real64) A(lda,n)
    integer i,j
    write (*,1001) name
    do i = 1,m
        do j = 1,n
            write(*,1002) A(i,j)
        end do
        write(*,*)
    end do

    1001 format (A,' = ')
    1002 format (1x,F6.3,SP,F6.3,'i',$)
end subroutine

character*4 function spftol(rnrm)
    use iso_fortran_env
    real(real32) rnrm,slamch
    external slamch
    common /stats/ passed,failed
    integer passed,failed
    if (rnrm < 5e2*slamch('p')) then
        spftol = 'PASS'
        passed = passed + 1
    else
        spftol = 'FAIL'
        failed = failed + 1
    end if
end function

character*4 function dpftol(rnrm)
    use iso_fortran_env
    real(real64) rnrm,dlamch
    external dlamch
    common /stats/ passed,failed
    integer passed,failed
    if (rnrm < 5d2*dlamch('p')) then
        dpftol = 'PASS'
        passed = passed + 1
    else
        dpftol = 'FAIL'
        failed = failed + 1
    end if
end function

subroutine pstats
    common /stats/ passed,failed
    integer passed,failed

    write(*,1001)
    write(*,1002) passed,failed
    write(*,*)
    if (failed .ne. 0) then
        stop 1
    end if
    1001 format(70('-'))
    1002 format(1x,'total:',5x,'PASSED',1x,I3,5x,'FAILED',1x,I3)
end subroutine

subroutine sqrchk(m,n,k,A,lda,Q,ldq,R,ldr)
    use iso_fortran_env
    integer m,n,k,lda,ldq,ldr
    real(real32) A(lda,max(n,k)),Q(ldq,k),R(ldr,n)
    real(real32) rnrm,slange,slansy
    external sgemm,ssyrk,slange,slansy,spftol
    character*4 spftol
    real(real32) wrk(m)
    integer i

    ! get residual
    call sgemm('N','N',m,n,k,-1e0,Q,ldq,R,ldr,1e0,A,lda)
    ! get frobenius norm
    rnrm = slange('M',m,n,A,lda,wrk)
    write(*,1001) rnrm,spftol(rnrm)
    ! form Q'*Q - I
    call ssyrk('U','T',k,m,1e0,Q,ldq,0e0,A,lda)
    do i = 1,k
        A(i,i) = A(i,i) - 1e0
    end do
    ! get frobenius norm
    rnrm = slansy('M','U',k,A,lda,wrk)
    write(*,1002) rnrm,spftol(rnrm)
    return

    1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
    1002 format('orth. residual error = ',10x,E21.12,5x,A6)
end subroutine

subroutine dqrchk(m,n,k,A,lda,Q,ldq,R,ldr)
    use iso_fortran_env
    integer m,n,k,lda,ldq,ldr
    real(real64) A(lda,max(n,k)),Q(ldq,k),R(ldr,n)
    real(real64) rnrm,dlange,dlansy
    external dgemm,dsyrk,dlange,dlansy,dpftol
    character*4 dpftol
    real(real64) wrk(m)
    integer i

    ! get residual
    call dgemm('N','N',m,n,k,-1d0,Q,ldq,R,ldr,1d0,A,lda)
    ! get frobenius norm
    rnrm = dlange('M',m,n,A,lda,wrk)
    write(*,1001) rnrm,dpftol(rnrm)
    ! form Q'*Q - I
    call dsyrk('U','T',k,m,1d0,Q,ldq,0d0,A,lda)
    do i = 1,k
        A(i,i) = A(i,i) - 1d0
    end do
    ! get frobenius norm
    rnrm = dlansy('M','U',k,A,lda,wrk)
    write(*,1002) rnrm,dpftol(rnrm)
    return

    1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
    1002 format('orth. residual error = ',10x,E21.12,5x,A6)
end subroutine

subroutine cqrchk(m,n,k,A,lda,Q,ldq,R,ldr)
    use iso_fortran_env
    integer m,n,k,lda,ldq,ldr
    complex(real32) A(lda,max(n,k)),Q(ldq,k),R(ldr,n)
    real(real32) rnrm,clange,clanhe
    external cgemm,cherk,clange,clanhe,spftol
    character*4 spftol
    real(real32) wrk(m)
    integer i

    ! get residual
    call cgemm('N','N',m,n,k,-(1e0,0e0),Q,ldq,R,ldr,(1e0,0e0),A,lda)
    ! get frobenius norm
    rnrm = clange('M',m,n,A,lda,wrk)
    write(*,1001) rnrm,spftol(rnrm)
    ! form Q'*Q - I
    call cherk('U','C',k,m,1e0,Q,ldq,0e0,A,lda)
    do i = 1,k
        A(i,i) = A(i,i) - 1e0
    end do
    ! get frobenius norm
    rnrm = clanhe('M','U',k,A,lda,wrk)
    write(*,1002) rnrm,spftol(rnrm)
    return

    1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
    1002 format('orth. residual error = ',10x,E21.12,5x,A6)
end subroutine

subroutine zqrchk(m,n,k,A,lda,Q,ldq,R,ldr)
    use iso_fortran_env
    integer m,n,k,lda,ldq,ldr
    complex(real64) A(lda,max(n,k)),Q(ldq,k),R(ldr,n)
    real(real64) rnrm,zlange,zlanhe
    external zgemm,zherk,zlange,zlanhe,dpftol
    character*4 dpftol
    real(real64) wrk(m)
    integer i

    ! get residual
    call zgemm('N','N',m,n,k,-(1d0,0d0),Q,ldq,R,ldr,(1d0,0d0),A,lda)
    ! get frobenius norm
    rnrm = zlange('M',m,n,A,lda,wrk)
    write(*,1001) rnrm,dpftol(rnrm)
    ! form Q'*Q - I
    call zherk('U','C',k,m,1d0,Q,ldq,0d0,A,lda)
    do i = 1,k
        A(i,i) = A(i,i) - 1d0
    end do
    ! get frobenius norm
    rnrm = zlanhe('M','U',k,A,lda,wrk)
    write(*,1002) rnrm,dpftol(rnrm)
    return

    1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
    1002 format('orth. residual error = ',10x,E21.12,5x,A6)
end subroutine

subroutine schgen(n,A,lda,R,ldr)
    use iso_fortran_env
    integer n,lda,ldr
    real(real32) A(lda,n),R(ldr,n)
    external ssyrk,slacpy,spotrf
    integer i,j,info
    call ssyrk('U','T',n,n,1e0,A,lda,0e0,R,ldr)
    ! augment to ensure strict positivity, zero below diag
    do i = 1,n
        R(i,i) = R(i,i) + 1e-3
        ! zero below diagonal
        do j = i+1,n
            R(j,i) = 0e0
        end do
    end do
    call slacpy('U',n,n,R,ldr,A,lda)
    ! symmetrize A
    do i = 1,n-1
        do j = i+1,n
            A(j,i) = A(i,j)
        end do
    end do
    call spotrf('U',n,R,ldr,info)
    if (info /= 0) stop 'fatal:error generating positive matrix'
end subroutine

subroutine dchgen(n,A,lda,R,ldr)
    use iso_fortran_env
    integer n,lda,ldr
    real(real64) A(lda,n),R(ldr,n)
    external dsyrk,dlacpy,dpotrf
    integer i,j,info
    call dsyrk('U','T',n,n,1d0,A,lda,0d0,R,ldr)
    ! augment to ensure strict positivity
    do i = 1,n
        R(i,i) = R(i,i) + 1d-3
        ! zero below diagonal
        do j = i+1,n
            R(j,i) = 0d0
        end do
    end do
    call dlacpy('U',n,n,R,ldr,A,lda)
    ! symmetrize A
    do i = 1,n-1
        do j = i+1,n
            A(j,i) = A(i,j)
        end do
    end do
    call dpotrf('U',n,R,ldr,info)
    if (info /= 0) stop 'fatal:error generating positive matrix'
end subroutine

subroutine cchgen(n,A,lda,R,ldr)
    use iso_fortran_env
    use qrupdate_blas
    integer n,lda,ldr
    complex(real32) A(lda,n),R(ldr,n)
    external cherk,clacpy,cpotrf
    complex(real32) Rii
    integer i,j,info
    call cherk('U','C',n,n,1e0,A,lda,0e0,R,ldr)
    ! augment to ensure strict positivity
    do i = 1,n
        ! CHERK is often buggy. We'll recompute the diagonal elements and
        ! possibly warn about the bug.
        call qrupdate_cdotc (Rii, n, A(1,i), 1, A(1,i), 1)
        if (.not. abs (Rii - R(i,i)) < 1e-5 * abs(Rii)) then
            write (*,1001)
            write (*,1002) R(i,i), Rii
        endif
        !        R(i,i) = Rii + 1e-3
        R(i,i) = cmplx(real(Rii)+1e-3,0.0)
        ! zero below diagonal
        do j = i+1,n
            R(j,i) = 0e0
        end do
    end do
    call clacpy('U',n,n,R,ldr,A,lda)
    ! symmetrize A
    do i = 1,n-1
        do j = i+1,n
            A(j,i) = conjg(A(i,j))
        end do
    end do
    call cpotrf('U',n,R,ldr,info)
    if (info /= 0) stop 'fatal:error generating positive matrix'
    1001 format ('WARNING: Possible bug in BLAS CHERK:')
    1002 format ('WARNING: CHERK computed diagonal element (',             &
        &F6.3,F6.3,'), direct computation gives (',F6.3,F6.3,').')
end subroutine

subroutine zchgen(n,A,lda,R,ldr)
    use iso_fortran_env
    use qrupdate_blas
    integer n,lda,ldr
    complex(real64) A(lda,n),R(ldr,n)
    external zherk,zlacpy,zpotrf
    complex(real64) Rii
    integer i,j,info
    call zherk('U','C',n,n,1d0,A,lda,0d0,R,ldr)
    ! augment to ensure strict positivity
    do i = 1,n
        ! ZHERK is often buggy. We'll recompute the diagonal elements and
        ! possibly warn about the bug.
        call qrupdate_zdotc (Rii, n, A(1,i), 1, A(1,i), 1)
        if (.not. abs (Rii - R(i,i)) < 1d-10 * abs(Rii)) then
            write (*,1001)
            write (*,1002) R(i,i), Rii
        endif
        !        R(i,i) = Rii + 1d-3
        R(i,i) = dcmplx(real(Rii)+1D-3,0.0D0)

        ! zero below diagonal
        do j = i+1,n
            R(j,i) = 0d0
        end do
    end do
    call zlacpy('U',n,n,R,ldr,A,lda)
    ! symmetrize A
    do i = 1,n-1
        do j = i+1,n
            A(j,i) = conjg(A(i,j))
        end do
    end do
    call zpotrf('U',n,R,ldr,info)
    if (info /= 0) stop 'fatal:error generating positive matrix'
    1001 format ('WARNING: Possible bug in BLAS CHERK:')
    1002 format ('WARNING: ZHERK computed diagonal element (',             &
        &F6.3,F6.3,'), direct computation gives (',F6.3,F6.3,').')
end subroutine

subroutine schchk(n,A,lda,R,ldr)
    use iso_fortran_env
    integer n,lda,ldr
    real(real32) A(lda,n),R(ldr,n)
    real(real32) rnrm,slansy
    external ssyrk,slansy,spftol
    character*4 spftol
    real wrk(n)
    integer i,j

    ! zero lower triangle of R
    do j = 1,n-1
        do i = j+1,n
            R(i,j) = 0e0
        end do
    end do
    ! form A - R'*R
    call ssyrk('U','T',n,n,1e0,R,ldr,-1e0,A,lda)
    ! get frobenius norm
    rnrm = slansy('M','U',n,A,lda,wrk)
    write(*,1001) rnrm,spftol(rnrm)
    return

    1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
end subroutine

subroutine dchchk(n,A,lda,R,ldr)
    use iso_fortran_env
    integer n,lda,ldr
    real(real64) A(lda,n),R(ldr,n)
    real(real64) rnrm,dlansy
    external dsyrk,dlansy,dpftol
    character*4 dpftol
    double precision wrk(n)
    integer i,j

    ! zero lower triangle of R
    do j = 1,n-1
        do i = j+1,n
            R(i,j) = 0d0
        end do
    end do
    ! form A - R'*R
    call dsyrk('U','T',n,n,1d0,R,ldr,-1d0,A,lda)
    ! get frobenius norm
    rnrm = dlansy('M','U',n,A,lda,wrk)
    write(*,1001) rnrm,dpftol(rnrm)
    return

    1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
end subroutine

subroutine cchchk(n,A,lda,R,ldr)
    use iso_fortran_env
    integer n,lda,ldr
    complex(real32) A(lda,n),R(ldr,n)
    real(real32) rnrm,clanhe
    external cherk,clanhe,spftol
    character*4 spftol
    real wrk(n)
    integer i,j

    ! zero lower triangle of R
    do j = 1,n-1
        do i = j+1,n
            R(i,j) = 0e0
        end do
    end do
    ! form A - R'*R
    call cherk('U','C',n,n,1e0,R,ldr,-1e0,A,lda)
    ! get frobenius norm
    rnrm = clanhe('M','U',n,A,lda,wrk)
    write(*,1001) rnrm,spftol(rnrm)
    return

    1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
end subroutine

subroutine zchchk(n,A,lda,R,ldr)
    use iso_fortran_env
    integer n,lda,ldr
    complex(real64) A(lda,n),R(ldr,n)
    real(real64) rnrm,zlanhe
    external zherk,zlanhe,dpftol
    character*4 dpftol
    double precision wrk(n)
    integer i,j

    ! zero lower triangle of R
    do j = 1,n-1
        do i = j+1,n
            R(i,j) = 0d0
        end do
    end do
    ! form A - R'*R
    call zherk('U','C',n,n,1d0,R,ldr,-1d0,A,lda)
    ! get frobenius norm
    rnrm = zlanhe('M','U',n,A,lda,wrk)
    write(*,1001) rnrm,dpftol(rnrm)
    return

    1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
end subroutine

subroutine slugen(m,n,A,lda,L,ldl,R,ldr)
    use iso_fortran_env
    integer m,n,lda,ldl,ldr
    real(real32) A(lda,n),L(ldl,min(m,n)),R(ldr,n)
    integer ipiv(min(m,n)),info,i,j
    external sswap,slacpy,sgetrf
    if (m >= n) then
        call slacpy('0',m,n,A,lda,L,ldl)
        call sgetrf(m,n,L,ldl,ipiv,info)
        call slacpy('U',m,n,L,ldl,R,ldr)
    else
        call slacpy('0',m,n,A,lda,R,ldr)
        call sgetrf(m,n,R,ldr,ipiv,info)
        call slacpy('L',m,n,R,ldr,L,ldl)
    end if
    do i = 1,min(m,n)
        do j = 1,i-1
            L(j,i) = 0e0
        end do
        L(i,i) = 1e0
    end do
    ! permute the orig matrix
    do i = 1,min(m,n)
        j = ipiv(i)
        if (i /= j) then
            call sswap(n,A(i,1),lda,A(j,1),lda)
        end if
    end do
end subroutine

subroutine dlugen(m,n,A,lda,L,ldl,R,ldr)
    use iso_fortran_env
    integer m,n,lda,ldl,ldr
    real(real64) A(lda,n),L(ldl,min(m,n)),R(ldr,n)
    integer ipiv(min(m,n)),info,i,j
    external dswap,dlacpy,dgetrf
    if (m >= n) then
        call dlacpy('0',m,n,A,lda,L,ldl)
        call dgetrf(m,n,L,ldl,ipiv,info)
        call dlacpy('U',m,n,L,ldl,R,ldr)
    else
        call dlacpy('0',m,n,A,lda,R,ldr)
        call dgetrf(m,n,R,ldr,ipiv,info)
        call dlacpy('L',m,n,R,ldr,L,ldl)
    end if
    do i = 1,min(m,n)
        do j = 1,i-1
            L(j,i) = 0d0
        end do
        L(i,i) = 1d0
    end do
    ! permute the orig matrix
    do i = 1,min(m,n)
        j = ipiv(i)
        if (i /= j) then
            call dswap(n,A(i,1),lda,A(j,1),lda)
        end if
    end do
end subroutine

subroutine clugen(m,n,A,lda,L,ldl,R,ldr)
    use iso_fortran_env
    integer m,n,lda,ldl,ldr
    complex(real32) A(lda,n),L(ldl,min(m,n)),R(ldr,n)
    integer ipiv(min(m,n)),info,i,j
    external cswap,clacpy,cgetrf
    if (m >= n) then
        call clacpy('0',m,n,A,lda,L,ldl)
        call cgetrf(m,n,L,ldl,ipiv,info)
        call clacpy('U',m,n,L,ldl,R,ldr)
    else
        call clacpy('0',m,n,A,lda,R,ldr)
        call cgetrf(m,n,R,ldr,ipiv,info)
        call clacpy('L',m,n,R,ldr,L,ldl)
    end if
    do i = 1,min(m,n)
        do j = 1,i-1
            L(j,i) = cmplx(0.0,0.0)
        end do
        L(i,i) = cmplx(1.0,0.0)
    end do
    ! permute the orig matrix
    do i = 1,min(m,n)
        j = ipiv(i)
        if (i /= j) then
            call cswap(n,A(i,1),lda,A(j,1),lda)
        end if
    end do
end subroutine

subroutine zlugen(m,n,A,lda,L,ldl,R,ldr)
    use iso_fortran_env
    integer m,n,lda,ldl,ldr
    complex(real64) A(lda,n),L(ldl,min(m,n)),R(ldr,n)
    integer ipiv(min(m,n)),info,i,j
    external zswap,zlacpy,zgetrf
    if (m >= n) then
        call zlacpy('0',m,n,A,lda,L,ldl)
        call zgetrf(m,n,L,ldl,ipiv,info)
        call zlacpy('U',m,n,L,ldl,R,ldr)
    else
        call zlacpy('0',m,n,A,lda,R,ldr)
        call zgetrf(m,n,R,ldr,ipiv,info)
        call zlacpy('L',m,n,R,ldr,L,ldl)
    end if
    do i = 1,min(m,n)
        do j = 1,i-1
            L(j,i) = 0d0
        end do
        L(i,i) = 1d0
    end do
    ! permute the orig matrix
    do i = 1,min(m,n)
        j = ipiv(i)
        if (i /= j) then
            call zswap(n,A(i,1),lda,A(j,1),lda)
        end if
    end do
end subroutine

subroutine sluchk(m,n,A,lda,L,ldl,R,ldr)
    integer m,n,lda,ldl,ldr
    real A(lda,n),L(ldl,min(m,n)),R(ldr,n)
    real rnrm,slange
    external sgemm,slange,spftol
    character*4 spftol
    real wrk(1)
    integer i,j

    ! zero lower triangle of R
    do j = 1,n-1
        do i = j+1,min(m,n)
            R(i,j) = 0e0
        end do
    end do
    ! form A - L*R
    call sgemm('N','N',m,n,min(m,n),1e0,L,ldl,R,ldr,-1e0,A,lda)
    ! get frobenius norm
    rnrm = slange('M',m,n,A,lda,wrk)
    write(*,1001) rnrm,spftol(rnrm)
    return

    1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
end subroutine

subroutine dluchk(m,n,A,lda,L,ldl,R,ldr)
    integer m,n,lda,ldl,ldr
    double precision A(lda,n),L(ldl,min(m,n)),R(ldr,n)
    double precision rnrm,dlange
    external dgemm,dlange,dpftol
    character*4 dpftol
    double precision wrk(1)
    integer i,j

    ! zero lower triangle of R
    do j = 1,n-1
        do i = j+1,min(m,n)
            R(i,j) = 0e0
        end do
    end do
    ! form A - L*R
    call dgemm('N','N',m,n,min(m,n),1d0,L,ldl,R,ldr,-1d0,A,lda)
    ! get frobenius norm
    rnrm = dlange('M',m,n,A,lda,wrk)
    write(*,1001) rnrm,dpftol(rnrm)
    return

    1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
end subroutine

subroutine cluchk(m,n,A,lda,L,ldl,R,ldr)
    integer m,n,lda,ldl,ldr
    complex A(lda,n),L(ldl,min(m,n)),R(ldr,n)
    real rnrm,clange
    external cgemm,clange,spftol
    character*4 spftol
    real wrk(1)
    integer i,j

    ! zero lower triangle of R
    do j = 1,n-1
        do i = j+1,min(m,n)
            R(i,j) = 0e0
        end do
    end do
    ! form A - L*R
    call cgemm('N','N',m,n,min(m,n),(1e0,0e0),L,ldl,R,ldr,(-1e0,0e0), &
        &A,lda)
    ! get frobenius norm
    rnrm = clange('M',m,n,A,lda,wrk)
    write(*,1001) rnrm,spftol(rnrm)
    return

    1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
end subroutine

subroutine zluchk(m,n,A,lda,L,ldl,R,ldr)
    integer m,n,lda,ldl,ldr
    double complex A(lda,n),L(ldl,min(m,n)),R(ldr,n)
    double precision rnrm,zlange
    external zgemm,zlange,dpftol
    character*4 dpftol
    double precision wrk(1)
    integer i,j

    ! zero lower triangle of R
    do j = 1,n-1
        do i = j+1,min(m,n)
            R(i,j) = 0e0
        end do
    end do
    ! form A - L*R
    call zgemm('N','N',m,n,min(m,n),(1d0,0d0),L,ldl,R,ldr,(-1d0,0d0), &
        &A,lda)
    ! get frobenius norm
    rnrm = zlange('M',m,n,A,lda,wrk)
    write(*,1001) rnrm,dpftol(rnrm)
    return

    1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
end subroutine

subroutine slupgen(m,n,A,lda,L,ldl,R,ldr,p)
    integer m,n,lda,ldl,ldr,p(m)
    real A(lda,n),L(ldl,min(m,n)),R(ldr,n)
    integer ipiv(min(m,n)),info,i,j,tmp
    external sswap,slacpy,sgetrf
    if (m >= n) then
        call slacpy('0',m,n,A,lda,L,ldl)
        call sgetrf(m,n,L,ldl,ipiv,info)
        call slacpy('U',m,n,L,ldl,R,ldr)
    else
        call slacpy('0',m,n,A,lda,R,ldr)
        call sgetrf(m,n,R,ldr,ipiv,info)
        call slacpy('L',m,n,R,ldr,L,ldl)
    end if
    do i = 1,min(m,n)
        do j = 1,i-1
            L(j,i) = 0e0
        end do
        L(i,i) = 1e0
    end do
    ! generate permutation
    do i = 1,m
        p(i) = i
    end do
    do i = 1,min(m,n)
        j = ipiv(i)
        if (i /= j) then
            tmp = p(i)
            p(i) = p(j)
            p(j) = tmp
        end if
    end do
    ! zero lower triangle of R
    do j = 1,n-1
        do i = j+1,min(m,n)
            R(i,j) = 0e0
        end do
    end do
end subroutine

subroutine dlupgen(m,n,A,lda,L,ldl,R,ldr,p)
    integer m,n,lda,ldl,ldr,p(m)
    double precision A(lda,n),L(ldl,min(m,n)),R(ldr,n)
    integer ipiv(min(m,n)),info,i,j,tmp
    external dswap,dlacpy,dgetrf
    if (m >= n) then
        call dlacpy('0',m,n,A,lda,L,ldl)
        call dgetrf(m,n,L,ldl,ipiv,info)
        call dlacpy('U',m,n,L,ldl,R,ldr)
    else
        call dlacpy('0',m,n,A,lda,R,ldr)
        call dgetrf(m,n,R,ldr,ipiv,info)
        call dlacpy('L',m,n,R,ldr,L,ldl)
    end if
    do i = 1,min(m,n)
        do j = 1,i-1
            L(j,i) = 0d0
        end do
        L(i,i) = 1d0
    end do
    ! generate permutation
    do i = 1,m
        p(i) = i
    end do
    do i = 1,min(m,n)
        j = ipiv(i)
        if (i /= j) then
            tmp = p(i)
            p(i) = p(j)
            p(j) = tmp
        end if
    end do
    ! zero lower triangle of R
    do j = 1,n-1
        do i = j+1,min(m,n)
            R(i,j) = 0d0
        end do
    end do
end subroutine

subroutine clupgen(m,n,A,lda,L,ldl,R,ldr,p)
    integer m,n,lda,ldl,ldr,p(m)
    complex A(lda,n),L(ldl,min(m,n)),R(ldr,n)
    integer ipiv(min(m,n)),info,i,j,tmp
    external cswap,clacpy,cgetrf
    if (m >= n) then
        call clacpy('0',m,n,A,lda,L,ldl)
        call cgetrf(m,n,L,ldl,ipiv,info)
        call clacpy('U',m,n,L,ldl,R,ldr)
    else
        call clacpy('0',m,n,A,lda,R,ldr)
        call cgetrf(m,n,R,ldr,ipiv,info)
        call clacpy('L',m,n,R,ldr,L,ldl)
    end if
    do i = 1,min(m,n)
        do j = 1,i-1
            L(j,i) = 0e0
        end do
        L(i,i) = 1e0
    end do
    ! generate permutation
    do i = 1,m
        p(i) = i
    end do
    do i = 1,min(m,n)
        j = ipiv(i)
        if (i /= j) then
            tmp = p(i)
            p(i) = p(j)
            p(j) = tmp
        end if
    end do
    ! zero lower triangle of R
    do j = 1,n-1
        do i = j+1,min(m,n)
            R(i,j) = 0e0
        end do
    end do
end subroutine

subroutine zlupgen(m,n,A,lda,L,ldl,R,ldr,p)
    integer m,n,lda,ldl,ldr,p(m)
    double complex A(lda,n),L(ldl,min(m,n)),R(ldr,n)
    integer ipiv(min(m,n)),info,i,j,tmp
    external zswap,zlacpy,zgetrf
    if (m >= n) then
        call zlacpy('0',m,n,A,lda,L,ldl)
        call zgetrf(m,n,L,ldl,ipiv,info)
        call zlacpy('U',m,n,L,ldl,R,ldr)
    else
        call zlacpy('0',m,n,A,lda,R,ldr)
        call zgetrf(m,n,R,ldr,ipiv,info)
        call zlacpy('L',m,n,R,ldr,L,ldl)
    end if
    do i = 1,min(m,n)
        do j = 1,i-1
            L(j,i) = 0d0
        end do
        L(i,i) = 1d0
    end do
    ! generate permutation
    do i = 1,m
        p(i) = i
    end do
    do i = 1,min(m,n)
        j = ipiv(i)
        if (i /= j) then
            tmp = p(i)
            p(i) = p(j)
            p(j) = tmp
        end if
    end do
    ! zero lower triangle of R
    do j = 1,n-1
        do i = j+1,min(m,n)
            R(i,j) = 0d0
        end do
    end do
end subroutine

! converts a linear permutation into LAPACK ipiv-style form
subroutine p2ipiv(n,p)
    integer n,p(n)
    integer q(n),i,j,k
    do i = 1,n
        q(p(i)) = i
    end do
    do i = 1,n
        j = p(i)
        k = q(i)
        if (j /= i) then
            p(k) = j
            q(j) = k
            p(i) = j
        end if
    end do
end subroutine

subroutine slupchk(m,n,A,lda,L,ldl,R,ldr,p)
    use iso_fortran_env
    integer m,n,lda,ldl,ldr,p(m)
    real(real32) A(lda,n),L(ldl,min(m,n)),R(ldr,n)
    real(real32) rnrm,slange
    external p2ipiv,sswap,sgemm,slange,spftol
    character*4 spftol
    real wrk(1)
    integer i,j

    ! convert p into successive swaps
    call p2ipiv(m,p)
    ! form A - L*R
    do i = 1,m
        j = p(i)
        if (i /= j) then
            call sswap(n,A(i,1),lda,A(j,1),lda)
        end if
    end do
    call sgemm('N','N',m,n,min(m,n),1e0,L,ldl,R,ldr,-1e0,A,lda)
    ! get frobenius norm
    rnrm = slange('M',m,n,A,lda,wrk)
    write(*,1001) rnrm,spftol(rnrm)
    return

    1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
end subroutine

subroutine dlupchk(m,n,A,lda,L,ldl,R,ldr,p)
    use iso_fortran_env
    integer m,n,lda,ldl,ldr,p(m)
    real(real64) A(lda,n),L(ldl,min(m,n)),R(ldr,n)
    real(real64) rnrm,dlange
    external p2ipiv,dswap,dgemm,dlange,dpftol
    character*4 dpftol
    double precision wrk(1)
    integer i,j

    ! convert p into successive swaps
    call p2ipiv(m,p)
    ! form A - L*R
    do i = 1,m
        j = p(i)
        if (i /= j) then
            call dswap(n,A(i,1),lda,A(j,1),lda)
        end if
    end do
    call dgemm('N','N',m,n,min(m,n),1d0,L,ldl,R,ldr,-1d0,A,lda)
    ! get frobenius norm
    rnrm = dlange('M',m,n,A,lda,wrk)
    write(*,1001) rnrm,dpftol(rnrm)
    return

    1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
end subroutine

subroutine clupchk(m,n,A,lda,L,ldl,R,ldr,p)
    use iso_fortran_env
    integer m,n,lda,ldl,ldr,p(m)
    complex(real32) A(lda,n),L(ldl,min(m,n)),R(ldr,n)
    real(real32) rnrm,clange
    external p2ipiv,cswap,cgemm,clange,spftol
    character*4 spftol
    real wrk(1)
    integer i,j

    ! convert p into successive swaps
    call p2ipiv(m,p)
    ! form A - L*R
    do i = 1,m
        j = p(i)
        if (i /= j) then
            call cswap(n,A(i,1),lda,A(j,1),lda)
        end if
    end do
    call cgemm('N','N',m,n,min(m,n),(1e0,0e0),L,ldl,R,ldr,(-1e0,0e0), &
        &A,lda)
    ! get frobenius norm
    rnrm = clange('M',m,n,A,lda,wrk)
    write(*,1001) rnrm,spftol(rnrm)
    return

    1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
end subroutine

subroutine zlupchk(m,n,A,lda,L,ldl,R,ldr,p)
    use iso_fortran_env
    integer m,n,lda,ldl,ldr,p(m)
    complex(real64) A(lda,n),L(ldl,min(m,n)),R(ldr,n)
    real(real64) rnrm,zlange
    external p2ipiv,zswap,zgemm,zlange,dpftol
    character*4 dpftol
    double precision wrk(1)
    integer i,j

    ! convert p into successive swaps
    call p2ipiv(m,p)
    ! form A - L*R
    do i = 1,m
        j = p(i)
        if (i /= j) then
            call zswap(n,A(i,1),lda,A(j,1),lda)
        end if
    end do
    call zgemm('N','N',m,n,min(m,n),(1d0,0d0),L,ldl,R,ldr,(-1d0,0d0), &
        &A,lda)
    ! get frobenius norm
    rnrm = zlange('M',m,n,A,lda,wrk)
    write(*,1001) rnrm,dpftol(rnrm)
    return

    1001 format(6x,'residual error = ',10x,E21.12,5x,A6)
    END

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
!> \brief Updates a Cholesky factorization after a symmetric shift of rows and columns.
!>
!> \par Definition:
! =============
!> \verbatim
!>       subroutine cchshx(n,R,ldr,i,j,w,rw)
!>
!>       .. Scalar Arguments ..
!>       integer            n, ldr, i, j
!>       ..
!>       .. Array Arguments ..
!>       complex            R(ldr,*), w(*)
!>       real               rw(*)
!>       ..
!> \endverbatim
!>
!> \par Purpose:
! =============
!> \verbatim
!>
!> CCHSHX updates the Cholesky factorization of a hermitian
!> positive definite matrix A after a symmetric shift of rows and
!> columns.  Given an upper triangular matrix R that is a Cholesky
!> factor of A, i.e., A = R'*R, where R' denotes the conjugate
!> transpose of R, CCHSHX updates R -> R1 so that
!> R1'*R1 = A(p,p), where p is the permutation
!> [1:i-1, shift(i:j,-1), j+1:n] if i < j, or
!> [1:j-1, shift(j:i,+1), i+1:n] if j < i.
!> \endverbatim
!>
!> \param[in] n
!> \verbatim
!>          n is INTEGER
!>          The order of matrix R.  n >= 0.
!> \endverbatim
!>
!> \param[in,out] R
!> \verbatim
!>          R is COMPLEX array, dimension (ldr,n)
!>          On entry, the upper triangular matrix R, the Cholesky
!>          factor of A.  On exit, the updated upper triangular
!>          matrix R1, the Cholesky factor of A(p,p).
!> \endverbatim
!>
!> \param[in] ldr
!> \verbatim
!>          ldr is INTEGER
!>          The leading dimension of the array R.  ldr >= n.
!> \endverbatim
!>
!> \param[in] i
!> \verbatim
!>          i is INTEGER
!>          The first index determining the range of the shift.
!>          1 <= i <= n.
!> \endverbatim
!>
!> \param[in] j
!> \verbatim
!>          j is INTEGER
!>          The second index determining the range of the shift.
!>          1 <= j <= n.
!> \endverbatim
!>
!> \param[out] w
!> \verbatim
!>          w is COMPLEX array, dimension (n)
!>          Workspace vector used to store rotation sines during
!>          the retriangularization.
!> \endverbatim
!>
!> \param[out] rw
!> \verbatim
!>          rw is REAL array, dimension (n)
!>          Workspace vector used to store rotation cosines during
!>          the retriangularization.
!> \endverbatim
!>
!> \ingroup choldecomp
subroutine cchshx(n,R,ldr,i,j,w,rw)
    use iso_fortran_env
    use qrupdate_error
    integer, intent(in) :: n, ldr, i, j
    complex(real32), intent(inout) :: R(ldr,*)
    complex(real32), intent(out) :: w(*)
    real(real32), intent(out) :: rw(*)
    external ccopy,cqrtv1,cqrqh,cqhqr
    integer info,l
    ! quick return if possible.
    if (n == 0 .or. n == 1) return
    info = 0
    ! check arguments.
    if (n < 0) then
        info = 1
    else if (i < 1 .or. i > n) then
        info = 4
    else if (j < 1 .or. j > n) then
        info = 5
    end if
    if (info /= 0) then
        call qrupdate_xerror('CCHSHX',info)
        return
    end if
    if (i < j) then
        ! shift columns
        call ccopy(n,R(1,i),1,w,1)
        do l = i,j-1
            call ccopy(n,R(1,l+1),1,R(1,l),1)
        end do
        call ccopy(n,w,1,R(1,j),1)
        ! retriangularize
        call cqhqr(n+1-i,n+1-i,R(i,i),ldr,rw,w)
    else if (j < i) then
        ! shift columns
        call ccopy(n,R(1,i),1,w,1)
        do l = i,j+1,-1
            call ccopy(n,R(1,l-1),1,R(1,l),1)
        end do
        call ccopy(n,w,1,R(1,j),1)
        ! eliminate the introduced spike.
        call cqrtv1(n+1-j,R(j,j),rw)
        ! apply rotations to R
        call cqrqh(n+1-j,n-j,R(j,j+1),ldr,rw,R(j+1,j))
        ! zero spike.
        do l = j+1,n
            R(l,j) = 0e0
        end do
    end if
end subroutine

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
!> \brief Converts an upper trapezoidal matrix to upper Hessenberg form.
!>
!> \par Definition:
! =============
!> \verbatim
!>       subroutine sqrqh(m,n,R,ldr,c,s)
!>
!>       .. Scalar Arguments ..
!>       integer             m, n, ldr
!>       ..
!>       .. Array Arguments ..
!>       real                R(ldr,*)
!>       real                c(*)
!>       real                s(*)
!>       ..
!> \endverbatim
!>
!> \par Purpose:
! =============
!> \verbatim
!>
!> SQRQH brings an upper trapezoidal matrix R into upper Hessenberg form
!> using min(m-1,n) Givens rotations. (real version)
!> \endverbatim
!>
!> \param[in] m
!> \verbatim
!>          m is INTEGER
!>          The number of rows of the matrix R.  m >= 0.
!> \endverbatim
!>
!> \param[in] n
!> \verbatim
!>          n is INTEGER
!>          The number of columns of the matrix R.  n >= 0.
!> \endverbatim
!>
!> \param[in,out] R
!> \verbatim
!>          R is REAL array, dimension (ldr,*)
!>          On entry, the upper Hessenberg matrix R.  On exit,
!>          the updated upper trapezoidal matrix.
!> \endverbatim
!>
!> \param[in] ldr
!> \verbatim
!>          ldr is INTEGER
!>          The leading dimension of R.  ldr >= m.
!> \endverbatim
!>
!> \param[in] c
!> \verbatim
!>          c is REAL array, dimension (*)
!>          The rotation cosines.  Must contain at least
!>          min(m-1,n) elements.
!> \endverbatim
!>
!> \param[in] s
!> \verbatim
!>          s is REAL array, dimension (*)
!>          The rotation sines.  Must contain at least
!>          min(m-1,n) elements.
!> \endverbatim
!>
!> \ingroup qrdecomp
subroutine sqrqh(m,n,R,ldr,c,s)
    use iso_fortran_env
    use qrupdate_error
    integer, intent(in) :: m, n, ldr
    real(real32), intent(inout) :: R(ldr,*)
    real(real32), intent(in) :: c(*)
    real(real32), intent(in) :: s(*)
    real(real32) t
    integer info,i,ii,j
    ! quick return if possible.
    if (m == 0 .or. m == 1 .or. n == 0) return
    ! check arguments.
    info = 0
    if (m < 0) then
        info = 1
    else if (n < 0) then
        info = 2
    else if (ldr < m) then
        info = 4
    end if
    if (info /= 0) then
        call qrupdate_xerror('SQRQH',info)
        return
    end if
    do i = 1,n
        ii = min(m-1,i)
        ! apply stored rotations, column-wise
        t = R(ii+1,i)
        do j = ii,1,-1
            R(j+1,i) = c(j)*t - s(j)*R(j,i)
            t = c(j)*R(j,i) + s(j)*t
        end do
        R(1,i) = t
    end do
end subroutine

! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!

module test_aux
    implicit none
    type :: aux_data
        character(len=32) :: message
        integer :: val
    end type aux_data
end module test_aux

program test_qrupdate_error
    use iso_fortran_env
    use qrupdate_error
    use test_state
    use test_aux
    implicit none

    type(aux_data), target :: my_data
    class(*), pointer :: p_aux_data
    procedure(error_handler_if), pointer :: p_handler

    print *, 'Running qrupdate_error tests...'

    ! Test 1: Default behavior (no custom handler)
    call reset()
    call qrupdate_xerror('TEST_ROUTINE', 42)
    if (.not. xerbla_called) then
        print *, 'Test 1 Failed: xerbla was not called'
        stop
    end if
    print *, 'Test 1 Passed: Default behavior calls xerbla'

    ! Test 2: Custom handler without auxiliary data
    call reset()
    p_handler => my_custom_handler
    call qrupdate_set_error(p_handler)
    call qrupdate_xerror('CUSTOM_ROUTINE', 123)
    if (.not. custom_handler_called) then
        print *, 'Test 2 Failed: Custom handler was not called'
        stop
    end if
    if (last_srname /= 'CUSTOM_ROUTINE' .or. last_info /= 123) then
        print *, 'Test 2 Failed: Incorrect arguments passed to handler'
        stop
    end if
    print *, 'Test 2 Passed: Custom handler called correctly'

    ! Test 3: Custom handler with auxiliary data
    call reset()
    my_data%message = 'Hello World'
    my_data%val = 999
    p_aux_data => my_data
    call qrupdate_set_error_data(p_aux_data)
    call qrupdate_xerror('DATA_ROUTINE', 7)
    if (.not. custom_handler_called) then
        print *, 'Test 3 Failed: Custom handler was not called'
        stop
    end if
    print *, 'Test 3 Passed: Custom handler called with auxiliary data'

    ! Test 4: Overwriting handler
    call reset()
    p_handler => my_other_handler
    call qrupdate_set_error(p_handler)
    call qrupdate_xerror('OTHER_ROUTINE', 1)
    if (call_count /= 1) then
        print *, 'Test 4 Failed: Incorrect call count for other handler'
        stop
    end if
    print *, 'Test 4 Passed: Handler overwritten successfully'

    print *, 'All qrupdate_error tests passed!'

contains

    subroutine my_custom_handler(srname, info, aux)
        use test_state
        character(len=*), intent(in) :: srname
        integer, intent(in) :: info
        class(*), optional, intent(in) :: aux

 
        if (present(aux)) then 
            call_count = call_count
        endif        
        print *, 'my_custom_handler called from ', srname, ' with ', info 

        custom_handler_called = .true.
        last_srname = srname
        last_info = info
        call_count = call_count + 1
    end subroutine my_custom_handler

    subroutine my_other_handler(srname, info, aux)
        use test_state
        character(len=*), intent(in) :: srname
        integer, intent(in) :: info
        class(*), optional, intent(in) :: aux

        if (present(aux)) then 
            call_count = call_count
        endif 
        print *, 'my_other_handler called from ', srname, ' with ', info 
        custom_handler_called = .true.
        call_count = call_count + 1
    end subroutine my_other_handler

end program test_qrupdate_error


subroutine xerbla(srname, info)
    use test_state
    implicit none
    character(len=*), intent(in) :: srname
    integer, intent(in) :: info
    xerbla_called = .true.
    print *, 'Mock xerbla called from: ', srname, ' with info: ', info
end subroutine xerbla

! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
!> \brief Module for custom error handling.
!>
!> This module provides a mechanism to override the default BLAS/LAPACK
!> error handler (xerbla). Users can specify a custom subroutine to
!> handle errors, along with optional auxiliary data.
module qrupdate_error
    use qrupdate_blas
    implicit none

    !> \brief Abstract interface for custom error handlers.
    !> \ingroup error
    abstract interface
    subroutine error_handler_if(srname, info, aux)
        character(len=*), intent(in) :: srname
        integer, intent(in) :: info
    class(*), optional, intent(in) :: aux
end subroutine error_handler_if
    end interface

    procedure(error_handler_if), pointer :: global_error_handler => null()
class(*), pointer :: global_error_aux => null()

private :: global_error_handler, global_error_aux
contains

    !> \brief Sets the custom error handler.
    !>
    !> \param[in] p_handler
    !> \verbatim
    !>          p_handler is a procedure pointer conforming to the
    !>          error_handler_if interface.
    !> \endverbatim
    !> \ingroup error
    subroutine qrupdate_set_error(p_handler)
        procedure(error_handler_if), pointer, intent(in) :: p_handler
        global_error_handler => p_handler
    end subroutine qrupdate_set_error

    !> \brief Sets auxiliary data for the error handler.
    !>
    !> \param[in] p_aux
    !> \verbatim
    !>          p_aux is a pointer to a polymorphic object (class(*))
    !>          that will be passed to the error handler.
    !> \endverbatim
    !> \ingroup error
    subroutine qrupdate_set_error_data(p_aux)
    class(*), pointer :: p_aux
    global_error_aux => p_aux
end subroutine qrupdate_set_error_data

!> \brief Dispatches error reporting to the handler.
!>
!> This subroutine checks if a custom error handler has been set via
!> qrupdate_set_error. If so, it calls that handler with the provided
!> routine name, error code, and any set auxiliary data. Otherwise, it
!> falls back to the standard LAPACK xerbla routine.
!>
!> \param[in] srname
!> \verbatim
!>          srname is CHARACTER(LEN=*)
!>          The name of the routine that encountered the error.
!> \endverbatim
!> \param[in] info
!> \verbatim
!>          info is INTEGER
!>          The error code.
!> \endverbatim
!> \ingroup error
subroutine qrupdate_xerror(srname, info)
    character(len=*), intent(in) :: srname
    integer, intent(in) :: info
    if (associated(global_error_handler)) then
        call global_error_handler(srname, info, global_error_aux)
    else
        call xerbla(srname, info)
    end if
end subroutine qrupdate_xerror

end module qrupdate_error

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
!> \brief Updates a QR factorization after a circular shift of columns.
!>
!> \par Definition:
! =============
!> \verbatim
!>       subroutine sqrshc(m,n,k,Q,ldq,R,ldr,i,j,w)
!>
!>       .. Scalar Arguments ..
!>       integer             m, n, k, ldq, ldr, i, j
!>       ..
!>       .. Array Arguments ..
!>       real                Q(ldq,*)
!>       real                R(ldr,*)
!>       real                w(*)
!>       ..
!> \endverbatim
!>
!> \par Purpose:
! =============
!> \verbatim
!>
!> SQRSHC updates a QR factorization after circular shift of columns.
!> i.e., given an m-by-k orthogonal matrix Q, an k-by-n upper
!> trapezoidal matrix R and index j in the range 1:n+1, SQRSHC
!> updates the matrix Q -> Q1 and R -> R1 so that Q1 is again
!> orthogonal, R1 upper trapezoidal, and Q1*R1 = A(:,p), where A = Q*R
!> and p is the permutation [1:i-1,shift(i:j,-1),j+1:n] if i < j or
!> [1:j-1,shift(j:i,+1),i+1:n] if j < i. (real version)
!> \endverbatim
!>
!> \param[in] m
!> \verbatim
!>          m is INTEGER
!>          The number of rows of the matrix Q.  m >= 0.
!> \endverbatim
!>
!> \param[in] n
!> \verbatim
!>          n is INTEGER
!>          The number of columns of the matrix R.  n >= 0.
!> \endverbatim
!>
!> \param[in] k
!> \verbatim
!>          k is INTEGER
!>          The number of columns of Q1, and rows of R1.  Must be
!>          either k = m (full Q) or k = n <= m (economical form).
!> \endverbatim
!>
!> \param[in,out] Q
!> \verbatim
!>          Q is REAL array, dimension (ldq,*)
!>          On entry, the orthogonal m-by-k matrix Q.  On exit,
!>          the updated matrix Q1.
!> \endverbatim
!>
!> \param[in] ldq
!> \verbatim
!>          ldq is INTEGER
!>          The leading dimension of Q.  ldq >= m.
!> \endverbatim
!>
!> \param[in,out] R
!> \verbatim
!>          R is REAL array, dimension (ldr,*)
!>          On entry, the original matrix R.  On exit, the
!>          updated matrix R1.
!> \endverbatim
!>
!> \param[in] ldr
!> \verbatim
!>          ldr is INTEGER
!>          The leading dimension of R.  ldr >= k.
!> \endverbatim
!>
!> \param[in] i
!> \verbatim
!>          i is INTEGER
!>          The first index determining the range (see above).
!> \endverbatim
!>
!> \param[in] j
!> \verbatim
!>          j is INTEGER
!>          The second index determining the range (see above).
!> \endverbatim
!>
!> \param[out] w
!> \verbatim
!>          w is REAL array, dimension (*)
!>          A workspace vector of size 2*k.
!> \endverbatim
!>
!> \ingroup qrdecomp
subroutine sqrshc(m,n,k,Q,ldq,R,ldr,i,j,w)
    use iso_fortran_env
    use qrupdate_error
    integer, intent(in) :: m, n, k, ldq, ldr, i, j
    real(real32), intent(inout) :: Q(ldq,*), R(ldr,*)
    real(real32), intent(out) :: w(*)
    external scopy,sqrtv1,sqrqh,sqhqr,sqrot
    integer info,jj,kk,l
    ! quick return if possible.
    if (m == 0 .or. n == 1) return
    info = 0
    ! check arguments.
    if (m < 0) then
        info = 1
    else if (n < 0) then
        info = 2
    else if (k /= m .and. (k /= n .or. n > m)) then
        info = 3
    else if (i < 1 .or. i > n) then
        info = 6
    else if (j < 1 .or. j > n) then
        info = 7
    end if
    if (info /= 0) then
        call qrupdate_xerror('SQRSHC',info)
        return
    end if
    if (i < j) then
        ! shift columns
        call scopy(k,R(1,i),1,w,1)
        do l = i,j-1
            call scopy(k,R(1,l+1),1,R(1,l),1)
        end do
        call scopy(k,w,1,R(1,j),1)
        ! retriangularize
        if (i < k) then
            kk = min(k,j)
            call sqhqr(kk+1-i,n+1-i,R(i,i),ldr,w(k+1),w)
            ! apply rotations to Q.
            call sqrot('F',m,kk+1-i,Q(1,i),ldq,w(k+1),w)
        end if
    else if (j < i) then
        ! shift columns
        call scopy(k,R(1,i),1,w,1)
        do l = i,j+1,-1
            call scopy(k,R(1,l-1),1,R(1,l),1)
        end do
        call scopy(k,w,1,R(1,j),1)
        ! retriangularize
        if (j < k) then
            jj = min(j+1,n)
            kk = min(k,i)
            ! eliminate the introduced spike.
            call sqrtv1(kk+1-j,R(j,j),w(k+1))
            ! apply rotations to R
            call sqrqh(kk+1-j,n-j,R(j,jj),ldr,w(k+1),R(j+1,j))
            ! apply rotations to Q
            call sqrot('B',m,kk+1-j,Q(1,j),ldq,w(k+1),R(j+1,j))
            ! zero spike.
            do l = j+1,kk
                R(l,j) = 0e0
            end do
        end if
    end if
end subroutine

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
!> \brief Updates a row-pivoted LU factorization after rank-1 modification.
!>
!> \par Definition:
! =============
!> \verbatim
!>       subroutine slup1up(m,n,L,ldl,R,ldr,p,u,v,w)
!>
!>       .. Scalar Arguments ..
!>       integer            m, n, ldl, ldr
!>       ..
!>       .. Array Arguments ..
!>       integer            p(*)
!>       real               L(ldl,*), R(ldr,*), u(*), v(*), w(*)
!>       ..
!> \endverbatim
!>
!> \par Purpose:
! =============
!> \verbatim
!>
!> SLUP1UP updates a row-pivoted LU factorization after rank-1
!> modification.  Given an m-by-k lower-triangular matrix L with
!> unit diagonal, a k-by-n upper-trapezoidal matrix R, and a
!> permutation vector p, where k = min(m,n), SLUP1UP
!> updates L -> L1, R -> R1 and p -> p1 so that L1 is again
!> lower unit triangular, R1 upper trapezoidal, p1 a permutation,
!> and P1.'*L1*R1 = P.'*L*R + u*v.', where v.' denotes the
!> transpose of v and P is the permutation matrix corresponding
!> to p.
!> \endverbatim
!>
!> \param[in] m
!> \verbatim
!>          m is INTEGER
!>          The number of rows of the matrix L.  m >= 0.
!> \endverbatim
!>
!> \param[in] n
!> \verbatim
!>          n is INTEGER
!>          The number of columns of the matrix R.  n >= 0.
!> \endverbatim
!>
!> \param[in,out] L
!> \verbatim
!>          L is REAL array, dimension (ldl,k)
!>          On entry, the unit lower triangular matrix L.  On exit,
!>          the updated unit lower triangular matrix L1.
!> \endverbatim
!>
!> \param[in] ldl
!> \verbatim
!>          ldl is INTEGER
!>          The leading dimension of the array L.  ldl >= m.
!> \endverbatim
!>
!> \param[in,out] R
!> \verbatim
!>          R is REAL array, dimension (ldr,n)
!>          On entry, the upper trapezoidal m-by-n matrix R.
!>          On exit, the updated upper trapezoidal matrix R1.
!> \endverbatim
!>
!> \param[in] ldr
!> \verbatim
!>          ldr is INTEGER
!>          The leading dimension of the array R.  ldr >= k,
!>          where k = min(m,n).
!> \endverbatim
!>
!> \param[in] p
!> \verbatim
!>          p is INTEGER array, dimension (m)
!>          The permutation vector representing the row pivoting.
!>          On exit, p is updated to reflect the new pivoting.
!> \endverbatim
!>
!> \param[in] u
!> \verbatim
!>          u is REAL array, dimension (m)
!>          The left m-vector defining the rank-1 modification.
!> \endverbatim
!>
!> \param[in] v
!> \verbatim
!>          v is REAL array, dimension (n)
!>          The right n-vector defining the rank-1 modification.
!> \endverbatim
!>
!> \param[out] w
!> \verbatim
!>          w is REAL array, dimension (m)
!>          Workspace vector used during the update computation.
!> \endverbatim
!>
!> \ingroup ludecomp
subroutine slup1up(m,n,L,ldl,R,ldr,p,u,v,w)
    use iso_fortran_env
    use qrupdate_error
    integer, intent(in) :: m, n, ldl, ldr
    integer, intent(inout) :: p(*)
    real(real32), intent(inout) :: L(ldl,*), R(ldr,*)
    real(real32), intent(in) :: u(*), v(*)
    real(real32), intent(out) :: w(*)
    real(real32) one,tau,tmp
    parameter (one = 1e0, tau = 1e-1)
    integer k,info,i,j,itmp
    external scopy,saxpy,strsv,sger,sgemv,sswap
    ! quick return if possible.
    k = min(m,n)
    if (k == 0) return
    ! check arguments.
    info = 0
    if (m < 0) then
        info = 1
    else if (n < 0) then
        info = 2
    else if (ldl < m) then
        info = 4
    else if (ldr < k) then
        info = 6
    endif
    if (info /= 0) then
        call qrupdate_xerror('SLUP1UP',info)
        return
    end if
    ! form L \ P*u.
    do i = 1,m
        w(i) = u(p(i))
    end do
    call strsv('L','N','U',k,L,ldl,w,1)
    ! if m > k = n, subtract the trailing part.
    if (m > k) then
        call sgemv('N',m-k,k,-one,L(k+1,1),ldl,w,1,one,w(k+1),1)
    end if
    ! work from bottom to top
    do j = k-1,1,-1
        if (abs(w(j)) < tau * abs(L(j+1,j)*w(j) + w(j+1))) then
            ! need pivoting. swap j and j+1
            tmp = w(j)
            w(j) = w(j+1)
            w(j+1) = tmp
            ! update p
            itmp = p(j)
            p(j) = p(j+1)
            p(j+1) = itmp
            ! update L
            call sswap(m-j+1,L(j,j),1,L(j,j+1),1)
            call sswap(j+1,L(j,1),ldl,L(j+1,1),ldl)
            ! update R
            call sswap(n-j+1,R(j,j),ldr,R(j+1,j),ldr)
            ! make L lower triangular again
            tmp = -L(j,j+1)
            call saxpy(m-j+1,tmp,L(j,j),1,L(j,j+1),1)
            ! update R
            call saxpy(n-j+1,-tmp,R(j+1,j),ldr,R(j,j),ldr)
            ! update w
            w(j) = w(j) - tmp*w(j+1)
        end if
        ! eliminate w(j+1)
        tmp = w(j+1)/w(j)
        w(j+1) = 0
        ! update R.
        call saxpy(n-j+1,-tmp,R(j,j),ldr,R(j+1,j),ldr)
        ! update L.
        call saxpy(m-j,tmp,L(j+1,j+1),1,L(j+1,j),1)
    end do
    ! add a multiple of v to R
    call saxpy(n,w(1),v,1,R(1,1),ldr)
    ! forward sweep
    do j = 1,k-1
        if (abs(R(j,j)) < tau * abs(L(j+1,j)*R(j,j) + R(j+1,j))) then
            ! need pivoting. swap j and j+1
            ! update p
            itmp = p(j)
            p(j) = p(j+1)
            p(j+1) = itmp
            ! update L
            call sswap(m-j+1,L(j,j),1,L(j,j+1),1)
            call sswap(j+1,L(j,1),ldl,L(j+1,1),ldl)
            ! update R
            call sswap(n-j+1,R(j,j),ldr,R(j+1,j),ldr)
            ! make L lower triangular again
            tmp = -L(j,j+1)
            call saxpy(m-j+1,tmp,L(j,j),1,L(j,j+1),1)
            ! update R
            call saxpy(n-j+1,-tmp,R(j+1,j),ldr,R(j,j),ldr)
        end if
        ! eliminate R(j+1,j)
        tmp = R(j+1,j)/R(j,j)
        ! update R.
        R(j+1,j) = 0e0
        call saxpy(n-j,-tmp,R(j,j+1),ldr,R(j+1,j+1),ldr)
        ! update L.
        call saxpy(m-j,tmp,L(j+1,j+1),1,L(j+1,j),1)
    end do
    ! if m > k = n, complete the update by updating the lower part of L.
    if (m > k) then
        call scopy(k,v,1,w,1)
        call strsv('U','T','N',k,R,ldr,w,1)
        call sger(m-k,k,one,w(k+1),1,w,1,L(k+1,1),ldl)
    endif
end subroutine

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
!> \brief Updates a QR factorization after deleting a row.
!>
!> \par Definition:
! =============
!> \verbatim
!>       subroutine dqrder(m,n,Q,ldq,R,ldr,j,w)
!>
!>       .. Scalar Arguments ..
!>       integer             m, n, ldq, ldr, j
!>       ..
!>       .. Array Arguments ..
!>       double precision    Q(ldq,*)
!>       double precision    R(ldr,*)
!>       double precision    w(*)
!>       ..
!> \endverbatim
!>
!> \par Purpose:
! =============
!> \verbatim
!>
!> DQRDER updates a QR factorization after deleting a row. i.e., given
!> an m-by-m orthogonal matrix Q, an m-by-n upper trapezoidal matrix R
!> and index j in the range 1:m, DQRDER updates Q ->Q1 and an R
!> -> R1 so that Q1 is again orthogonal, R1 upper trapezoidal, and Q1*R1
!> = [A(1:j-1,:); A(j+1:m,:)], where A = Q*R. (real version)
!> \endverbatim
!>
!> \param[in] m
!> \verbatim
!>          m is INTEGER
!>          The number of rows of the matrix Q.  m >= 1.
!> \endverbatim
!>
!> \param[in] n
!> \verbatim
!>          n is INTEGER
!>          The number of columns of the matrix R.  n >= 0.
!> \endverbatim
!>
!> \param[in,out] Q
!> \verbatim
!>          Q is DOUBLE PRECISION array, dimension (ldq,*)
!>          On entry, the orthogonal matrix Q.  On exit, the
!>          updated matrix Q1.
!> \endverbatim
!>
!> \param[in] ldq
!> \verbatim
!>          ldq is INTEGER
!>          The leading dimension of Q.  ldq >= m.
!> \endverbatim
!>
!> \param[in,out] R
!> \verbatim
!>          R is DOUBLE PRECISION array, dimension (ldr,*)
!>          On entry, the original matrix R.  On exit, the
!>          updated matrix R1.
!> \endverbatim
!>
!> \param[in] ldr
!> \verbatim
!>          ldr is INTEGER
!>          The leading dimension of R.  ldr >= m.
!> \endverbatim
!>
!> \param[in] j
!> \verbatim
!>          j is INTEGER
!>          The position of the deleted row.  1 <= j <= m.
!> \endverbatim
!>
!> \param[out] w
!> \verbatim
!>          w is DOUBLE PRECISION array, dimension (*)
!>          A workspace vector of size 2*m.
!> \endverbatim
!>
!> \ingroup qrdecomp
subroutine dqrder(m,n,Q,ldq,R,ldr,j,w)
    use iso_fortran_env
    use qrupdate_error
    integer, intent(in) :: m, n, j, ldq, ldr
    real(real64), intent(inout) :: Q(ldq,*)
    real(real64), intent(inout) :: R(ldr,*)
    real(real64), intent(out) :: w(*)
    external dcopy,dqrtv1,dqrot,dqrqh
    integer info,i,k
    ! quick return if possible.
    if (m == 1) return
    ! check arguments
    info = 0
    if (m < 1) then
        info = 1
    else if (j < 1 .or. j > m) then
        info = 7
    end if
    if (info /= 0) then
        call qrupdate_xerror('DQRDER',info)
        return
    end if
    ! eliminate Q(j,2:m).
    call dcopy(m,Q(j,1),ldq,w,1)
    call dqrtv1(m,w,w(m+1))
    ! apply rotations to Q.
    call dqrot('B',m,m,Q,ldq,w(m+1),w(2))
    ! form Q1.
    do k = 1,m-1
        if (j > 1) call dcopy(j-1,Q(1,k+1),1,Q(1,k),1)
        if (j < m) call dcopy(m-j,Q(j+1,k+1),1,Q(j,k),1)
    end do
    ! apply rotations to R.
    call dqrqh(m,n,R,ldr,w(m+1),w(2))
    ! form R1.
    do k = 1,n
        do i = 1,m-1
            R(i,k) = R(i+1,k)
        end do
    end do
end subroutine

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
!> \brief Updates a Cholesky factorization after deleting a row and column.
!>
!> \par Definition:
! =============
!> \verbatim
!>       subroutine dchdex(n,R,ldr,j,w)
!>
!>       .. Scalar Arguments ..
!>       integer            n, ldr, j
!>       ..
!>       .. Array Arguments ..
!>       double precision   R(ldr,*), w(*)
!>       ..
!> \endverbatim
!>
!> \par Purpose:
! =============
!> \verbatim
!>
!> DCHDEX updates the Cholesky factorization of a symmetric
!> positive definite matrix A after deleting a row/column.
!> Given an upper triangular matrix R that is a Cholesky
!> factor of A, i.e., A = R.'*R, where R.' denotes the
!> transpose of R, DCHDEX updates R -> R1 so that
!> R1.'*R1 = A(jj,jj), where jj = [1:j-1, j+1:n+1].
!> \endverbatim
!>
!> \param[in] n
!> \verbatim
!>          n is INTEGER
!>          The order of matrix R.  n >= 0.
!> \endverbatim
!>
!> \param[in,out] R
!> \verbatim
!>          R is DOUBLE PRECISION array, dimension (ldr,n)
!>          On entry, the upper triangular matrix R, the Cholesky
!>          factor of A.  On exit, the updated upper triangular
!>          matrix R1, the Cholesky factor of A(jj,jj).
!> \endverbatim
!>
!> \param[in] ldr
!> \verbatim
!>          ldr is INTEGER
!>          The leading dimension of the array R.  ldr >= n.
!> \endverbatim
!>
!> \param[in] j
!> \verbatim
!>          j is INTEGER
!>          The position of the deleted row/column.
!> \endverbatim
!>
!> \param[out] w
!> \verbatim
!>          w is DOUBLE PRECISION array, dimension (n)
!>          A workspace vector.
!> \endverbatim
!>
!> \ingroup choldecomp
subroutine dchdex(n,R,ldr,j,w)
    use iso_fortran_env
    use qrupdate_error
    integer, intent(in) :: n, ldr, j
    real(real64), intent(inout) :: R(ldr,*)
    real(real64), intent(out) :: w(*)
    integer info,i
    external dcopy,dqhqr
    ! quick return if possible.
    if (n == 1) return
    ! check arguments
    info = 0
    if (n < 0) then
        info = 1
    else if (j < 1 .or. j > n) then
        info = 4
    end if
    if (info /= 0) then
        call qrupdate_xerror('DCHDEX',info)
        return
    end if
    ! delete the j-th column.
    do i = j,n-1
        call dcopy(n,R(1,i+1),1,R(1,i),1)
    end do
    ! retriangularize.
    if (j < n) then
        call dqhqr(n+1-j,n-j,R(j,j),ldr,w,R(1,n))
    end if
end subroutine

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
!> \brief Updates a Cholesky factorization after a rank-1 modification.
!>
!> \par Definition:
! =============
!> \verbatim
!>       subroutine sch1up(n,R,ldr,u,w)
!>
!>       .. Scalar Arguments ..
!>       integer            n, ldr
!>       ..
!>       .. Array Arguments ..
!>       real               R(ldr,*), u(*), w(*)
!>       ..
!> \endverbatim
!>
!> \par Purpose:
! =============
!> \verbatim
!>
!> SCH1UP updates the Cholesky factorization of a symmetric
!> positive definite matrix A after a rank-1 modification.  Given an
!> upper triangular matrix R that is a Cholesky factor of A, i.e.,
!> A = R.'*R, where R.' denotes the transpose of R, SCH1UP
!> updates R -> R1 so that R1.'*R1 = A + u*u.', where u is a given
!> vector.
!>
!> The update is performed by applying a sequence of Givens rotations
!> to restore the upper triangular structure of R.  On exit, u
!> contains the rotation sines and w contains the rotation cosines
!> used in the transformation.
!> \endverbatim
!>
!> \param[in] n
!> \verbatim
!>          n is INTEGER
!>          The order of matrix R.  n >= 0.
!> \endverbatim
!>
!> \param[in,out] R
!> \verbatim
!>          R is REAL array, dimension (ldr,n)
!>          On entry, the upper triangular matrix R, the Cholesky
!>          factor of A.  On exit, the updated upper triangular
!>          matrix R1, the Cholesky factor of A + u*u.'.
!> \endverbatim
!>
!> \param[in] ldr
!> \verbatim
!>          ldr is INTEGER
!>          The leading dimension of the array R.  ldr >= n.
!> \endverbatim
!>
!> \param[in,out] u
!> \verbatim
!>          u is REAL array, dimension (n)
!>          On entry, the vector determining the rank-1 update.
!>          On exit, u contains the rotation sines used to
!>          transform R to R1.
!> \endverbatim
!>
!> \param[out] w
!> \verbatim
!>          w is REAL array, dimension (n)
!>          On exit, w contains the cosine parts of the Givens
!>          rotations used to transform R to R1.
!> \endverbatim
!>
!> \ingroup choldecomp
subroutine sch1up(n,R,ldr,u,w)
    use iso_fortran_env
    integer, intent(in) :: n, ldr
    real(real32), intent(inout) :: R(ldr,*), u(*)
    real(real32), intent(out) :: w(*)
    external slartg
    real(real32) rr,ui,t
    integer i,j

    do i = 1,n
        ! apply stored rotations, column-wise
        ui = u(i)
        do j = 1,i-1
            t = w(j)*R(j,i) + u(j)*ui
            ui = w(j)*ui - u(j)*R(j,i)
            R(j,i) = t
        end do
        ! generate next rotation
        call slartg(R(i,i),ui,w(i),u(i),rr)
        R(i,i) = rr
    end do
end subroutine

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
!> \brief Generates Givens rotations to eliminate all but the first element of a vector.
!>
!> \par Definition:
! =============
!> \verbatim
!>       subroutine cqrtv1(n,u,w)
!>
!>       .. Scalar Arguments ..
!>       integer            n
!>       ..
!>       .. Array Arguments ..
!>       complex            u(*)
!>       real               w(*)
!>       ..
!> \endverbatim
!>
!> \par Purpose:
! =============
!> \verbatim
!>
!> CQRTV1 generates a sequence of n-1 Givens rotations that
!> eliminate all but the first element of a complex vector u.
!> On entry, u contains the vector to be reduced.  On exit,
!> u(1) contains the resulting element, u(2:n) contains the
!> rotation sines, and w contains the rotation cosines.
!>
!> The rotations are generated from the bottom up, so that the
!> first rotation eliminates u(n), the second eliminates u(n-1),
!> and so on.
!> \endverbatim
!>
!> \param[in] n
!> \verbatim
!>          n is INTEGER
!>          The length of the vector u.  If n <= 0, the subroutine
!>          returns immediately without modification.
!> \endverbatim
!>
!> \param[in,out] u
!> \verbatim
!>          u is COMPLEX array, dimension (n)
!>          On entry, the vector to be reduced.  On exit, u(1)
!>          contains the remaining element, and u(2:n) contains
!>          the sine parts of the Givens rotations.
!> \endverbatim
!>
!> \param[out] w
!> \verbatim
!>          w is REAL array, dimension (n)
!>          On exit, w contains the cosine parts of the Givens
!>          rotations.
!> \endverbatim
!>
!> \ingroup givens
subroutine cqrtv1(n,u,w)
    use iso_fortran_env
    integer, intent(in) :: n
    complex(real32), intent(inout) :: u(*)
    real(real32), intent(out) :: w(*)
    external clartg
    complex(real32) rr,t
    integer i
    ! quick return if possible.
    if (n <= 0) return
    rr = u(n)
    do i = n-1,1,-1
        call clartg(u(i),rr,w(i),u(i+1),t)
        rr = t
    end do
    u(1) = rr
end subroutine

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
program tqr1up
    integer m,n
    external stest, dtest, ctest, ztest, pstats


    write (*,*)
    write (*,*) 'testing QR rank-1 update routines.'
    write (*,*) 'All residual errors are expected to be small.'
    write (*,*)

    m = 60
    n = 40
    write (*,*) 'sqr1up test (full factorization):'
    call stest(m,n,0)
    write (*,*) 'dqr1up test (full factorization):'
    call dtest(m,n,0)
    write (*,*) 'cqr1up test (full factorization):'
    call ctest(m,n,0)
    write (*,*) 'zqr1up test (full factorization):'
    call ztest(m,n,0)

    write (*,*) 'sqr1up test (economized factorization):'
    call stest(m,n,1)
    write (*,*) 'dqr1up test (economized factorization):'
    call dtest(m,n,1)
    write (*,*) 'cqr1up test (economized factorization):'
    call ctest(m,n,1)
    write (*,*) 'zqr1up test (economized factorization):'
    call ztest(m,n,1)

    m = 40
    n = 60
    write (*,*) 'sqr1up test (rows < columns):'
    call stest(m,n,0)
    write (*,*) 'dqr1up test (rows < columns):'
    call dtest(m,n,0)
    write (*,*) 'cqr1up test (rows < columns):'
    call ctest(m,n,0)
    write (*,*) 'zqr1up test (rows < columns):'
    call ztest(m,n,0)

    call pstats
end program

subroutine stest(m,n,ec)
    use iso_fortran_env
    integer m,n,ec
    real(real32) A(m,max(m,n)),Q(m,m),R(m,n),u(m),v(n),wrk(2*m)
    external srandg,sqrgen,sger,sqr1up,sqrchk
    integer k
    ! set up random matrix & vectors
    call srandg(m,n,A,m)
    call srandg(m,1,u,m)
    call srandg(n,1,v,n)
    ! generate QR decomposition
    call sqrgen(m,n,A,m,Q,m,R,m)
    ! update A
    call sger(m,n,1e0,u,1,v,1,A,m)
    ! update the QR decomposition
    k = m
    if (ec == 1) k = n
    call sqr1up(m,n,k,Q,m,R,m,u,v,wrk)
    ! check result
    call sqrchk(m,n,k,A,m,Q,m,R,m)

end subroutine

subroutine dtest(m,n,ec)
    use iso_fortran_env
    integer m,n,ec
    real(real64) A(m,max(m,n)),Q(m,m),R(m,n),u(m),v(n),wrk(2*m)
    external drandg,dqrgen,dger,dqr1up,dqrchk
    integer k
    ! set up random matrix & vectors
    call drandg(m,n,A,m)
    call drandg(m,1,u,m)
    call drandg(n,1,v,n)
    ! generate QR decomposition
    call dqrgen(m,n,A,m,Q,m,R,m)
    ! update A
    call dger(m,n,1d0,u,1,v,1,A,m)
    ! update the QR decomposition
    k = m
    if (ec == 1) k = n
    call dqr1up(m,n,k,Q,m,R,m,u,v,wrk)
    ! check result
    call dqrchk(m,n,k,A,m,Q,m,R,m)

end subroutine

subroutine ctest(m,n,ec)
    use iso_fortran_env
    integer m,n,ec
    complex(real32) A(m,max(m,n)),Q(m,m),R(m,n),u(m),v(n),wrk(m)
    real(real32) rwrk(m)
    external crandg,cqrgen,cgerc,cqr1up,cqrchk
    integer k
    ! set up random matrix & vectors
    call crandg(m,n,A,m)
    call crandg(m,1,u,m)
    call crandg(n,1,v,n)
    ! generate QR decomposition
    call cqrgen(m,n,A,m,Q,m,R,m)
    ! update A
    call cgerc(m,n,(1e0,0e0),u,1,v,1,A,m)
    ! update the QR decomposition
    k = m
    if (ec == 1) k = n
    call cqr1up(m,n,k,Q,m,R,m,u,v,wrk,rwrk)
    ! check result
    call cqrchk(m,n,k,A,m,Q,m,R,m)

end subroutine

subroutine ztest(m,n,ec)
    use iso_fortran_env
    integer m,n,ec
    complex(real64) A(m,max(m,n)),Q(m,m),R(m,n),u(m),v(n),wrk(m)
    real(real64) rwrk(m)
    external zrandg,zqrgen,zgerc,zqr1up,zqrchk
    integer k
    ! set up random matrix & vectors
    call zrandg(m,n,A,m)
    call zrandg(m,1,u,m)
    call zrandg(n,1,v,n)
    ! generate QR decomposition
    call zqrgen(m,n,A,m,Q,m,R,m)
    ! update A
    call zgerc(m,n,(1d0,0d0),u,1,v,1,A,m)
    ! update the QR decomposition
    k = m
    if (ec == 1) k = n
    call zqr1up(m,n,k,Q,m,R,m,u,v,wrk,rwrk)
    ! check result
    call zqrchk(m,n,k,A,m,Q,m,R,m)

    END

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
!> \brief Applies a sequence of Givens rotations from the right to a matrix.
!>
!> \par Definition:
! =============
!> \verbatim
!>       subroutine sqrot(dir,m,n,Q,ldq,c,s)
!>
!>       .. Scalar Arguments ..
!>       character           dir
!>       integer             m, n, ldq
!>       ..
!>       .. Array Arguments ..
!>       real                Q(ldq,*)
!>       real                c(*)
!>       real                s(*)
!>       ..
!> \endverbatim
!>
!> \par Purpose:
! =============
!> \verbatim
!>
!> SQROT applies a sequence of Givens rotations from the right
!> side to an m-by-n matrix Q.  Given a direction indicator
!> dir, the rotation cosine and sine vectors c and s, SQROT
!> applies the rotations to Q, updating it in place.  If dir
!> is 'F' (forward), rotations are applied from the first to
!> the last; if dir is 'B' (backward), from the last to the
!> first.
!> \endverbatim
!>
!> \param[in] dir
!> \verbatim
!>          dir is CHARACTER
!>          If 'B' or 'b', rotations are applied backwards
!>          (from the last to the first).  If 'F' or 'f',
!>          rotations are applied forwards (from the first to
!>          the last).
!> \endverbatim
!>
!> \param[in] m
!> \verbatim
!>          m is INTEGER
!>          The number of rows of matrix Q.  m >= 0.
!> \endverbatim
!>
!> \param[in] n
!> \verbatim
!>          n is INTEGER
!>          The number of columns of the matrix Q.  n >= 0.
!> \endverbatim
!>
!> \param[in,out] Q
!> \verbatim
!>          Q is REAL array, dimension (ldq,*)
!>          On entry, the matrix Q.  On exit, the updated
!>          matrix Q1.
!> \endverbatim
!>
!> \param[in] ldq
!> \verbatim
!>          ldq is INTEGER
!>          The leading dimension of Q.  ldq >= m.
!> \endverbatim
!>
!> \param[in] c
!> \verbatim
!>          c is REAL array, dimension (*)
!>          The rotation cosines.  Must contain at least
!>          n-1 elements.
!> \endverbatim
!>
!> \param[in] s
!> \verbatim
!>          s is REAL array, dimension (*)
!>          The rotation sines.  Must contain at least
!>          n-1 elements.
!> \endverbatim
!>
!> \ingroup givens
subroutine sqrot(dir,m,n,Q,ldq,c,s)
    use iso_fortran_env
    use qrupdate_error
    use qrupdate_blas
    character, intent(in) :: dir
    integer, intent(in) :: m, n, ldq
    real(real32), intent(inout) :: Q(ldq,*)
    real(real32), intent(in) :: c(*)
    real(real32), intent(in) :: s(*)
    external  srot
    logical fwd
    integer info,i
    ! quick return if possible.
    if (m == 0 .or. n == 0 .or. n == 1) return
    ! check arguments.
    info = 0
    fwd = lsame(dir,'F')
    if (.not.(fwd .or. lsame(dir,'B'))) then
        info = 1
    else if (m < 0) then
        info = 2
    else if (n < 0) then
        info = 3
    else if (ldq < m) then
        info = 5
    end if
    if (info /= 0) then
        call qrupdate_xerror('SQROT',info)
        return
    end if
    if (fwd) then
        do i = 1,n-1
            call srot(m,Q(1,i),1,Q(1,i+1),1,c(i),s(i))
        end do
    else
        do i = n-1,1,-1
            call srot(m,Q(1,i),1,Q(1,i+1),1,c(i),s(i))
        end do
    end if
end subroutine

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
!> \brief Updates a QR factorization after inserting a new column.
!>
!> \par Definition:
! =============
!> \verbatim
!>       subroutine sqrinc(m,n,k,Q,ldq,R,ldr,j,x,w)
!>
!>       .. Scalar Arguments ..
!>       integer             m, n, k, ldq, ldr, j
!>       ..
!>       .. Array Arguments ..
!>       real                Q(ldq,*)
!>       real                R(ldr,*)
!>       real                x(*)
!>       real                w(*)
!>       ..
!> \endverbatim
!>
!> \par Purpose:
! =============
!> \verbatim
!>
!> SQRINC updates a QR factorization after inserting a new column. i.e.,
!> given an m-by-k orthogonal matrix Q, an m-by-n upper trapezoidal
!> matrix R and index j in the range 1:n+1, SQRINC updates the
!> matrix Q -> Q1 and R -> R1 so that Q1 is again orthogonal, R1 upper
!> trapezoidal, and Q1*R1 = [A(:,1:j-1); x; A(:,j:n)], where A = Q*R.
!> (real version)
!> \endverbatim
!>
!> \param[in] m
!> \verbatim
!>          m is INTEGER
!>          The number of rows of the matrix Q.  m >= 0.
!> \endverbatim
!>
!> \param[in] n
!> \verbatim
!>          n is INTEGER
!>          The number of columns of the matrix R.  n >= 0.
!> \endverbatim
!>
!> \param[in] k
!> \verbatim
!>          k is INTEGER
!>          The number of columns of Q, and rows of R.  Must be
!>          either k = m (full Q) or k = n <= m (economical form,
!>          basis dimension will increase).
!> \endverbatim
!>
!> \param[in,out] Q
!> \verbatim
!>          Q is REAL array, dimension (ldq,*)
!>          On entry, the orthogonal m-by-k matrix Q.  On exit,
!>          the updated matrix Q1.
!> \endverbatim
!>
!> \param[in] ldq
!> \verbatim
!>          ldq is INTEGER
!>          The leading dimension of Q.  ldq >= m.
!> \endverbatim
!>
!> \param[in,out] R
!> \verbatim
!>          R is REAL array, dimension (ldr,*)
!>          On entry, the original matrix R.  On exit, the
!>          updated matrix R1.
!> \endverbatim
!>
!> \param[in] ldr
!> \verbatim
!>          ldr is INTEGER
!>          The leading dimension of R.  ldr >= min(m,n+1).
!> \endverbatim
!>
!> \param[in] j
!> \verbatim
!>          j is INTEGER
!>          The position of the new column in R1.  1 <= j <= n+1.
!> \endverbatim
!>
!> \param[in] x
!> \verbatim
!>          x is REAL array, dimension (*)
!>          The column being inserted.
!> \endverbatim
!>
!> \param[out] w
!> \verbatim
!>          w is REAL array, dimension (*)
!>          A workspace vector of size k.
!> \endverbatim
!>
!> \ingroup qrdecomp
subroutine sqrinc(m,n,k,Q,ldq,R,ldr,j,x,w)
    use iso_fortran_env
    use qrupdate_error
    integer, intent(in) :: m, n, k, ldq, ldr, j
    real(real32), intent(inout) :: Q(ldq,*), R(ldr,*)
    real(real32), intent(in) :: x(*)
    real(real32), intent(out) :: w(*)
    external sqrtv1,sqrqh,sqrot
    external scopy,sdot,saxpy,sscal,snrm2,sgqvec
    real(real32) sdot,snrm2,rx
    integer info,i,k1
    logical full
    ! quick return if possible.
    if (m == 0) return
    ! check arguments.
    info = 0
    if (m < 0) then
        info = 1
    else if (n < 0) then
        info = 2
    else if (k /= m .and. (k /= n .or. n >= m)) then
        info = 3
    else if (ldq < m) then
        info = 5
    else if (ldr < min(m,k+1)) then
        info = 7
    else if (j < 1 .or. j > n+1) then
        info = 8
    end if
    if (info /= 0) then
        call qrupdate_xerror('SQRINC',info)
        return
    end if
    full = k == m
    ! insert empty column at j-th position.
    do i = n,j,-1
        call scopy(k,R(1,i),1,R(1,i+1),1)
    end do
    ! insert Q'*u into R. In the nonfull case, form also u-Q*Q'*u.
    if (full) then
        k1 = k
        do i = 1,k
            R(i,j) = sdot(m,Q(1,i),1,x,1)
        end do
    else
        k1 = k + 1
        ! zero last row of R
        do i = 1,n+1
            R(k1,i) = 0e0
        end do
        call scopy(m,x,1,Q(1,k1),1)
        do i = 1,k
            R(i,j) = sdot(m,Q(1,i),1,Q(1,k1),1)
            call saxpy(m,-R(i,j),Q(1,i),1,Q(1,k1),1)
        end do
        ! get norm of the inserted column
        rx = snrm2(m,Q(1,k1),1)
        R(k1,j) = rx
        if (rx == 0e0) then
            ! in the rare case when rx is exact zero, we still need to provide
            ! a valid orthogonal unit vector. The details are boring, so handle
            ! that elsewhere.
            call sgqvec(m,k,Q,ldq,Q(1,k1))
        else
            ! otherwise, just normalize the added column.
            call sscal(m,1e0/rx,Q(1,k1),1)
        end if
    end if
    ! maybe we're finished.
    if (j > k) return
    ! eliminate the spike.
    call sqrtv1(k1+1-j,R(j,j),w)
    ! apply rotations to R(j:k,j:n).
    if (j <= n) call sqrqh(k1+1-j,n+1-j,R(j,j+1),ldr,w,R(j+1,j))
    ! apply rotations to Q(:,j:k).
    call sqrot('B',m,k1+1-j,Q(1,j),ldq,w,R(j+1,j))
    ! zero spike.
    do i = j+1,k1
        R(i,j) = 0e0
    end do
end subroutine

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
!> \brief Generates a unit vector orthogonal to the column space of a unitary matrix.
!>
!> \par Definition:
! =============
!> \verbatim
!>       subroutine sgqvec(m,n,Q,ldq,u)
!>
!>       .. Scalar Arguments ..
!>       integer            m, n, ldq
!>       ..
!>       .. Array Arguments ..
!>       real               Q(ldq,*), u(*)
!>       ..
!> \endverbatim
!>
!> \par Purpose:
! =============
!> \verbatim
!>
!> SGQVEC generates a vector u in the orthogonal complement of the
!> column space of an orthogonal matrix Q.  Given an m-by-n
!> orthogonal matrix Q with n < m, SGQVEC generates a
!> vector u of length m such that Q.'*u = 0 and norm(u) = 1, where
!> Q.' denotes the transpose of Q.
!>
!> The algorithm projects canonical unit vectors onto the orthogonal
!> complement of Q's column space until a nonzero result is found.
!> If n = 0, the first canonical unit vector is returned.
!> \endverbatim
!>
!> \param[in] m
!> \verbatim
!>          m is INTEGER
!>          The number of rows of the matrix Q.  m >= 0.
!> \endverbatim
!>
!> \param[in] n
!> \verbatim
!>          n is INTEGER
!>          The number of columns of the matrix Q.  n >= 0 and
!>          n < m.
!> \endverbatim
!>
!> \param[in] Q
!> \verbatim
!>          Q is REAL array, dimension (ldq,n)
!>          The orthogonal m-by-n matrix Q.
!> \endverbatim
!>
!> \param[in] ldq
!> \verbatim
!>          ldq is INTEGER
!>          The leading dimension of the array Q.  ldq >= m.
!> \endverbatim
!>
!> \param[out] u
!> \verbatim
!>          u is REAL array, dimension (m)
!>          The generated vector such that Q.'*u = 0 and norm(u) = 1.
!> \endverbatim
!>
!> \ingroup qrdecomp
subroutine sgqvec(m,n,Q,ldq,u)
    use iso_fortran_env
    use qrupdate_error
    integer, intent(in) :: m, n, ldq
    real(real32), intent(in) :: Q(ldq,*)
    real(real32), intent(out) :: u(*)
    external sdot,saxpy,snrm2,sscal
    real(real32) sdot,snrm2,r
    integer info,i,j
    ! quick return if possible.
    if (m == 0) return
    if (n == 0) then
        u(1) = 1e0
        do i = 2,m
            u(i) = 0e0
        end do
        return
    end if
    ! check arguments.
    info = 0
    if (m < 0) then
        info = 1
    else if (n < 0) then
        info = 2
    else if (ldq < m) then
        info = 4
    end if
    if (info /= 0) then
        call qrupdate_xerror('SGQVEC',info)
        return
    end if
    j = 1
    r = 0e0
    do while ( r .eq. 0e0 )
        ! probe j-th canonical unit vector.
        do i = 1,m
            u(i) = 0e0
        end do
        u(j) = 1e0
        ! form u - Q*Q'*u
        do i = 1,n
            r = sdot(m,Q(1,i),1,u,1)
            call saxpy(m,-r,Q(1,i),1,u,1)
        end do
        r = snrm2(m,u,1)
        if (r == 0e0) then
            j = j + 1
            if (j > n) then
                ! this is fatal, and in theory, it can't happen.
                stop 'fatal: impossible condition in SGQVEC'
            end if
        end if
    end do
    call sscal(m,1e0/r,u,1)
end subroutine

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
program tqrder
    integer m,n,j
    external stest, dtest, ctest, ztest, pstats


    write (*,*)
    write (*,*) 'testing QR row delete routines.'
    write (*,*) 'All residual errors are expected to be small.'
    write (*,*)

    m = 60
    n = 40
    j = 30
    write (*,*) 'sqrder test (full factorization):'
    call stest(m,n,j)
    write (*,*) 'dqrder test (full factorization):'
    call dtest(m,n,j)
    write (*,*) 'cqrder test (full factorization):'
    call ctest(m,n,j)
    write (*,*) 'zqrder test (full factorization):'
    call ztest(m,n,j)

    call pstats
end program

subroutine stest(m,n,j)
    use iso_fortran_env
    integer m,n,j
    real(real32) A(m,max(m,n)),Q(m,m),R(m,n),wrk(2*m)
    external srandg,sqrgen,scopy,sqrder,sqrchk
    integer i
    ! set up random matrix & vector
    call srandg(m,n,A,m)
    ! generate QR decomposition
    call sqrgen(m,n,A,m,Q,m,R,m)
    ! update A
    do i = j,m-1
        call scopy(n,A(i+1,1),m,A(i,1),m)
    end do
    ! update the QR decomposition
    call sqrder(m,n,Q,m,R,m,j,wrk)
    ! check result
    call sqrchk(m-1,n,m-1,A,m,Q,m,R,m)

end subroutine

subroutine dtest(m,n,j)
    use iso_fortran_env
    integer m,n,j
    real(real64) A(m,max(m,n)),Q(m,m),R(m,n),wrk(2*m)
    external drandg,dqrgen,dcopy,dqrder,dqrchk
    integer i
    ! set up random matrix & vector
    call drandg(m,n,A,m)
    ! generate QR decomposition
    call dqrgen(m,n,A,m,Q,m,R,m)
    ! update A
    do i = j,m-1
        call dcopy(n,A(i+1,1),m,A(i,1),m)
    end do
    ! update the QR decomposition
    call dqrder(m,n,Q,m,R,m,j,wrk)
    ! check result
    call dqrchk(m-1,n,m-1,A,m,Q,m,R,m)

end subroutine

subroutine ctest(m,n,j)
    use iso_fortran_env
    integer m,n,j
    complex(real32) A(m,max(m,n)),Q(m,m),R(m,n),wrk(m)
    real(real32) rwrk(m)
    external crandg,cqrgen,ccopy,cqrder,cqrchk
    integer i
    ! set up random matrix & vector
    call crandg(m,n,A,m)
    ! generate QR decomposition
    call cqrgen(m,n,A,m,Q,m,R,m)
    ! update A
    do i = j,m-1
        call ccopy(n,A(i+1,1),m,A(i,1),m)
    end do
    ! update the QR decomposition
    call cqrder(m,n,Q,m,R,m,j,wrk,rwrk)
    ! check result
    call cqrchk(m-1,n,m-1,A,m,Q,m,R,m)

end subroutine

subroutine ztest(m,n,j)
    use iso_fortran_env
    integer m,n,j
    complex(real64) A(m,max(m,n)),Q(m,m),R(m,n),wrk(m)
    real(real64) rwrk(m)
    external zrandg,zqrgen,zcopy,zqrder,zqrchk
    integer i
    ! set up random matrix & vector
    call zrandg(m,n,A,m)
    ! generate QR decomposition
    call zqrgen(m,n,A,m,Q,m,R,m)
    ! update A
    do i = j,m-1
        call zcopy(n,A(i+1,1),m,A(i,1),m)
    end do
    ! update the QR decomposition
    call zqrder(m,n,Q,m,R,m,j,wrk,rwrk)
    ! check result
    call zqrchk(m-1,n,m-1,A,m,Q,m,R,m)

    END

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
program tqrshc
    integer m,n,i,j
    external stest, dtest, ctest, ztest, pstats


    write (*,*)
    write (*,*) 'testing QR column shift routines.'
    write (*,*) 'All residual errors are expected to be small.'
    write (*,*)

    m = 60
    n = 50
    i = 20
    j = 40
    write (*,*) 'sqrshc test (left shift, full factorization):'
    call stest(m,n,i,j,0)
    write (*,*) 'dqrshc test (left shift, full factorization):'
    call dtest(m,n,i,j,0)
    write (*,*) 'cqrshc test (left shift, full factorization):'
    call ctest(m,n,i,j,0)
    write (*,*) 'zqrshc test (left shift, full factorization):'
    call ztest(m,n,i,j,0)

    i = 40
    j = 20
    write (*,*) 'sqrshc test (right shift, economized factorization):'
    call stest(m,n,i,j,1)
    write (*,*) 'dqrshc test (right shift, economized factorization):'
    call dtest(m,n,i,j,1)
    write (*,*) 'cqrshc test (right shift, economized factorization):'
    call ctest(m,n,i,j,1)
    write (*,*) 'zqrshc test (right shift, economized factorization):'
    call ztest(m,n,i,j,1)

    call pstats
end program

subroutine stest(m,n,i,j,ec)
    use iso_fortran_env
    integer m,n,i,j,ec
    real(real32) A(m,max(m,n)),Q(m,m),R(m,n),wrk(2*m)
    external srandg,sqrgen,scopy,sqrshc,sqrchk
    integer k
    ! set up random matrix & vector
    call srandg(m,n,A,m)
    ! generate QR decomposition
    call sqrgen(m,n,A,m,Q,m,R,m)
    ! update A
    if (i < j) then
        call scopy(m,A(1,i),1,wrk,1)
        do k = i,j-1
            call scopy(m,A(1,k+1),1,A(1,k),1)
        end do
        call scopy(m,wrk,1,A(1,j),1)
    else
        call scopy(m,A(1,i),1,wrk,1)
        do k = i,j+1,-1
            call scopy(m,A(1,k-1),1,A(1,k),1)
        end do
        call scopy(m,wrk,1,A(1,j),1)
    end if
    ! update the QR decomposition
    k = m
    if (ec == 1) k = n
    call sqrshc(m,n,k,Q,m,R,m,i,j,wrk)
    ! check result
    call sqrchk(m,n,k,A,m,Q,m,R,m)

end subroutine

subroutine dtest(m,n,i,j,ec)
    use iso_fortran_env
    integer m,n,i,j,ec
    real(real64) A(m,max(m,n)),Q(m,m),R(m,n),wrk(2*m)
    external drandg,dqrgen,dcopy,dqrshc,dqrchk
    integer k
    ! set up random matrix & vector
    call drandg(m,n,A,m)
    ! generate QR decomposition
    call dqrgen(m,n,A,m,Q,m,R,m)
    ! update A
    if (i < j) then
        call dcopy(m,A(1,i),1,wrk,1)
        do k = i,j-1
            call dcopy(m,A(1,k+1),1,A(1,k),1)
        end do
        call dcopy(m,wrk,1,A(1,j),1)
    else
        call dcopy(m,A(1,i),1,wrk,1)
        do k = i,j+1,-1
            call dcopy(m,A(1,k-1),1,A(1,k),1)
        end do
        call dcopy(m,wrk,1,A(1,j),1)
    end if
    ! update the QR decomposition
    k = m
    if (ec == 1) k = n
    call dqrshc(m,n,k,Q,m,R,m,i,j,wrk)
    ! check result
    call dqrchk(m,n,k,A,m,Q,m,R,m)

end subroutine

subroutine ctest(m,n,i,j,ec)
    use iso_fortran_env
    integer m,n,i,j,ec
    complex(real32) A(m,max(m,n)),Q(m,m),R(m,n),wrk(m)
    real(real32) rwrk(m)
    external crandg,cqrgen,ccopy,cqrshc,cqrchk
    integer k
    ! set up random matrix & vector
    call crandg(m,n,A,m)
    ! generate QR decomposition
    call cqrgen(m,n,A,m,Q,m,R,m)
    ! update A
    if (i < j) then
        call ccopy(m,A(1,i),1,wrk,1)
        do k = i,j-1
            call ccopy(m,A(1,k+1),1,A(1,k),1)
        end do
        call ccopy(m,wrk,1,A(1,j),1)
    else
        call ccopy(m,A(1,i),1,wrk,1)
        do k = i,j+1,-1
            call ccopy(m,A(1,k-1),1,A(1,k),1)
        end do
        call ccopy(m,wrk,1,A(1,j),1)
    end if
    ! update the QR decomposition
    k = m
    if (ec == 1) k = n
    call cqrshc(m,n,k,Q,m,R,m,i,j,wrk,rwrk)
    ! check result
    call cqrchk(m,n,k,A,m,Q,m,R,m)

end subroutine

subroutine ztest(m,n,i,j,ec)
    use iso_fortran_env
    integer m,n,i,j,ec
    complex(real64) A(m,max(m,n)),Q(m,m),R(m,n),wrk(m)
    real(real64) rwrk(m)
    external zrandg,zqrgen,zcopy,zqrshc,zqrchk
    integer k
    ! set up random matrix & vector
    call zrandg(m,n,A,m)
    ! generate QR decomposition
    call zqrgen(m,n,A,m,Q,m,R,m)
    ! update A
    if (i < j) then
        call zcopy(m,A(1,i),1,wrk,1)
        do k = i,j-1
            call zcopy(m,A(1,k+1),1,A(1,k),1)
        end do
        call zcopy(m,wrk,1,A(1,j),1)
    else
        call zcopy(m,A(1,i),1,wrk,1)
        do k = i,j+1,-1
            call zcopy(m,A(1,k-1),1,A(1,k),1)
        end do
        call zcopy(m,wrk,1,A(1,j),1)
    end if
    ! update the QR decomposition
    k = m
    if (ec == 1) k = n
    call zqrshc(m,n,k,Q,m,R,m,i,j,wrk,rwrk)
    ! check result
    call zqrchk(m,n,k,A,m,Q,m,R,m)

    END

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
program tch1dn
    integer n
    external stest, dtest, ctest, ztest, pstats

    write (*,*)
    write (*,*) 'testing Cholesky rank-1 downdate routines.'
    write (*,*) 'All residual errors are expected to be small.'
    write (*,*)

    n = 50
    write (*,*) 'sch1dn test:'
    call stest(n)
    write (*,*) 'dch1dn test:'
    call dtest(n)
    write (*,*) 'cch1dn test:'
    call ctest(n)
    write (*,*) 'zch1dn test:'
    call ztest(n)

    call pstats
end program

subroutine stest(n)
    use iso_fortran_env
    integer n
    real(real32) A(n,n),R(n,n),u(n),wrk(2*n)
    external srandg,scopy,schgen,sch1up,schchk,sch1dn
    integer info
    ! set up random matrix & vectors
    call srandg(n,n,A,n)
    call srandg(n,1,u,n)
    call scopy(n,u,1,wrk,1)
    ! generate A'*A and its Cholesky decomposition
    call schgen(n,A,n,R,n)
    ! update the Cholesky decomposition
    call sch1up(n,R,n,u,wrk(1+n))
    ! downdate it back
    call sch1dn(n,R,n,wrk,wrk(1+n),info)
    ! check result
    call schchk(n,A,n,R,n)

end subroutine

subroutine dtest(n)
    use iso_fortran_env
    integer n
    real(real64) A(n,n),R(n,n),u(n),wrk(2*n)
    external drandg,dcopy,dchgen,dch1up,dchchk,dch1dn
    integer info
    ! set up random matrix & vectors
    call drandg(n,n,A,n)
    call drandg(n,1,u,n)
    call dcopy(n,u,1,wrk,1)
    ! generate A'*A and its Cholesky decomposition
    call dchgen(n,A,n,R,n)
    ! update the Cholesky decomposition
    call dch1up(n,R,n,u,wrk(1+n))
    ! downdate it back
    call dch1dn(n,R,n,wrk,wrk(1+n),info)
    ! check result
    call dchchk(n,A,n,R,n)

end subroutine

subroutine ctest(n)
    use iso_fortran_env
    integer n
    complex(real32) A(n,n),R(n,n),u(n),wrk(n)
    real(real32) rwrk(n)
    external crandg,ccopy,cchgen,cch1up,cchchk,cch1dn
    integer info
    ! set up random matrix & vectors
    call crandg(n,n,A,n)
    call crandg(n,1,u,n)
    call ccopy(n,u,1,wrk,1)
    ! generate A'*A and its Cholesky decomposition
    call cchgen(n,A,n,R,n)
    ! update the Cholesky decomposition
    call cch1up(n,R,n,u,rwrk)
    ! downdate it back
    call cch1dn(n,R,n,wrk,rwrk,info)
    ! check result
    call cchchk(n,A,n,R,n)

end subroutine

subroutine ztest(n)
    use iso_fortran_env
    integer n
    complex(real64) A(n,n),R(n,n),u(n),wrk(n)
    real(real64) rwrk(n)
    external zrandg,zcopy,zchgen,zch1up,zchchk,zch1dn
    integer info
    ! set up random matrix & vectors
    call zrandg(n,n,A,n)
    call zrandg(n,1,u,n)
    call zcopy(n,u,1,wrk,1)
    ! generate A'*A and its Cholesky decomposition
    call zchgen(n,A,n,R,n)
    ! update the Cholesky decomposition
    call zch1up(n,R,n,u,rwrk)
    ! downdate it back
    call zch1dn(n,R,n,wrk,rwrk,info)
    ! check result
    call zchchk(n,A,n,R,n)

    END

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
!> \brief Downdates a Cholesky factorization after a rank-1 modification.
!>
!> \par Definition:
! =============
!> \verbatim
!>       subroutine zch1dn(n,R,ldr,u,rw,info)
!>
!>       .. Scalar Arguments ..
!>       integer            n, ldr, info
!>       ..
!>       .. Array Arguments ..
!>       double complex     R(ldr,*), u(*)
!>       double precision   rw(*)
!>       ..
!> \endverbatim
!>
!> \par Purpose:
! =============
!> \verbatim
!>
!> ZCH1DN downdates the Cholesky factorization of a hermitian
!> positive definite matrix A after a rank-1 modification.  Given an
!> upper triangular matrix R that is a Cholesky factor of A, i.e.,
!> A = R'*R, where R' denotes the conjugate transpose of R, this
!> ZCH1DN downdates R -> R1 so that R1'*R1 = A - u*u', where u
!> is a given vector.
!>
!> The downdate is performed by applying a sequence of hyperbolic
!> rotations to restore the upper triangular structure of R.  On
!> exit, u contains the rotation sines and rw contains the rotation
!> cosines used in the transformation.
!> \endverbatim
!>
!> \param[in] n
!> \verbatim
!>          n is INTEGER
!>          The order of matrix R.  n >= 0.
!> \endverbatim
!>
!> \param[in,out] R
!> \verbatim
!>          R is COMPLEX*16 array, dimension (ldr,n)
!>          On entry, the upper triangular matrix R, the Cholesky
!>          factor of A.  On exit, the updated upper triangular
!>          matrix R1, the Cholesky factor of A - u*u'.
!> \endverbatim
!>
!> \param[in] ldr
!> \verbatim
!>          ldr is INTEGER
!>          The leading dimension of the array R.  ldr >= n.
!> \endverbatim
!>
!> \param[in,out] u
!> \verbatim
!>          u is COMPLEX*16 array, dimension (n)
!>          On entry, the vector determining the rank-1 downdate.
!>          On exit, u contains the rotation sines used to
!>          transform R to R1.
!> \endverbatim
!>
!> \param[out] rw
!> \verbatim
!>          rw is DOUBLE PRECISION array, dimension (n)
!>          On exit, rw contains the cosine parts of the
!>          rotations used to transform R to R1.
!> \endverbatim
!>
!> \param[out] info
!> \verbatim
!>          info is INTEGER
!>          = 0:  successful exit
!>          = 1:  the update would violate positive-definiteness
!>          = 2:  R is singular
!> \endverbatim
!>
!> \ingroup choldecomp
subroutine zch1dn(n,R,ldr,u,rw,info)
    use iso_fortran_env
    use qrupdate_error
    integer, intent(in) :: n, ldr
    complex(real64), intent(inout) :: R(ldr,*), u(*)
    real(real64), intent(out) :: rw(*)
    integer, intent(out) :: info
    external ztrsv,zlartg,dznrm2
    complex(real64) crho,rr,ui,t
    real(real64) dznrm2,rho
    integer i,j
    ! quick return if possible.
    if (n == 0) return
    ! check arguments.
    info = 0
    if (n < 0) then
        info = -1
    else if (ldr < n) then
        info = -3
    end if
    if (info /= 0) then
        call qrupdate_xerror('ZCH1DN',-info)
        return
    end if
    ! check for singularity of R.
    do i = 1,n
        if (R(i,i) == 0d0) goto 20
    end do
    ! form R' \ u
    call ztrsv('U','C','N',n,R,ldr,u,1)
    rho = dznrm2(n,u,1)
    ! check positive definiteness
    rho = 1 - rho**2
    if (rho <= 0d0) goto 10
    crho = sqrt(rho)
    ! eliminate R' \ u
    do i = n,1,-1
        ui = u(i)
        ! generate next rotation
        call zlartg(crho,ui,rw(i),u(i),rr)
        crho = rr
    end do
    ! apply rotations
    do i = n,1,-1
        ui = 0d0
        do j = i,1,-1
            t = rw(j)*ui + u(j)*R(j,i)
            R(j,i) = rw(j)*R(j,i) - conjg(u(j))*ui
            ui = t
        end do
    end do
    ! normal return
    return
    ! error returns
    10 info = 1
    return
    20 info = 2
    return
end subroutine

program tchshx
    integer n,i,j
    external stest, dtest, ctest, ztest, pstats


    write (*,*)
    write (*,*) 'testing QR column shift routines.'
    write (*,*) 'All residual errors are expected to be small.'
    write (*,*)

    n = 50
    i = 20
    j = 40
    write (*,*) 'schshx test (left shift):'
    call stest(n,i,j)
    write (*,*) 'dchshx test (left shift):'
    call dtest(n,i,j)
    write (*,*) 'cchshx test (left shift):'
    call ctest(n,i,j)
    write (*,*) 'zchshx test (left shift):'
    call ztest(n,i,j)

    i = 40
    j = 20
    write (*,*) 'schshx test (right shift):'
    call stest(n,i,j)
    write (*,*) 'dchshx test (right shift):'
    call dtest(n,i,j)
    write (*,*) 'cchshx test (right shift):'
    call ctest(n,i,j)
    write (*,*) 'zchshx test (right shift):'
    call ztest(n,i,j)

    call pstats
end program

subroutine stest(n,i,j)
    use iso_fortran_env
    integer n,i,j
    real(real32) A(n,n),R(n,n),wrk(2*n)
    external srandg,schgen,sswap,schshx,schchk
    integer k
    ! set up random matrix
    call srandg(n,n,A,n)
    ! generate A'*A and its Cholesky decomposition
    call schgen(n,A,n,R,n)
    ! update matrix
    if (i < j) then
        do k = i,j-1
            call sswap(n,A(1,k),1,A(1,k+1),1)
            call sswap(n,A(k,1),n,A(k+1,1),n)
        end do
    else if (i > j) then
        do k = i,j+1,-1
            call sswap(n,A(1,k),1,A(1,k-1),1)
            call sswap(n,A(k,1),n,A(k-1,1),n)
        end do
    end if
    ! update factorization
    call schshx(n,R,n,i,j,wrk)
    ! check result
    call schchk(n,A,n,R,n)

end subroutine

subroutine dtest(n,i,j)
    use iso_fortran_env
    integer n,i,j
    real(real64) A(n,n),R(n,n),wrk(2*n)
    external drandg,dchgen,dswap,dchshx,dchchk
    integer k
    ! set up random matrix
    call drandg(n,n,A,n)
    ! generate A'*A and its Cholesky decomposition
    call dchgen(n,A,n,R,n)
    ! update matrix
    if (i < j) then
        do k = i,j-1
            call dswap(n,A(1,k),1,A(1,k+1),1)
            call dswap(n,A(k,1),n,A(k+1,1),n)
        end do
    else if (i > j) then
        do k = i,j+1,-1
            call dswap(n,A(1,k),1,A(1,k-1),1)
            call dswap(n,A(k,1),n,A(k-1,1),n)
        end do
    end if
    ! update factorization
    call dchshx(n,R,n,i,j,wrk)
    ! check result
    call dchchk(n,A,n,R,n)

end subroutine

subroutine ctest(n,i,j)
    use iso_fortran_env
    integer n,i,j
    complex(real32) A(n,n),R(n,n),wrk(n)
    real(real32) rwrk(n)
    external crandg,cchgen,cswap,cchshx,cchchk
    integer k
    ! set up random matrix
    call crandg(n,n,A,n)
    ! generate A'*A and its Cholesky decomposition
    call cchgen(n,A,n,R,n)
    ! update matrix
    if (i < j) then
        do k = i,j-1
            call cswap(n,A(1,k),1,A(1,k+1),1)
            call cswap(n,A(k,1),n,A(k+1,1),n)
        end do
    else if (i > j) then
        do k = i,j+1,-1
            call cswap(n,A(1,k),1,A(1,k-1),1)
            call cswap(n,A(k,1),n,A(k-1,1),n)
        end do
    end if
    ! update factorization
    call cchshx(n,R,n,i,j,wrk,rwrk)
    ! check result
    call cchchk(n,A,n,R,n)

end subroutine

subroutine ztest(n,i,j)
    use iso_fortran_env
    integer n,i,j
    complex(real64) A(n,n),R(n,n),wrk(n)
    real(real64) rwrk(n)
    external zrandg,zchgen,zswap,zchshx,zchchk
    integer k
    ! set up random matrix
    call zrandg(n,n,A,n)
    ! generate A'*A and its Cholesky decomposition
    call zchgen(n,A,n,R,n)
    ! update matrix
    if (i < j) then
        do k = i,j-1
            call zswap(n,A(1,k),1,A(1,k+1),1)
            call zswap(n,A(k,1),n,A(k+1,1),n)
        end do
    else if (i > j) then
        do k = i,j+1,-1
            call zswap(n,A(1,k),1,A(1,k-1),1)
            call zswap(n,A(k,1),n,A(k-1,1),n)
        end do
    end if
    ! update factorization
    call zchshx(n,R,n,i,j,wrk,rwrk)
    ! check result
    call zchchk(n,A,n,R,n)

    END

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
program tlu1up
    integer m,n
    external stest, dtest, ctest, ztest, pstats


    write (*,*)
    write (*,*) 'testing LU rank-1 update routines.'
    write (*,*) 'All residual errors are expected to be small.'
    write (*,*)

    m = 60
    n = 40
    write (*,*) 'slu1up test (rows > columns):'
    call stest(m,n)
    write (*,*) 'dlu1up test (rows > columns):'
    call dtest(m,n)
    write (*,*) 'clu1up test (rows > columns):'
    call ctest(m,n)
    write (*,*) 'zlu1up test (rows > columns):'
    call ztest(m,n)

    m = 40
    n = 60
    write (*,*) 'slu1up test (rows < columns):'
    call stest(m,n)
    write (*,*) 'dlu1up test (rows < columns):'
    call dtest(m,n)
    write (*,*) 'clu1up test (rows < columns):'
    call ctest(m,n)
    write (*,*) 'zlu1up test (rows < columns):'
    call ztest(m,n)

    call pstats
end program

subroutine stest(m,n)
    use iso_fortran_env
    integer m,n
    real(real32) A(m,n),L(m,min(m,n)),R(min(m,n),n),u(m),v(n)
    external srandg,slugen,sger,slu1up,sluchk
    integer k
    ! set up random matrix & vectors
    call srandg(m,n,A,m)
    call srandg(m,1,u,m)
    call srandg(n,1,v,n)
    k = min(m,n)
    ! generate LU decomposition
    call slugen(m,n,A,m,L,m,R,k)
    ! update A
    call sger(m,n,1e0,u,1,v,1,A,m)
    ! update the LU decomposition
    call slu1up(m,n,L,m,R,k,u,v)
    ! check result
    call sluchk(m,n,A,m,L,m,R,k)

end subroutine

subroutine dtest(m,n)
    use iso_fortran_env
    integer m,n
    real(real64) A(m,n),L(m,min(m,n)),R(min(m,n),n),u(m),v(n)
    external drandg,dlugen,dger,dlu1up,dluchk
    integer k
    ! set up random matrix & vectors
    call drandg(m,n,A,m)
    call drandg(m,1,u,m)
    call drandg(n,1,v,n)
    k = min(m,n)
    ! generate LU decomposition
    call dlugen(m,n,A,m,L,m,R,k)
    ! update A
    call dger(m,n,1d0,u,1,v,1,A,m)
    ! update the LU decomposition
    call dlu1up(m,n,L,m,R,k,u,v)
    ! check result
    call dluchk(m,n,A,m,L,m,R,k)

end subroutine

subroutine ctest(m,n)
    use iso_fortran_env
    integer m,n
    complex(real32) A(m,n),L(m,min(m,n)),R(min(m,n),n),u(m),v(n)
    external crandg,clugen,cgeru,clu1up,cluchk
    integer k
    ! set up random matrix & vectors
    call crandg(m,n,A,m)
    call crandg(m,1,u,m)
    call crandg(n,1,v,n)
    k = min(m,n)
    ! generate LU decomposition
    call clugen(m,n,A,m,L,m,R,k)
    ! update A
    call cgeru(m,n,(1e0,0e0),u,1,v,1,A,m)
    ! update the LU decomposition
    call clu1up(m,n,L,m,R,k,u,v)
    ! check result
    call cluchk(m,n,A,m,L,m,R,k)

end subroutine

subroutine ztest(m,n)
    use iso_fortran_env
    integer m,n
    complex(real64) A(m,n),L(m,min(m,n)),R(min(m,n),n),u(m),v(n)
    external zrandg,zlugen,zgeru,zlu1up,zluchk
    integer k
    ! set up random matrix & vectors
    call zrandg(m,n,A,m)
    call zrandg(m,1,u,m)
    call zrandg(n,1,v,n)
    k = min(m,n)
    ! generate LU decomposition
    call zlugen(m,n,A,m,L,m,R,k)
    ! update A
    call zgeru(m,n,(1d0,0d0),u,1,v,1,A,m)
    ! update the LU decomposition
    call zlu1up(m,n,L,m,R,k,u,v)
    ! check result
    call zluchk(m,n,A,m,L,m,R,k)

    END

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
!> \brief Performs scaled conjugate vector addition.
!>
!> \par Definition:
! =============
!> \verbatim
!>       subroutine caxcpy(n,a,x,incx,y,incy)
!>
!>       .. Scalar Arguments ..
!>       integer            n, incx, incy
!>       ..
!>       .. Array Arguments ..
!>       complex            a, x(*), y(*)
!>       ..
!> \endverbatim
!>
!> \par Purpose:
! =============
!> \verbatim
!>
!> CAXCPY performs the operation y := y + a * conjg(x), where a is a
!> complex scalar, x is a vector of length n, conjg(x) denotes the
!> element-wise complex conjugate of x, and y is a vector of the same
!> length.  On entry, y contains the existing values; on exit, y is
!> overwritten with the result.  This is the complex analogue of the
!> BLAS caxpy, with the x argument conjugated before scaling.
!> \endverbatim
!>
!> \param[in] n
!> \verbatim
!>          n is INTEGER
!>          The number of elements in vectors x and y.  If n <= 0,
!>          the subroutine returns immediately without modification.
!> \endverbatim
!>
!> \param[in] a
!> \verbatim
!>          a is COMPLEX
!>          The complex scalar used to scale the conjugated vector
!>          conjg(x) before accumulation into y.
!> \endverbatim
!>
!> \param[in] x
!> \verbatim
!>          x is COMPLEX array, dimension (*)
!>          The vector whose complex conjugate is scaled by a and
!>          added to y.  x is not modified.
!> \endverbatim
!>
!> \param[in] incx
!> \verbatim
!>          incx is INTEGER
!>          The stride (increment) for elements of x.  If incx > 0,
!>          elements are accessed starting from x(1); if incx < 0,
!>          elements are accessed starting from
!>          x(1 + (-n+1)*incx).  A value of 1 accesses
!>          contiguous elements.
!> \endverbatim
!>
!> \param[in,out] y
!> \verbatim
!>          y is COMPLEX array, dimension (*)
!>          On entry, the vector y of length n.  On exit, y is
!>          overwritten with y + a * conjg(x).
!> \endverbatim
!>
!> \param[in] incy
!> \verbatim
!>          incy is INTEGER
!>          The stride (increment) for elements of y.  If incy > 0,
!>          elements are accessed starting from y(1); if incy < 0,
!>          elements are accessed starting from
!>          y(1 + (-n+1)*incy).  A value of 1 accesses
!>          contiguous elements.
!> \endverbatim
!> \ingroup aux
subroutine caxcpy(n,a,x,incx,y,incy)
    use iso_fortran_env
    integer, intent(in) :: n, incx, incy
    complex(real32), intent(in) :: a, x(*)
    complex(real32), intent(inout) :: y(*)
    integer i,ix,iy
    ! quick return if possible.
    if (n <= 0) return
    if (incx /= 1 .or. incy /= 1) then
        ! code for unequal increments or equal increments not equal to 1
        ix = 1
        iy = 1
        if (incx.lt.0) ix = (-n+1)*incx + 1
        if (incy.lt.0) iy = (-n+1)*incy + 1
        do i = 1,n
            y(iy) = y(iy) + a*conjg(x(ix))
            ix = ix + incx
            iy = iy + incy
        end do
    else
        ! code for both increments equal to 1
        do i = 1,n
            y(i) = y(i) + a*conjg(x(i))
        end do
    end if
end subroutine

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
!> \brief Updates a QR factorization after deleting a column.
!>
!> \par Definition:
! =============
!> \verbatim
!>       subroutine cqrdec(m,n,k,Q,ldq,R,ldr,j,rw)
!>
!>       .. Scalar Arguments ..
!>       integer             m, n, k, ldq, ldr, j
!>       ..
!>       .. Array Arguments ..
!>       complex             Q(ldq,*)
!>       complex             R(ldr,*)
!>       real                rw(*)
!>       ..
!> \endverbatim
!>
!> \par Purpose:
! =============
!> \verbatim
!>
!> CQRDEC updates a QR factorization after deleting a column. i.e.,
!> given an m-by-k unitary matrix Q, an k-by-n upper trapezoidal matrix
!> R and index j in the range 1:n+1, CQRDEC updates the matrix
!> Q -> Q1 and R -> R1 so that Q1 remains unitary, R1 is upper
!> trapezoidal, and Q1*R1 = [A(:,1:j-1) A(:,j+1:n)], where A = Q*R.
!> (complex version)
!> \endverbatim
!>
!> \param[in] m
!> \verbatim
!>          m is INTEGER
!>          The number of rows of the matrix Q.  m >= 0.
!> \endverbatim
!>
!> \param[in] n
!> \verbatim
!>          n is INTEGER
!>          The number of columns of the matrix R.  n >= 0.
!> \endverbatim
!>
!> \param[in] k
!> \verbatim
!>          k is INTEGER
!>          The number of columns of Q, and rows of R.  Must be
!>          (full Q) or k = n < m (economical form, basis dimension will
!>          decrease).
!> \endverbatim
!>
!> \param[in,out] Q
!> \verbatim
!>          Q is COMPLEX array, dimension (ldq,*)
!>          On entry, the unitary m-by-k matrix Q.  On exit,
!>          the updated matrix Q1.
!> \endverbatim
!>
!> \param[in] ldq
!> \verbatim
!>          ldq is INTEGER
!>          The leading dimension of Q.  ldq >= m.
!> \endverbatim
!>
!> \param[in,out] R
!> \verbatim
!>          R is COMPLEX array, dimension (ldr,*)
!>          On entry, the original matrix R.  On exit, the
!>          updated matrix R1.
!> \endverbatim
!>
!> \param[in] ldr
!> \verbatim
!>          ldr is INTEGER
!>          The leading dimension of R.  ldr >= k.
!> \endverbatim
!>
!> \param[in] j
!> \verbatim
!>          j is INTEGER
!>          The position of the deleted column in R.  1 <= j <= n.
!> \endverbatim
!>
!> \param[out] rw
!> \verbatim
!>          rw is REAL array, dimension (*)
!>          A real workspace vector of size k-j.
!> \endverbatim
!>
!> \ingroup qrdecomp
subroutine cqrdec(m,n,k,Q,ldq,R,ldr,j,rw)
    use iso_fortran_env
    use qrupdate_error
    integer, intent(in) :: m, n, k, ldq, ldr, j
    complex(real32), intent(inout) :: Q(ldq,*)
    complex(real32), intent(inout) :: R(ldr,*)
    real(real32), intent(out) :: rw(*)
    external ccopy,cqhqr,cqrot
    integer info,i
    ! quick return if possible.
    if (m == 0 .or. n == 0 .or. j == n) return
    ! check arguments.
    info = 0
    if (m < 0) then
        info = 1
    else if (n < 0) then
        info = 2
    else if (k /= m .and. (k /= n .or. n >= m)) then
        info = 3
    else if (ldq < m) then
        info = 5
    else if (ldr < k) then
        info = 7
    else if (j < 1 .or. j > n+1) then
        info = 8
    end if
    if (info /= 0) then
        call qrupdate_xerror('CQRDEC',info)
        return
    end if
    ! delete the j-th column.
    do i = j,n-1
        call ccopy(k,R(1,i+1),1,R(1,i),1)
    end do
    ! retriangularize.
    if (j < k) then
        call cqhqr(k+1-j,n-j,R(j,j),ldr,rw,R(1,n))
        ! apply rotations to Q.
        call cqrot('F',m,min(k,n)+1-j,Q(1,j),ldq,rw,R(1,n))
    end if
end subroutine

! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
!> \brief ZDOTC Complex dot product (x**H y version)
!
!> \par  Definition:
!  ===========
!> \verbatim
!>       SUBROUTINE QRUPDATE_ZDOTC(RET, N,CX,INCX,CY,INCY)
!>
!>       .. Scalar Arguments ..
!>       INTEGER INCX,INCY,N
!>       COMPLEX(real64) ret
!>       ..
!>       .. Array Arguments ..
!>       COMPLEX(real64) CX(*),CY(*)
!>       ..
!> \endverbatim
!
!> \par Purpose:
!  =============
!>
!> \verbatim
!>
!> ZDOTC forms the dot product of two complex vectors
!>      ZDOTC = X^H * Y
!>
!> \endverbatim
!
!  Arguments:
!  ==========
!
!> \param[out] RET
!> \verbatim
!>         RET is COMPLEX(real64)
!>         RET contains the dot product.
!> \endverbatim
!>
!> \param[in] N
!> \verbatim
!>         N is INTEGER
!>         number of elements in input vector(s)
!> \endverbatim
!>
!> \param[in] CX
!> \verbatim
!>          CX is COMPLEX(real64) array, dimension ( 1 + ( N - 1 )*abs( INCX ) )
!> \endverbatim
!>
!> \param[in] INCX
!> \verbatim
!>         INCX is INTEGER
!>         storage spacing between elements of CX
!> \endverbatim
!>
!> \param[in] CY
!> \verbatim
!>          CY is COMPLEX(real64) array, dimension ( 1 + ( N - 1 )*abs( INCY ) )
!> \endverbatim
!>
!> \param[in] INCY
!> \verbatim
!>         INCY is INTEGER
!>         storage spacing between elements of CY
!> \endverbatim
!
!> \remark This routine is equivalent to zdotc from BLAS but invariant with the compiler's Fortran ABI
!
!> \ingroup aux
!  =====================================================================
subroutine qrupdate_zdotc(ret,n,cx,incx,cy,incy)
    use iso_fortran_env
    implicit none

    !     .. scalar arguments ..
    integer, intent(in) :: incx,incy,n
    !     ..
    !     .. array arguments ..
    complex(real64), intent(in) :: cx(*),cy(*)
    complex(real64), intent(out) :: ret
    !     ..
    !
    !     .. local scalars ..
    complex(real64) ctemp
    integer i,ix,iy
    !     ..
    ctemp = (0.0,0.0)
    ret = (0.0,0.0)
    if (n.le.0) return
    if (incx.eq.1 .and. incy.eq.1) then
        !
        !        code for both increments equal to 1
        !
        do i = 1,n
            ctemp = ctemp + conjg(cx(i))*cy(i)
        end do
    else
        !
        !        code for unequal increments or equal increments
        !          not equal to 1
        !
        ix = 1
        iy = 1
        if (incx.lt.0) ix = (-n+1)*incx + 1
        if (incy.lt.0) iy = (-n+1)*incy + 1
        do i = 1,n
            ctemp = ctemp + conjg(cx(ix))*cy(iy)
            ix = ix + incx
            iy = iy + incy
        end do
    end if
    ret = ctemp
    return
    !
    !     end of zdotc
    !
end subroutine

! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!

!
! This module contains the (c/z)dot(u/c) replacements to obtain a
! Fortran (gfortran/flang) ABI invariant implementation.
! Furthermore, I provides the interface to LAPACK's xerbla.
!
module qrupdate_blas
    use iso_fortran_env
    implicit none

    interface
        subroutine qrupdate_cdotc(ret,n,cx,incx,cy,incy)
            use iso_fortran_env
            integer, intent(in) :: incx, incy, n
            complex(real32), intent(in) :: cx(*),cy(*)
            complex(real32), intent(out) :: ret
        end subroutine qrupdate_cdotc
    end interface

    interface
        subroutine qrupdate_cdotu(ret,n,cx,incx,cy,incy)
            use iso_fortran_env
            integer, intent(in) :: incx, incy, n
            complex(real32), intent(in) :: cx(*),cy(*)
            complex(real32), intent(out) :: ret
        end subroutine qrupdate_cdotu
    end interface

    interface
        subroutine qrupdate_zdotc(ret,n,cx,incx,cy,incy)
            use iso_fortran_env
            integer, intent(in) :: incx, incy, n
            complex(real64), intent(in) :: cx(*),cy(*)
            complex(real64), intent(out) :: ret
        end subroutine qrupdate_zdotc
    end interface

    interface
        subroutine qrupdate_zdotu(ret,n,cx,incx,cy,incy)
            use iso_fortran_env
            integer, intent(in) :: incx, incy, n
            complex(real64), intent(in) :: cx(*),cy(*)
            complex(real64), intent(out) :: ret
        end subroutine qrupdate_zdotu
    end interface

    interface
        subroutine xerbla( srname, info )
            character*(*), intent(in) :: srname
            integer, intent(in) ::  info
        end subroutine
    end interface

contains

    function lsame( ca, cb )
        character, intent(in) :: ca, cb
        logical :: lsame
        integer :: inta, intb, zcode

        lsame = ca == cb
        if ( lsame ) return

        zcode = ichar( 'Z' )
        inta = ichar( ca )
        intb = ichar( cb )

        if ( zcode == 90 .or. zcode == 122 ) then
            ! ASCII
            if ( inta >= 97 .and. inta <= 122 ) inta = inta - 32
            if ( intb >= 97 .and. intb <= 122 ) intb = intb - 32
        else if ( zcode == 233 .or. zcode == 169 ) then
            ! EBCDIC
            if ( ( inta >= 129 .and. inta <= 137 ) .or. &
                 ( inta >= 145 .and. inta <= 153 ) .or. &
                 ( inta >= 162 .and. inta <= 169 ) ) inta = inta + 64
            if ( ( intb >= 129 .and. intb <= 137 ) .or. &
                 ( intb >= 145 .and. intb <= 153 ) .or. &
                 ( intb >= 162 .and. intb <= 169 ) ) intb = intb + 64
        else if ( zcode == 218 .or. zcode == 250 ) then
            ! ASCII on Prime machines
            if ( inta >= 225 .and. inta <= 250 ) inta = inta - 32
            if ( intb >= 225 .and. intb <= 250 ) intb = intb - 32
        end if

        lsame = inta == intb
    end function lsame

end module qrupdate_blas

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
!> \brief Updates a QR factorization after a rank-1 modification.
!>
!> \par Definition:
! =============
!> \verbatim
!>       subroutine cqr1up(m,n,k,Q,ldq,R,ldr,u,v,w,rw)
!>
!>       .. Scalar Arguments ..
!>       integer             m, n, k, ldq, ldr
!>       ..
!>       .. Array Arguments ..
!>       complex             Q(ldq,*)
!>       complex             R(ldr,*)
!>       complex             u(*)
!>       complex             v(*)
!>       complex             w(*)
!>       real                rw(*)
!>       ..
!> \endverbatim
!>
!> \par Purpose:
! =============
!> \verbatim
!>
!> CQR1UP updates a QR factorization after rank-1 modification i.e.,
!> given a m-by-k unitary Q and m-by-n upper trapezoidal R, an m-vector
!> u and n-vector v, CQR1UP updates Q -> Q1 and R -> R1 so that
!> Q1*R1 = Q*R + u*v', and Q1 is again unitary and R1 upper trapezoidal.
!> (complex version)
!> \endverbatim
!>
!> \param[in] m
!> \verbatim
!>          m is INTEGER
!>          The number of rows of the matrix Q.  m >= 0.
!> \endverbatim
!>
!> \param[in] n
!> \verbatim
!>          n is INTEGER
!>          The number of columns of the matrix R.  n >= 0.
!> \endverbatim
!>
!> \param[in] k
!> \verbatim
!>          k is INTEGER
!>          The number of columns of Q, and rows of R.  Must be
!>          either k = m (full Q) or k = n < m (economical form).
!> \endverbatim
!>
!> \param[in,out] Q
!> \verbatim
!>          Q is COMPLEX array, dimension (ldq,*)
!>          On entry, the unitary m-by-k matrix Q.  On exit,
!>          the updated matrix Q1.
!> \endverbatim
!>
!> \param[in] ldq
!> \verbatim
!>          ldq is INTEGER
!>          The leading dimension of Q.  ldq >= m.
!> \endverbatim
!>
!> \param[in,out] R
!> \verbatim
!>          R is COMPLEX array, dimension (ldr,*)
!>          On entry, the upper trapezoidal m-by-n matrix R.  On
!>          exit, the updated matrix R1.
!> \endverbatim
!>
!> \param[in] ldr
!> \verbatim
!>          ldr is INTEGER
!>          The leading dimension of R.  ldr >= k.
!> \endverbatim
!>
!> \param[in,out] u
!> \verbatim
!>          u is COMPLEX array, dimension (*)
!>          On entry, the left m-vector.  On exit, if k < m,
!>          u is destroyed.
!> \endverbatim
!>
!> \param[in,out] v
!> \verbatim
!>          v is COMPLEX array, dimension (*)
!>          On entry, the right n-vector.  On exit, v is
!>          destroyed.
!> \endverbatim
!>
!> \param[out] w
!> \verbatim
!>          w is COMPLEX array, dimension (*)
!>          A workspace vector of size k.
!> \endverbatim
!>
!> \param[out] rw
!> \verbatim
!>          rw is REAL array, dimension (*)
!>          A real workspace vector of size k.
!> \endverbatim
!>
!> \ingroup qrdecomp
subroutine cqr1up(m,n,k,Q,ldq,R,ldr,u,v,w,rw)
    use iso_fortran_env
    use qrupdate_blas
    use qrupdate_error
    integer, intent(in) :: m, n, k, ldq, ldr
    complex(real32), intent(inout) :: Q(ldq,*)
    complex(real32), intent(inout) :: R(ldr,*)
    complex(real32), intent(inout) :: u(*)
    complex(real32), intent(inout) :: v(*)
    complex(real32), intent(out) :: w(*)
    real(real32), intent(out) :: rw(*)
    external  cch1up, cqrqh,cqhqr,cqrot,cqrtv1,caxcpy
    external caxpy,scnrm2,slamch,csscal,crot
    real(real32) scnrm2,slamch,ru,ruu
    integer info,i
    logical full
    ! quick return if possible.
    if (k == 0 .or. n == 0) return
    ! check arguments.
    info = 0
    if (m < 0) then
        info = 1
    else if (n < 0) then
        info = 2
    else if (k /= m .and. (k /= n .or. n > m)) then
        info = 3
    else if (ldq < m) then
        info = 5
    else if (ldr < k) then
        info = 7
    endif
    if (info /= 0) then
        call qrupdate_xerror('CQR1UP',info)
        return
    end if
    full = k == m
    ru = 1.0
    ! in the non-full case, we shall need the norm of u.
    if (.not.full) ru = scnrm2(m,u,1)
    ! form Q'*u. In the non-full case, form also u - Q*Q'u.
    do i = 1,k
        call qrupdate_cdotc(w(i), m,Q(1,i),1,u,1)
        if (.not.full) call caxpy(m,-w(i),Q(1,i),1,u,1)
    end do
    ! generate rotations to eliminate Q'*u.
    call cqrtv1(k,w,rw)
    ! apply rotations to R.
    call cqrqh(k,n,R,ldr,rw,w(2))
    ! apply rotations to Q.
    call cqrot('B',m,k,Q,ldq,rw,w(2))
    ! update the first row of R.
    call caxcpy(n,w(1),v,1,R(1,1),ldr)
    ! retriangularize R.
    call cqhqr(k,n,R,ldr,rw,w)
    ! apply rotations to Q.
    call cqrot('F',m,min(k,n+1),Q,ldq,rw,w)
    ! in the full case, we're finished
    if (full) return
    ! compute relative residual norm
    ruu = scnrm2(m,u,1)
    ru = ru * slamch('e')
    if (ruu <= ru) return
    ! update the orthogonal basis.
    call csscal(n,ruu,v,1)
    call csscal(m,1e0/ruu,u,1)
    call cch1up(n,R,ldr,v,rw)
    do i = 1,n
        call crot(m,Q(1,i),1,u,1,rw(i),conjg(v(i)))
    end do
end subroutine

! Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic, Jaroslav Hajek <highegg@gmail.com>
! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
!> \brief Updates a QR factorization after inserting a new row.
!>
!> \par Definition:
! =============
!> \verbatim
!>       subroutine sqrinr(m,n,Q,ldq,R,ldr,j,x,w)
!>
!>       .. Scalar Arguments ..
!>       integer             m, n, ldq, ldr, j
!>       ..
!>       .. Array Arguments ..
!>       real                Q(ldq,*)
!>       real                R(ldr,*)
!>       real                x(*)
!>       real                w(*)
!>       ..
!> \endverbatim
!>
!> \par Purpose:
! =============
!> \verbatim
!>
!> SQRINR updates a QR factorization after inserting a new row. i.e.,
!> given an m-by-m orthogonal matrix Q, an m-by-n upper trapezoidal
!> matrix R and index j in the range 1:m+1, SQRINR updates Q ->
!> Q1 and R -> R1 so that Q1 is again orthogonal, R1 upper trapezoidal,
!> and Q1*R1 = [A(1:j-1,:); x; A(j:m,:)], where A = Q*R. (real version)
!> \endverbatim
!>
!> \param[in] m
!> \verbatim
!>          m is INTEGER
!>          The number of rows of the matrix Q.  m >= 0.
!> \endverbatim
!>
!> \param[in] n
!> \verbatim
!>          n is INTEGER
!>          The number of columns of the matrix R.  n >= 0.
!> \endverbatim
!>
!> \param[in,out] Q
!> \verbatim
!>          Q is REAL array, dimension (ldq,*)
!>          On entry, the orthogonal matrix Q.  On exit, the
!>          updated matrix Q1.
!> \endverbatim
!>
!> \param[in] ldq
!> \verbatim
!>          ldq is INTEGER
!>          The leading dimension of Q.  ldq >= m+1.
!> \endverbatim
!>
!> \param[in,out] R
!> \verbatim
!>          R is REAL array, dimension (ldr,*)
!>          On entry, the original matrix R.  On exit, the
!>          updated matrix R1.
!> \endverbatim
!>
!> \param[in] ldr
!> \verbatim
!>          ldr is INTEGER
!>          The leading dimension of R.  ldr >= m+1.
!> \endverbatim
!>
!> \param[in] j
!> \verbatim
!>          j is INTEGER
!>          The position of the new row in R1.  1 <= j <= m+1.
!> \endverbatim
!>
!> \param[in,out] x
!> \verbatim
!>          x is REAL array, dimension (*)
!>          On entry, the row being added.  On exit, x is
!> \endverbatim
!>
!> \param[out] w
!> \verbatim
!>          w is REAL array, dimension (*)
!>          A workspace vector of size min(m,n).
!> \endverbatim
!>
!> \ingroup qrdecomp
subroutine sqrinr(m,n,Q,ldq,R,ldr,j,x,w)
    use iso_fortran_env
    use qrupdate_error
    integer, intent(in) :: m, n, j, ldq, ldr
    real(real32), intent(inout) :: Q(ldq,*), R(ldr,*)
    real(real32), intent(inout) :: x(*)
    real(real32), intent(out) :: w(*)
    external scopy,sqhqr,sqrot
    integer info,i,k
    ! check arguments
    info = 0
    if (n < 0) then
        info = 2
    else if (j < 1 .or. j > m+1) then
        info = 7
    end if
    if (info /= 0) then
        call qrupdate_xerror('SQRINR',info)
        return
    end if
    ! permute the columns of Q1 and rows of R1 so that c the new row ends
    ! up being the topmost row of R1.
    do i = m,1,-1
        if (j > 1) then
            call scopy(j-1,Q(1,i),1,Q(1,i+1),1)
        end if
        Q(j,i+1) = 0e0
        if (j <= m) then
            call scopy(m+1-j,Q(j,i),1,Q(j+1,i+1),1)
        end if
    end do
    ! set up the 1st column
    do i = 1,j-1
        Q(i,1) = 0e0
    end do
    Q(j,1) = 1e0
    do i = j+1,m+1
        Q(i,1) = 0e0
    end do
    ! set up the new matrix R1
    do k = 1,n
        if (k < m) R(m+1,k) = 0e0
        do i = min(m,k),1,-1
            R(i+1,k) = R(i,k)
        end do
        R(1,k) = x(k)
    end do
    ! retriangularize R
    call sqhqr(m+1,n,R,ldr,w,x)
    ! apply rotations to Q
    call sqrot('F',m+1,min(m,n)+1,Q,ldq,w,x)
end subroutine

! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
!> \brief Tests input validation (qrupdate_xerror) for all qrupdate functions.
program test_qrupdate_validation
    use iso_fortran_env
    use qrupdate_error
    use test_state
    implicit none

    integer, parameter :: n = 5
    external sch1dn, dch1dn, cch1dn, zch1dn
    external schdex, dchdex, cchdex, zchdex
    external schinx, dchinx, cchinx, zchinx
    external schshx, dchshx, cchshx, zchshx
    external slu1up, dlu1up, clu1up, zlu1up
    external slup1up, dlup1up, clup1up, zlup1up
    external sqr1up, dqr1up, cqr1up, zqr1up
    external sqrdec, dqrdec, cqrdec, zqrdec
    external sqrder, dqrder, cqrder, zqrder
    external sqrinc, dqrinc, cqrinc, zqrinc
    external sqrinr, dqrinr, cqrinr, zqrinr
    external sqrshc, dqrshc, cqrshc, zqrshc
    external sqrot, dqrot, cqrot, zqrot
    external sqhqr, dqhqr, cqhqr, zqhqr
    external sqrqh, dqrqh, cqrqh, zqrqh
    external sgqvec, dgqvec, cgqvec, zgqvec

    integer :: info
    real(real32) :: R_s(n,n), u_s(n), w_s(n), rw_s(n)
    real(real64) :: R_d(n,n), u_d(n), w_d(n), rw_d(n)
    complex(real32) :: R_c(n,n), u_c(n), rw_c(n)
    complex(real32) :: R_z(n,n), u_z(n), rw_z(n)
    real(real32) :: Q_s(n,n), c_s(n-1), s_s(n-1), rhs_s(n)
    real(real64) :: Q_d(n,n), c_d(n-1), s_d(n-1), rhs_d(n)
    complex(real32) :: Q_c(n,n), Q_z(n,n), rhs_c(n), rhs_z(n)
    real(real32) :: c_c(n-1), c_z(n-1)
    complex(real32) :: s_c(n-1), s_z(n-1)
    real(real32) :: L_s(n,n), v_s(n), wv_s(n)
    real(real64) :: L_d(n,n), v_d(n), wv_d(n)
    complex(real32) :: L_c(n,n), v_c(n), wv_c(n), L_z(n,n), v_z(n), wv_z(n)
    real(real32) :: p_s(n), p2_s(n)
    real(real64) :: p_d(n), p2_d(n)
    complex(real32) :: p_c(n), p2_c(n), p_z(n), p2_z(n)
    real(real32) :: x_s(n), x_d(n), x_c(n), x_z(n)
    character(len=1) :: dir
    procedure(error_handler_if), pointer :: p_handler

    print *, 'Testing input validation for all qrupdate functions...'

    ! Initialize arrays to avoid undefined values
    R_s = 0; u_s = 0; w_s = 0; rw_s = 0
    R_d = 0; u_d = 0; w_d = 0; rw_d = 0
    R_c = 0; u_c = 0; rw_c = 0
    R_z = 0; u_z = 0; rw_z = 0
    Q_s = 0; c_s = 0; s_s = 0; rhs_s = 0
    Q_d = 0; c_d = 0; s_d = 0; rhs_d = 0
    Q_c = 0; c_c = 0; s_c = 0; rhs_c = 0
    Q_z = 0; c_z = 0; s_z = 0; rhs_z = 0
    L_s = 0; v_s = 0; wv_s = 0
    L_d = 0; v_d = 0; wv_d = 0
    L_c = 0; v_c = 0; wv_c = 0
    L_z = 0; v_z = 0; wv_z = 0
    p_s = 0; p2_s = 0; p_d = 0; p2_d = 0
    p_c = 0; p2_c = 0; p_z = 0; p2_z = 0
    x_s = 0; x_d = 0; x_c = 0; x_z = 0

    p_handler => pxerbla
    call qrupdate_set_error(p_handler)

    ! ====== Cholesky downdate ======
    ! sch1dn(n,R,ldr,u,w,info): validates n>=0, ldr>=n (negates info before xerror)
    call reset()
    call sch1dn(-1, R_s, n, u_s, w_s, info)
    call check_error('SCH1DN', 1)
    call reset()
    call sch1dn(n, R_s, n-1, u_s, w_s, info)
    call check_error('SCH1DN', 3)
    call reset()
    call dch1dn(-1, R_d, n, u_d, w_d, info)
    call check_error('DCH1DN', 1)
    call reset()
    call dch1dn(n, R_d, n-1, u_d, w_d, info)
    call check_error('DCH1DN', 3)
    call reset()
    call cch1dn(-1, R_c, n, u_c, rw_c, info)
    call check_error('CCH1DN', 1)
    call reset()
    call cch1dn(n, R_c, n-1, u_c, rw_c, info)
    call check_error('CCH1DN', 3)
    call reset()
    call zch1dn(-1, R_z, n, u_z, rw_z, info)
    call check_error('ZCH1DN', 1)
    call reset()
    call zch1dn(n, R_z, n-1, u_z, rw_z, info)
    call check_error('ZCH1DN', 3)

    ! ====== Cholesky delete ======
    ! schdex(n,R,ldr,j,w): validates n>=0, j in [1,n]
    call reset()
    call schdex(-1, R_s, n, 1, w_s)
    call check_error('SCHDEX', 1)
    call reset()
    call schdex(n, R_s, n, 0, w_s)
    call check_error('SCHDEX', 4)
    call reset()
    call dchdex(-1, R_d, n, 1, w_d)
    call check_error('DCHDEX', 1)
    call reset()
    call dchdex(n, R_d, n, 0, w_d)
    call check_error('DCHDEX', 4)
    call reset()
    call cchdex(-1, R_c, n, 1, rw_c)
    call check_error('CCHDEX', 1)
    call reset()
    call cchdex(n, R_c, n, 0, rw_c)
    call check_error('CCHDEX', 4)
    call reset()
    call zchdex(-1, R_z, n, 1, rw_z)
    call check_error('ZCHDEX', 1)
    call reset()
    call zchdex(n, R_z, n, 0, rw_z)
    call check_error('ZCHDEX', 4)

    ! ====== Cholesky insert ======
    ! schinx(n,R,ldr,j,u,w,info): validates n>=0, j in [1,n+1] (passes info directly)
    ! dchinx uses -info before xerror, others pass info directly
    call reset()
    call schinx(-1, R_s, n, 1, u_s, w_s, info)
    call check_error('SCHINX', -1)
    call reset()
    call schinx(n, R_s, n, 0, u_s, w_s, info)
    call check_error('SCHINX', -4)
    call reset()
    call dchinx(-1, R_d, n, 1, u_d, w_d, info)
    call check_error('DCHINX', 1)
    call reset()
    call dchinx(n, R_d, n, 0, u_d, w_d, info)
    call check_error('DCHINX', 4)
    call reset()
    call cchinx(-1, R_c, n, 1, u_c, rw_c, info)
    call check_error('CCHINX', -1)
    call reset()
    call cchinx(n, R_c, n, 0, u_c, rw_c, info)
    call check_error('CCHINX', -4)
    call reset()
    call zchinx(-1, R_z, n, 1, u_z, rw_z, info)
    call check_error('ZCHINX', -1)
    call reset()
    call zchinx(n, R_z, n, 0, u_z, rw_z, info)
    call check_error('ZCHINX', -4)

    ! ====== Cholesky shift ======
    ! schshx(n,R,ldr,i,j,w): validates n>=0, i in [1,n], j in [1,n]
    call reset()
    call schshx(-1, R_s, n, 1, 1, w_s)
    call check_error('SCHSHX', 1)
    call reset()
    call schshx(n, R_s, n, 0, 1, w_s)
    call check_error('SCHSHX', 4)
    call reset()
    call schshx(n, R_s, n, 1, 0, w_s)
    call check_error('SCHSHX', 5)
    call reset()
    call dchshx(-1, R_d, n, 1, 1, w_d)
    call check_error('DCHSHX', 1)
    call reset()
    call dchshx(n, R_d, n, 0, 1, w_d)
    call check_error('DCHSHX', 4)
    call reset()
    call dchshx(n, R_d, n, 1, 0, w_d)
    call check_error('DCHSHX', 5)
    call reset()
    call cchshx(-1, R_c, n, 1, 1, rw_s, rw_c)
    call check_error('CCHSHX', 1)
    call reset()
    call cchshx(n, R_c, n, 0, 1, rw_s, rw_c)
    call check_error('CCHSHX', 4)
    call reset()
    call cchshx(n, R_c, n, 1, 0, rw_s, rw_c)
    call check_error('CCHSHX', 5)
    call reset()
    call zchshx(-1, R_z, n, 1, 1, rw_d, rw_z)
    call check_error('ZCHSHX', 1)
    call reset()
    call zchshx(n, R_z, n, 0, 1, rw_d, rw_z)
    call check_error('ZCHSHX', 4)
    call reset()
    call zchshx(n, R_z, n, 1, 0, rw_d, rw_z)
    call check_error('ZCHSHX', 5)

    ! ====== LU rank-1 update ======
    ! slu1up(m,n,L,ldl,R,ldr,u,v): validates m>=0, n>=0, ldl>=m, ldr>=min(m,n)
    call reset()
    call slu1up(-1, n, L_s, n, R_s, n, rhs_s, v_s)
    call check_error('SLU1UP', 1)
    call reset()
    call slu1up(n, -1, L_s, n, R_s, n, rhs_s, v_s)
    call check_error('SLU1UP', 2)
    call reset()
    call slu1up(n, n, L_s, n-1, R_s, n, rhs_s, v_s)
    call check_error('SLU1UP', 4)
    call reset()
    call slu1up(n, n, L_s, n, R_s, n-1, rhs_s, v_s)
    call check_error('SLU1UP', 6)
    call reset()
    call dlu1up(-1, n, L_d, n, R_d, n, rhs_d, v_d)
    call check_error('DLU1UP', 1)
    call reset()
    call dlu1up(n, -1, L_d, n, R_d, n, rhs_d, v_d)
    call check_error('DLU1UP', 2)
    call reset()
    call dlu1up(n, n, L_d, n-1, R_d, n, rhs_d, v_d)
    call check_error('DLU1UP', 4)
    call reset()
    call dlu1up(n, n, L_d, n, R_d, n-1, rhs_d, v_d)
    call check_error('DLU1UP', 6)
    call reset()
    call clu1up(-1, n, L_c, n, R_c, n, rhs_c, v_c)
    call check_error('CLU1UP', 1)
    call reset()
    call clu1up(n, -1, L_c, n, R_c, n, rhs_c, v_c)
    call check_error('CLU1UP', 2)
    call reset()
    call clu1up(n, n, L_c, n-1, R_c, n, rhs_c, v_c)
    call check_error('CLU1UP', 4)
    call reset()
    call clu1up(n, n, L_c, n, R_c, n-1, rhs_c, v_c)
    call check_error('CLU1UP', 6)
    call reset()
    call zlu1up(-1, n, L_z, n, R_z, n, rhs_z, v_z)
    call check_error('ZLU1UP', 1)
    call reset()
    call zlu1up(n, -1, L_z, n, R_z, n, rhs_z, v_z)
    call check_error('ZLU1UP', 2)
    call reset()
    call zlu1up(n, n, L_z, n-1, R_z, n, rhs_z, v_z)
    call check_error('ZLU1UP', 4)
    call reset()
    call zlu1up(n, n, L_z, n, R_z, n-1, rhs_z, v_z)
    call check_error('ZLU1UP', 6)

    ! ====== LU+perm rank-1 update ======
    ! slup1up(m,n,L,ldl,R,ldr,p,u,v,w): validates m>=0, n>=0, ldl>=m, ldr>=min(m,n)
    call reset()
    call slup1up(-1, n, L_s, n, R_s, n, p_s, rhs_s, v_s, wv_s)
    call check_error('SLUP1UP', 1)
    call reset()
    call slup1up(n, -1, L_s, n, R_s, n, p_s, rhs_s, v_s, wv_s)
    call check_error('SLUP1UP', 2)
    call reset()
    call slup1up(n, n, L_s, n-1, R_s, n, p_s, rhs_s, v_s, wv_s)
    call check_error('SLUP1UP', 4)
    call reset()
    call slup1up(n, n, L_s, n, R_s, n-1, p_s, rhs_s, v_s, wv_s)
    call check_error('SLUP1UP', 6)
    call reset()
    call dlup1up(-1, n, L_d, n, R_d, n, p_d, rhs_d, v_d, wv_d)
    call check_error('DLUP1UP', 1)
    call reset()
    call dlup1up(n, -1, L_d, n, R_d, n, p_d, rhs_d, v_d, wv_d)
    call check_error('DLUP1UP', 2)
    call reset()
    call dlup1up(n, n, L_d, n-1, R_d, n, p_d, rhs_d, v_d, wv_d)
    call check_error('DLUP1UP', 4)
    call reset()
    call dlup1up(n, n, L_d, n, R_d, n-1, p_d, rhs_d, v_d, wv_d)
    call check_error('DLUP1UP', 6)
    call reset()
    call clup1up(-1, n, L_c, n, R_c, n, p_c, rhs_c, v_c, wv_s)
    call check_error('CLUP1UP', 1)
    call reset()
    call clup1up(n, -1, L_c, n, R_c, n, p_c, rhs_c, v_c, wv_s)
    call check_error('CLUP1UP', 2)
    call reset()
    call clup1up(n, n, L_c, n-1, R_c, n, p_c, rhs_c, v_c, wv_s)
    call check_error('CLUP1UP', 4)
    call reset()
    call clup1up(n, n, L_c, n, R_c, n-1, p_c, rhs_c, v_c, wv_s)
    call check_error('CLUP1UP', 6)
    call reset()
    call zlup1up(-1, n, L_z, n, R_z, n, p_z, rhs_z, v_z, wv_d)
    call check_error('ZLUP1UP', 1)
    call reset()
    call zlup1up(n, -1, L_z, n, R_z, n, p_z, rhs_z, v_z, wv_d)
    call check_error('ZLUP1UP', 2)
    call reset()
    call zlup1up(n, n, L_z, n-1, R_z, n, p_z, rhs_z, v_z, wv_d)
    call check_error('ZLUP1UP', 4)
    call reset()
    call zlup1up(n, n, L_z, n, R_z, n-1, p_z, rhs_z, v_z, wv_d)
    call check_error('ZLUP1UP', 6)

    ! ====== QR rank-1 update ======
    ! sqr1up(m,n,k,Q,ldq,R,ldr,u,v,w): validates m>=0, n>=0, k valid, ldq>=m, ldr>=k
    call reset()
    call sqr1up(-1, n, n, Q_s, n, R_s, n, rhs_s, v_s, wv_s)
    call check_error('SQR1UP', 1)
    call reset()
    call sqr1up(n, -1, n, Q_s, n, R_s, n, rhs_s, v_s, wv_s)
    call check_error('SQR1UP', 2)
    call reset()
    call sqr1up(n, n, 99, Q_s, n, R_s, n, rhs_s, v_s, wv_s)
    call check_error('SQR1UP', 3)
    call reset()
    call sqr1up(n, n, n, Q_s, n-1, R_s, n, rhs_s, v_s, wv_s)
    call check_error('SQR1UP', 5)
    call reset()
    call sqr1up(n, n, n, Q_s, n, R_s, n-1, rhs_s, v_s, wv_s)
    call check_error('SQR1UP', 7)
    call reset()
    call dqr1up(-1, n, n, Q_d, n, R_d, n, rhs_d, v_d, wv_d)
    call check_error('DQR1UP', 1)
    call reset()
    call dqr1up(n, -1, n, Q_d, n, R_d, n, rhs_d, v_d, wv_d)
    call check_error('DQR1UP', 2)
    call reset()
    call dqr1up(n, n, 99, Q_d, n, R_d, n, rhs_d, v_d, wv_d)
    call check_error('DQR1UP', 3)
    call reset()
    call dqr1up(n, n, n, Q_d, n-1, R_d, n, rhs_d, v_d, wv_d)
    call check_error('DQR1UP', 5)
    call reset()
    call dqr1up(n, n, n, Q_d, n, R_d, n-1, rhs_d, v_d, wv_d)
    call check_error('DQR1UP', 7)
    call reset()
    call cqr1up(-1, n, n, Q_c, n, R_c, n, rhs_c, v_c, wv_s)
    call check_error('CQR1UP', 1)
    call reset()
    call cqr1up(n, -1, n, Q_c, n, R_c, n, rhs_c, v_c, wv_s)
    call check_error('CQR1UP', 2)
    call reset()
    call cqr1up(n, n, 99, Q_c, n, R_c, n, rhs_c, v_c, wv_s)
    call check_error('CQR1UP', 3)
    call reset()
    call cqr1up(n, n, n, Q_c, n-1, R_c, n, rhs_c, v_c, wv_s)
    call check_error('CQR1UP', 5)
    call reset()
    call cqr1up(n, n, n, Q_c, n, R_c, n-1, rhs_c, v_c, wv_s)
    call check_error('CQR1UP', 7)
    call reset()
    call zqr1up(-1, n, n, Q_z, n, R_z, n, rhs_z, v_z, wv_d)
    call check_error('ZQR1UP', 1)
    call reset()
    call zqr1up(n, -1, n, Q_z, n, R_z, n, rhs_z, v_z, wv_d)
    call check_error('ZQR1UP', 2)
    call reset()
    call zqr1up(n, n, 99, Q_z, n, R_z, n, rhs_z, v_z, wv_d)
    call check_error('ZQR1UP', 3)
    call reset()
    call zqr1up(n, n, n, Q_z, n-1, R_z, n, rhs_z, v_z, wv_d)
    call check_error('ZQR1UP', 5)
    call reset()
    call zqr1up(n, n, n, Q_z, n, R_z, n-1, rhs_z, v_z, wv_d)
    call check_error('ZQR1UP', 7)

    ! ====== QR delete (column) ======
    ! sqrdec(m,n,k,Q,ldq,R,ldr,j,w): validates m>=0, n>=0, k valid, ldq>=m, ldr>=k, j in [1,n+1]
    call reset()
    call sqrdec(-1, n, n, Q_s, n, R_s, n, 1, w_s)
    call check_error('SQRDEC', 1)
    call reset()
    call sqrdec(n, -1, n, Q_s, n, R_s, n, 1, w_s)
    call check_error('SQRDEC', 2)
    call reset()
    call sqrdec(n, n, 99, Q_s, n, R_s, n, 1, w_s)
    call check_error('SQRDEC', 3)
    call reset()
    call sqrdec(n, n, n, Q_s, n-1, R_s, n, 1, w_s)
    call check_error('SQRDEC', 5)
    call reset()
    call sqrdec(n, n, n, Q_s, n, R_s, n-1, 1, w_s)
    call check_error('SQRDEC', 7)
    call reset()
    call sqrdec(n, n, n, Q_s, n, R_s, n, 0, w_s)
    call check_error('SQRDEC', 8)
    call reset()
    call dqrdec(-1, n, n, Q_d, n, R_d, n, 1, w_d)
    call check_error('DQRDEC', 1)
    call reset()
    call dqrdec(n, -1, n, Q_d, n, R_d, n, 1, w_d)
    call check_error('DQRDEC', 2)
    call reset()
    call dqrdec(n, n, 99, Q_d, n, R_d, n, 1, w_d)
    call check_error('DQRDEC', 3)
    call reset()
    call dqrdec(n, n, n, Q_d, n-1, R_d, n, 1, w_d)
    call check_error('DQRDEC', 5)
    call reset()
    call dqrdec(n, n, n, Q_d, n, R_d, n-1, 1, w_d)
    call check_error('DQRDEC', 7)
    call reset()
    call dqrdec(n, n, n, Q_d, n, R_d, n, 0, w_d)
    call check_error('DQRDEC', 8)
    call reset()
    call cqrdec(-1, n, n, Q_c, n, R_c, n, 1, rw_c)
    call check_error('CQRDEC', 1)
    call reset()
    call cqrdec(n, -1, n, Q_c, n, R_c, n, 1, rw_c)
    call check_error('CQRDEC', 2)
    call reset()
    call cqrdec(n, n, 99, Q_c, n, R_c, n, 1, rw_c)
    call check_error('CQRDEC', 3)
    call reset()
    call cqrdec(n, n, n, Q_c, n-1, R_c, n, 1, rw_c)
    call check_error('CQRDEC', 5)
    call reset()
    call cqrdec(n, n, n, Q_c, n, R_c, n-1, 1, rw_c)
    call check_error('CQRDEC', 7)
    call reset()
    call cqrdec(n, n, n, Q_c, n, R_c, n, 0, rw_c)
    call check_error('CQRDEC', 8)
    call reset()
    call zqrdec(-1, n, n, Q_z, n, R_z, n, 1, rw_z)
    call check_error('ZQRDEC', 1)
    call reset()
    call zqrdec(n, -1, n, Q_z, n, R_z, n, 1, rw_z)
    call check_error('ZQRDEC', 2)
    call reset()
    call zqrdec(n, n, 99, Q_z, n, R_z, n, 1, rw_z)
    call check_error('ZQRDEC', 3)
    call reset()
    call zqrdec(n, n, n, Q_z, n-1, R_z, n, 1, rw_z)
    call check_error('ZQRDEC', 5)
    call reset()
    call zqrdec(n, n, n, Q_z, n, R_z, n-1, 1, rw_z)
    call check_error('ZQRDEC', 7)
    call reset()
    call zqrdec(n, n, n, Q_z, n, R_z, n, 0, rw_z)
    call check_error('ZQRDEC', 8)

    ! ====== QR delete (row) ======
    ! sqrder(m,n,Q,ldq,R,ldr,j,w): validates m>=1, j in [1,m]
    call reset()
    call sqrder(0, n, Q_s, n, R_s, n, 1, w_s)
    call check_error('SQRDER', 1)
    call reset()
    call sqrder(n, n, Q_s, n, R_s, n, 0, w_s)
    call check_error('SQRDER', 7)
    call reset()
    call dqrder(0, n, Q_d, n, R_d, n, 1, w_d)
    call check_error('DQRDER', 1)
    call reset()
    call dqrder(n, n, Q_d, n, R_d, n, 0, w_d)
    call check_error('DQRDER', 7)
    call reset()
    call cqrder(0, n, Q_c, n, R_c, n, 1, rw_c)
    call check_error('CQRDER', 1)
    call reset()
    call cqrder(n, n, Q_c, n, R_c, n, 0, rw_c)
    call check_error('CQRDER', 7)
    call reset()
    call zqrder(0, n, Q_z, n, R_z, n, 1, rw_z)
    call check_error('ZQRDER', 1)
    call reset()
    call zqrder(n, n, Q_z, n, R_z, n, 0, rw_z)
    call check_error('ZQRDER', 7)

    ! ====== QR increment (column) ======
    ! sqrinc(m,n,k,Q,ldq,R,ldr,j,x,w): validates m>=0, n>=0, k valid, ldq>=m, ldr>=min(m,k+1), j in [1,n+1]
    call reset()
    call sqrinc(-1, n, n, Q_s, n, R_s, n, 1, x_s, w_s)
    call check_error('SQRINC', 1)
    call reset()
    call sqrinc(n, -1, n, Q_s, n, R_s, n, 1, x_s, w_s)
    call check_error('SQRINC', 2)
    call reset()
    call sqrinc(n, n, 99, Q_s, n, R_s, n, 1, x_s, w_s)
    call check_error('SQRINC', 3)
    call reset()
    call sqrinc(n, n, n, Q_s, n-1, R_s, n, 1, x_s, w_s)
    call check_error('SQRINC', 5)
    call reset()
    call sqrinc(n, n, n, Q_s, n, R_s, 0, 1, x_s, w_s)
    call check_error('SQRINC', 7)
    call reset()
    call sqrinc(n, n, n, Q_s, n, R_s, n, 0, x_s, w_s)
    call check_error('SQRINC', 8)
    call reset()
    call dqrinc(-1, n, n, Q_d, n, R_d, n, 1, x_d, w_d)
    call check_error('DQRINC', 1)
    call reset()
    call dqrinc(n, -1, n, Q_d, n, R_d, n, 1, x_d, w_d)
    call check_error('DQRINC', 2)
    call reset()
    call dqrinc(n, n, 99, Q_d, n, R_d, n, 1, x_d, w_d)
    call check_error('DQRINC', 3)
    call reset()
    call dqrinc(n, n, n, Q_d, n-1, R_d, n, 1, x_d, w_d)
    call check_error('DQRINC', 5)
    call reset()
    call dqrinc(n, n, n, Q_d, n, R_d, 0, 1, x_d, w_d)
    call check_error('DQRINC', 7)
    call reset()
    call dqrinc(n, n, n, Q_d, n, R_d, n, 0, x_d, w_d)
    call check_error('DQRINC', 8)
    call reset()
    call cqrinc(-1, n, n, Q_c, n, R_c, n, 1, x_c, rw_c)
    call check_error('CQRINC', 1)
    call reset()
    call cqrinc(n, -1, n, Q_c, n, R_c, n, 1, x_c, rw_c)
    call check_error('CQRINC', 2)
    call reset()
    call cqrinc(n, n, 99, Q_c, n, R_c, n, 1, x_c, rw_c)
    call check_error('CQRINC', 3)
    call reset()
    call cqrinc(n, n, n, Q_c, n-1, R_c, n, 1, x_c, rw_c)
    call check_error('CQRINC', 5)
    call reset()
    call cqrinc(n, n, n, Q_c, n, R_c, 0, 1, x_c, rw_c)
    call check_error('CQRINC', 7)
    call reset()
    call cqrinc(n, n, n, Q_c, n, R_c, n, 0, x_c, rw_c)
    call check_error('CQRINC', 8)
    call reset()
    call zqrinc(-1, n, n, Q_z, n, R_z, n, 1, x_z, rw_z)
    call check_error('ZQRINC', 1)
    call reset()
    call zqrinc(n, -1, n, Q_z, n, R_z, n, 1, x_z, rw_z)
    call check_error('ZQRINC', 2)
    call reset()
    call zqrinc(n, n, 99, Q_z, n, R_z, n, 1, x_z, rw_z)
    call check_error('ZQRINC', 3)
    call reset()
    call zqrinc(n, n, n, Q_z, n-1, R_z, n, 1, x_z, rw_z)
    call check_error('ZQRINC', 5)
    call reset()
    call zqrinc(n, n, n, Q_z, n, R_z, 0, 1, x_z, rw_z)
    call check_error('ZQRINC', 7)
    call reset()
    call zqrinc(n, n, n, Q_z, n, R_z, n, 0, x_z, rw_z)
    call check_error('ZQRINC', 8)

    ! ====== QR inner (row) ======
    ! sqrinr(m,n,Q,ldq,R,ldr,j,x,w): validates n>=0, j in [1,m+1]
    call reset()
    call sqrinr(n, -1, Q_s, n, R_s, n, 1, x_s, w_s)
    call check_error('SQRINR', 2)
    call reset()
    call sqrinr(n, n, Q_s, n, R_s, n, 0, x_s, w_s)
    call check_error('SQRINR', 7)
    call reset()
    call dqrinr(n, -1, Q_d, n, R_d, n, 1, x_d, w_d)
    call check_error('DQRINR', 2)
    call reset()
    call dqrinr(n, n, Q_d, n, R_d, n, 0, x_d, w_d)
    call check_error('DQRINR', 7)
    call reset()
    call cqrinr(n, -1, Q_c, n, R_c, n, 1, x_c, rw_c)
    call check_error('CQRINR', 2)
    call reset()
    call cqrinr(n, n, Q_c, n, R_c, n, 0, x_c, rw_c)
    call check_error('CQRINR', 7)
    call reset()
    call zqrinr(n, -1, Q_z, n, R_z, n, 1, x_z, rw_z)
    call check_error('ZQRINR', 2)
    call reset()
    call zqrinr(n, n, Q_z, n, R_z, n, 0, x_z, rw_z)
    call check_error('ZQRINR', 7)

    ! ====== QR shift ======
    ! sqrshc(m,n,k,Q,ldq,R,ldr,i,j,w): validates m>=0, n>=0, k valid, i in [1,n], j in [1,n]
    call reset()
    call sqrshc(-1, n, n, Q_s, n, R_s, n, 1, 1, w_s)
    call check_error('SQRSHC', 1)
    call reset()
    call sqrshc(n, -1, n, Q_s, n, R_s, n, 1, 1, w_s)
    call check_error('SQRSHC', 2)
    call reset()
    call sqrshc(n, n, 99, Q_s, n, R_s, n, 1, 1, w_s)
    call check_error('SQRSHC', 3)
    call reset()
    call sqrshc(n, n, n, Q_s, n, R_s, n, 0, 1, w_s)
    call check_error('SQRSHC', 6)
    call reset()
    call sqrshc(n, n, n, Q_s, n, R_s, n, 1, 0, w_s)
    call check_error('SQRSHC', 7)
    call reset()
    call dqrshc(-1, n, n, Q_d, n, R_d, n, 1, 1, w_d)
    call check_error('DQRSHC', 1)
    call reset()
    call dqrshc(n, -1, n, Q_d, n, R_d, n, 1, 1, w_d)
    call check_error('DQRSHC', 2)
    call reset()
    call dqrshc(n, n, 99, Q_d, n, R_d, n, 1, 1, w_d)
    call check_error('DQRSHC', 3)
    call reset()
    call dqrshc(n, n, n, Q_d, n, R_d, n, 0, 1, w_d)
    call check_error('DQRSHC', 6)
    call reset()
    call dqrshc(n, n, n, Q_d, n, R_d, n, 1, 0, w_d)
    call check_error('DQRSHC', 7)
    call reset()
    call cqrshc(-1, n, n, Q_c, n, R_c, n, 1, 1, rw_s)
    call check_error('CQRSHC', 1)
    call reset()
    call cqrshc(n, -1, n, Q_c, n, R_c, n, 1, 1, rw_s)
    call check_error('CQRSHC', 2)
    call reset()
    call cqrshc(n, n, 99, Q_c, n, R_c, n, 1, 1, rw_s)
    call check_error('CQRSHC', 3)
    call reset()
    call cqrshc(n, n, n, Q_c, n, R_c, n, 0, 1, rw_s)
    call check_error('CQRSHC', 6)
    call reset()
    call cqrshc(n, n, n, Q_c, n, R_c, n, 1, 0, rw_s)
    call check_error('CQRSHC', 7)
    call reset()
    call zqrshc(-1, n, n, Q_z, n, R_z, n, 1, 1, rw_d)
    call check_error('ZQRSHC', 1)
    call reset()
    call zqrshc(n, -1, n, Q_z, n, R_z, n, 1, 1, rw_d)
    call check_error('ZQRSHC', 2)
    call reset()
    call zqrshc(n, n, 99, Q_z, n, R_z, n, 1, 1, rw_d)
    call check_error('ZQRSHC', 3)
    call reset()
    call zqrshc(n, n, n, Q_z, n, R_z, n, 0, 1, rw_d)
    call check_error('ZQRSHC', 6)
    call reset()
    call zqrshc(n, n, n, Q_z, n, R_z, n, 1, 0, rw_d)
    call check_error('ZQRSHC', 7)

    ! ====== Givens rotations ======
    ! sqrot(dir,m,n,Q,ldq,c,s): validates dir in {F,B}, m>=0, n>=0, ldq>=m
    call reset()
    dir = 'X'
    call sqrot(dir, n, n, Q_s, n, c_s, s_s)
    call check_error('SQROT', 1)
    call reset()
    dir = 'F'
    call sqrot(dir, -1, n, Q_s, n, c_s, s_s)
    call check_error('SQROT', 2)
    call reset()
    call sqrot(dir, n, -1, Q_s, n, c_s, s_s)
    call check_error('SQROT', 3)
    call reset()
    call sqrot(dir, n, n, Q_s, n-1, c_s, s_s)
    call check_error('SQROT', 5)
    call reset()
    dir = 'X'
    call dqrot(dir, n, n, Q_d, n, c_d, s_d)
    call check_error('DQROT', 1)
    call reset()
    dir = 'F'
    call dqrot(dir, -1, n, Q_d, n, c_d, s_d)
    call check_error('DQROT', 2)
    call reset()
    call dqrot(dir, n, -1, Q_d, n, c_d, s_d)
    call check_error('DQROT', 3)
    call reset()
    call dqrot(dir, n, n, Q_d, n-1, c_d, s_d)
    call check_error('DQROT', 5)
    call reset()
    dir = 'X'
    call cqrot(dir, n, n, Q_c, n, c_c, s_c)
    call check_error('CQROT', 1)
    call reset()
    dir = 'F'
    call cqrot(dir, -1, n, Q_c, n, c_c, s_c)
    call check_error('CQROT', 2)
    call reset()
    call cqrot(dir, n, -1, Q_c, n, c_c, s_c)
    call check_error('CQROT', 3)
    call reset()
    call cqrot(dir, n, n, Q_c, n-1, c_c, s_c)
    call check_error('CQROT', 5)
    call reset()
    dir = 'X'
    call zqrot(dir, n, n, Q_z, n, c_z, s_z)
    call check_error('ZQROT', 1)
    call reset()
    dir = 'F'
    call zqrot(dir, -1, n, Q_z, n, c_z, s_z)
    call check_error('ZQROT', 2)
    call reset()
    call zqrot(dir, n, -1, Q_z, n, c_z, s_z)
    call check_error('ZQROT', 3)
    call reset()
    call zqrot(dir, n, n, Q_z, n-1, c_z, s_z)
    call check_error('ZQROT', 5)

    ! ====== QH factor ======
    ! sqhqr(m,n,R,ldr,c,s): validates m>=0, n>=0, ldr>=m
    call reset()
    call sqhqr(-1, n, R_s, n, c_s, s_s)
    call check_error('SQHQR', 1)
    call reset()
    call sqhqr(n, -1, R_s, n, c_s, s_s)
    call check_error('SQHQR', 2)
    call reset()
    call sqhqr(n, n, R_s, n-1, c_s, s_s)
    call check_error('SQHQR', 4)
    call reset()
    call dqhqr(-1, n, R_d, n, c_d, s_d)
    call check_error('DQHQR', 1)
    call reset()
    call dqhqr(n, -1, R_d, n, c_d, s_d)
    call check_error('DQHQR', 2)
    call reset()
    call dqhqr(n, n, R_d, n-1, c_d, s_d)
    call check_error('DQHQR', 4)
    call reset()
    call cqhqr(-1, n, R_c, n, c_c, s_c)
    call check_error('CQHQR', 1)
    call reset()
    call cqhqr(n, -1, R_c, n, c_c, s_c)
    call check_error('CQHQR', 2)
    call reset()
    call cqhqr(n, n, R_c, n-1, c_c, s_c)
    call check_error('CQHQR', 4)
    call reset()
    call zqhqr(-1, n, R_z, n, c_z, s_z)
    call check_error('ZQHQR', 1)
    call reset()
    call zqhqr(n, -1, R_z, n, c_z, s_z)
    call check_error('ZQHQR', 2)
    call reset()
    call zqhqr(n, n, R_z, n-1, c_z, s_z)
    call check_error('ZQHQR', 4)

    ! ====== QR-QH ======
    ! sqrqh(m,n,R,ldr,c,s): validates m>=0, n>=0, ldr>=m
    call reset()
    call sqrqh(-1, n, R_s, n, c_s, s_s)
    call check_error('SQRQH', 1)
    call reset()
    call sqrqh(n, -1, R_s, n, c_s, s_s)
    call check_error('SQRQH', 2)
    call reset()
    call sqrqh(n, n, R_s, n-1, c_s, s_s)
    call check_error('SQRQH', 4)
    call reset()
    call dqrqh(-1, n, R_d, n, c_d, s_d)
    call check_error('DQRQH', 1)
    call reset()
    call dqrqh(n, -1, R_d, n, c_d, s_d)
    call check_error('DQRQH', 2)
    call reset()
    call dqrqh(n, n, R_d, n-1, c_d, s_d)
    call check_error('DQRQH', 4)
    call reset()
    call cqrqh(-1, n, R_c, n, c_c, s_c)
    call check_error('CQRQH', 1)
    call reset()
    call cqrqh(n, -1, R_c, n, c_c, s_c)
    call check_error('CQRQH', 2)
    call reset()
    call cqrqh(n, n, R_c, n-1, c_c, s_c)
    call check_error('CQRQH', 4)
    call reset()
    call zqrqh(-1, n, R_z, n, c_z, s_z)
    call check_error('ZQRQH', 1)
    call reset()
    call zqrqh(n, -1, R_z, n, c_z, s_z)
    call check_error('ZQRQH', 2)
    call reset()
    call zqrqh(n, n, R_z, n-1, c_z, s_z)
    call check_error('ZQRQH', 4)

    ! ====== Givens Q vector ======
    ! sgqvec(m,n,Q,ldq,u): validates m>=0, n>=0, ldq>=m
    call reset()
    call sgqvec(-1, n, Q_s, n, rhs_s)
    call check_error('SGQVEC', 1)
    call reset()
    call sgqvec(n, -1, Q_s, n, rhs_s)
    call check_error('SGQVEC', 2)
    call reset()
    call sgqvec(n, n, Q_s, n-1, rhs_s)
    call check_error('SGQVEC', 4)
    call reset()
    call dgqvec(-1, n, Q_d, n, rhs_d)
    call check_error('DGQVEC', 1)
    call reset()
    call dgqvec(n, -1, Q_d, n, rhs_d)
    call check_error('DGQVEC', 2)
    call reset()
    call dgqvec(n, n, Q_d, n-1, rhs_d)
    call check_error('DGQVEC', 4)
    call reset()
    call cgqvec(-1, n, Q_c, n, rhs_c)
    call check_error('CGQVEC', 1)
    call reset()
    call cgqvec(n, -1, Q_c, n, rhs_c)
    call check_error('CGQVEC', 2)
    call reset()
    call cgqvec(n, n, Q_c, n-1, rhs_c)
    call check_error('CGQVEC', 4)
    call reset()
    call zgqvec(-1, n, Q_z, n, rhs_z)
    call check_error('ZGQVEC', 1)
    call reset()
    call zgqvec(n, -1, Q_z, n, rhs_z)
    call check_error('ZGQVEC', 2)
    call reset()
    call zgqvec(n, n, Q_z, n-1, rhs_z)
    call check_error('ZGQVEC', 4)

    print *, 'All validation tests passed!'

contains

    subroutine check_error(expected_name, expected_code)
        character(len=*), intent(in) :: expected_name
        integer, intent(in) :: expected_code
        if (.not. xerbla_called) then
            print '(A)', 'FAIL: xerbla not called for '//expected_name
            stop 1
        end if
        if (last_srname /= expected_name) then
            print '(A,A,A,I0)', 'FAIL: expected srname "', expected_name, '" but got "', trim(last_srname), '"'
            stop 1
        end if
        if (last_info /= expected_code) then
            print '(A,A,A,I0,A,I0)', 'FAIL: expected info=', expected_name, ' but got info=', last_info
            stop 1
        end if
        print '(A,A,A,I0)', 'PASS: ', trim(expected_name), ' info=', last_info
    end subroutine check_error

    subroutine pxerbla(srname, info, aux)
        use test_state
        implicit none
        character(len=*), intent(in) :: srname
        integer, intent(in) :: info
        class(*), intent(in), optional :: aux
        xerbla_called = .true.
        last_srname = trim(srname)
        last_info = info
    end subroutine pxerbla
end program test_qrupdate_validation

! Copyright (C) 2026 Martin Köhler <koehlerm(AT)mpi-magdeburg.mpg.de>
!
! This file is part of qrupdate-ng.
!
! qrupdate is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this software; see the file COPYING.  If not, see
! <http://www.gnu.org/licenses/>.
!
module test_state
    implicit none
    logical :: xerbla_called = .false.
    logical :: custom_handler_called = .false.
    character(len=64) :: last_srname = ''
    integer :: last_info = 0
    integer :: call_count = 0
contains
    subroutine reset()
        xerbla_called = .false.
        custom_handler_called = .false.
        last_srname = ''
        last_info = 0
        call_count = 0
    end subroutine reset
end module test_state

#!/bin/bash
export LAPACK_VERSION=3.12.1
set -x

[ -d build-lapack-win64 ] && rm -rf build-lapack-win64

[ -e v${LAPACK_VERSION}.tar.gz ] || wget -c https://github.com/Reference-LAPACK/lapack/archive/refs/tags/v${LAPACK_VERSION}.tar.gz
tar xf v${LAPACK_VERSION}.tar.gz
cmake -S lapack-${LAPACK_VERSION} -B build-lapack-win64 \
    -DCMAKE_TOOLCHAIN_FILE=$(pwd)/../cmake/mingw-w64-x86_64.cmake \
    -DBUILD_SHARED_LIBS=ON \
    -DCMAKE_INSTALL_PREFIX=`dirname $(realpath $0)`/x86_64-w64-mingw32
make -C build-lapack-win64 -j 4
make -C build-lapack-win64 install

#!/usr/bin/env sh
if [ $# -ne 1 ]; then
    echo "usage: $0 version"
    exit 1
fi
NEWV=$1
D=$(date +'%Y-%m-%d')
sed -i -e "s/VERSION \([[:digit:]]\+[\.]\?\)\{3\} /VERSION ${NEWV} /g" CMakeLists.txt
sed -i -e "s/version: \([[:digit:]]\+[\.]\?\)\{3\}/version: ${NEWV}/g" CODE
sed -i -e "s/release-date: .*$/release-date: ${D}/g" CODE
sed -i -e "s/Version: \([[:digit:]]\+[\.]\?\)\{3\}.*$/Version: ${NEWV} (${D})/g" README.md
sed -i -e "s/version = \"\([[:digit:]]\+[\.]\?\)\{3\}\"/version = \"${NEWV}\"/g" fpm.toml

#!/bin/bash
export WINEARCH=win64
export WINEPREFIX=$(mktemp -d -p "$(pwd)")

set -x
(cd tools/; bash install-lapack-mingw-x86_64.sh)
cmake -S . -B build.win64 -DCMAKE_TOOLCHAIN_FILE=$(pwd)/cmake/mingw-w64-x86_64.cmake -DBUILD_SHARED_LIBS=ON
make -C build.win64 all
(cd build.win64; ctest -V )
rm -rf "${WINEPREFIX}"

#!/bin/bash
set -x
export LAPACK_VERSION=3.12.1

[ -d build-lapack-win32 ] && rm -rf build-lapack-win32

[ -e v${LAPACK_VERSION}.tar.gz ] || wget -c https://github.com/Reference-LAPACK/lapack/archive/refs/tags/v${LAPACK_VERSION}.tar.gz
tar xf v${LAPACK_VERSION}.tar.gz
cmake -S lapack-${LAPACK_VERSION} -B build-lapack-win32 \
    -DCMAKE_TOOLCHAIN_FILE=$(pwd)/../cmake/mingw-w32-i686.cmake \
    -DBUILD_SHARED_LIBS=ON \
    -DCMAKE_INSTALL_PREFIX=`dirname $(realpath $0)`/i686-w64-mingw32
make -C build-lapack-win32 -j 4
make -C build-lapack-win32 install

#!/bin/bash
export WINEARCH=win32
export WINEPREFIX=$(mktemp -d -p "$(pwd)")
set -x
 (cd tools/; bash install-lapack-mingw-i686.sh)
cmake -S . -B build.win32 -DCMAKE_TOOLCHAIN_FILE=$(pwd)/cmake/mingw-w32-i686.cmake -DBUILD_SHARED_LIBS=ON --fresh
make -C build.win32 all
(cd build.win32; ctest -V )
rm -rf "${WINEPREFIX}"

Installation Notes
==================

The library is written in Fortran. It is Fortran-90/95-compliant. Fortran 77
compilers are no longer supported. This includes the f2c translator as well.

## Requirements

The library requires a Fortran 90/95 compiler, BLAS, and LAPACK. The following
compilers and BLAS/LAPACK implementations are tested under Linux. Other
operating systems, which are supported by CMAKE, should work as well.

**Required CMake Version:** 3.18

Tested Fortran compilers:

 * GNU gfortran >= 9.3
 * Intel ifort >= 18.0.1
 * Intel oneAPI ifx >= 2024

The AMD AOCC 5.x compiler compiles the code, but the generated code may contain
invalid memory accesses. Please check carefully if the required routines work
correctly in your application.

Tested BLAS/LAPACK implementations:

 * Reference BLAS/LAPACK, http://www.netlib.org/lapack
 * OpenBLAS, https://www.openblas.net
 * FlexiBLAS, https://www.mpi-magdeburg.mpg.de/projects/ flexiblas
 * Intel MKL, https://software.intel.com/en-us/mkl
 * IBM ESSL (Missing LAPACK routines are automatically added.),
   https://www.ibm.com/support/knowledgecenter/en/SSFHY8

## Configuration and Installation

CMAKE is used to configure the source code. Out-of-source builds are prefered.

The default installation of qrupdate-ng is done by

    mkdir -p build && cd build
    cmake ../ -DCMAKE_INSTALL_PREFIX=/your/installation/path/
    make
    make install

The installation can adjusted with the help of the CMAKE options. Beside the
standard options of CMAKE, the following ones are supported:

| **Option**                     | **Description**                             |
|--------------------------------|---------------------------------------------|
| `-DDEBUG=OFF/ON`               | Enable the debug build.                     |
| `-DHOSTOPT=OFF/ON`             | Enable host specific compiler flags.        |
| `-DENABLE_COVERAGE=OFF/ON`     | Enable code coverage.                       |
| `-DFORTRAN_BOUND_CHECK=OFF/ON` | Enable the runtime bound checker.           |
| `-DFORTRAN_SANITIZE=OFF/ON`    | Enable the runtime sanitizer.               |
| `-DBUILD_SHARED_LIBS=ON/OFF`   | Enable building of shared libraries.        |
| `-DBUILD_STATIC_LIBS=ON/OFF`   | Enable building of static libraries.        |

The `FORTRAN_BOUND_CHECK` option is only supported for gfortran and ifort
compilers. The `FORTRAN_SANITIZE` option can only be used with the gfortran
compiler. If the host optimizations are enabled, the build might not be portable
to other computers.

The qrupdate-ng code includes a testsuite which can be executed by `make test`.

## ILP64 Binaries

If you need qrupdate-ng with 64 bit integers, i.e. the ILP64 integer model, you
can add
```
-DINTEGER8=ON
```
to the cmake command line. Since this enables the `-fdefault-integer-8` flag
(in case of the GNU compilers), this leads to warning during the compilation,
since these types of flags are not compatible with the `iso_fortran_env` module.
In future versions of qrupdate, the ILP64 build with be refactored to be
portable and compatible with the `iso_fortran_env` module.

**Attention**: Enabling the ILP64 build requires at least CMake 3.22

### Selecting individual BLAS and LAPACK libraries

By default CMAKE uses the first BLAS and LAPACK library it finds on the system.
If a special selection is required, one can either specifiy the `BLA_VENDOR`
vendor option of CMAKE's `FindBLAS.cmake` module or specify the BLAS and LAPACK
libraries completly on ones own.

Possible values for the `BLA_VENDOR` options can be found in the help of the
`FindBLAS.cmake` module and can be obtained by `cmake --help-module FindBLAS`.

A custom BLAS and LAPACK library can be specified by setting the
`BLAS_LIBRRARIES` and `LAPACK_LIBRARIES` variables. The variable contain a
semicolon separated list of libraries that are required to provide the BLAS and
LAPACK functionality. If a libraries contains both, BLAS and LAPACK, it needs
to be set in both variables. An example to use a self-compiled reference BLAS
and LAPACK could yield the following CMAKE call:

    cmake ../ -DBLAS_LIBRARIES=/home/user/software/libblas.a \
              -DLAPACK_LIBRARIES=/home/user/software/liblapack.a

## Cross Compiling for Windows
The build system supports cross compiling from Unix-like operating systems to
Windows. Therefore, MingW64 (https://www.mingw-w64.org/) and
Wine (https://www.winehq.org/) need to be present on the system. In case of
Ubuntu 20.04 the following packages are required:
* `mingw-w64`, `mingw-w64-i686-dev` , `mingw-w64-x86-64-dev`
* `gfortran-mingw-w64-i686`, `gfortran-mingw-w64-x86-64`
* `wine32`, `wine64`
* `wget`

Furthermore, BLAS and LAPACK are required in the MingW installation. If this is
not the case, the reference BLAS and LAPACK library can be installed via
```shell
 bash ./tools/install-lapack-mingw-i686.sh
```
for the Windows 32-bit environment, and  using
```shelll
bash ./tools/install-lapack-mingw-x86_64.sh
```
for the Windows 64-bit environment.

The Windows 32-bit  library can then be compiled using
```shell
cmake -S . -B build.win32 \
      -DCMAKE_TOOLCHAIN_FILE=$(pwd)/cmake/mingw-w32-i686.cmake \
      -DBUILD_SHARED_LIBS=ON \
      -DCMAKE_INSTALL_PREFIX=$(pwd)/install-win32
make -C build.win32 all
(cd build.win32; ctest -V )
make -C build.win32 install
```

In case of the 64-bit Windows library, the build process looks like
```shell
cmake -S . -B build.win64 \
      -DCMAKE_TOOLCHAIN_FILE=$(pwd)/cmake/mingw-w64-x86_64.cmake \
      -DBUILD_SHARED_LIBS=ON \
      -DCMAKE_INSTALL_PREFIX=$(pwd)/install-win32
make -C build.win64 all
(cd build.win64; ctest -V )
make -C build.win64 install
```

## Documentation

The library uses Doxygen for documenting the source code. If Doxygen is
installed in the system, cmake will detect it. After configuring the
documentation can bei built using
```shell
make doc
```
and gets available in `doc/html`.
